// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

// import { getSprNode } from "./util";
import { getSprNode, playAudioByUrl, showBtnAnima, getScaleRateBy2Node, localPosTolocalPos, randomSortByArr, loadDragonBones, playAudio, showTrebleFirework, getSprNodeByUrl, setSprNodeMaxLen, delayCall, asyncDelay, RandomInt, exchangeNodePos, onHomeworkFinish, callNetworkApi, loopLog, showTips} from "../script/hw_dictation_360_util";

cc.Class({
	extends: cc.Component,

	properties: {
		baseWidth: {
			default: 1920,
			type: cc.Integer
		},
		baseHeight: {
			default: 1080,
			type: cc.Integer
		}
	},

	onLoad() {
		cc.debug.setDisplayStats(false);
		this.initSceneData();
		this.initSize();
	},

	initSceneData() {
		this._imageResList = [];
		this._audioResList = [];
		this._animaResList = [];
	},


	_designSize: null,
	_frameSize: null,
	_mapScaleMin: null,
	_mapScaleMax: null,
	_cocosScale: null,
	canvas: null,
	initSize() {

		this.canvas = cc.find('Canvas');

	

		// 注意cc.winSize只有在适配后(修改fitHeight/fitWidth后)才能获取到正确的值,因此使用cc.getFrameSize()来获取初始的屏幕大小
		let screen_size = cc.view.getFrameSize().width / cc.view.getFrameSize().height
		let design_size = cc.Canvas.instance.designResolution.width / cc.Canvas.instance.designResolution.height


		let f = screen_size >= design_size
		cc.Canvas.instance.fitHeight = f
		cc.Canvas.instance.fitWidth = !f

		const frameSize = cc.view.getFrameSize();
		this._frameSize = frameSize;

		this._designSize = cc.view.getDesignResolutionSize();

		let sx = cc.winSize.width / frameSize.width;
		let sy = cc.winSize.height / frameSize.height;
		this._cocosScale = Math.min(sx, sy);

		sx = frameSize.width / this._designSize.width;
		sy = frameSize.height / this._designSize.height;
		this._mapScaleMin = Math.min(sx, sy) * this._cocosScale;
		this._mapScaleMax = Math.max(sx, sy) * this._cocosScale;



		// cc.log('cc.Canvas: ', cc.Canvas);
	},

	start() {

		console.log(' in start 1 ');

		// const middleLayer = cc.find('middleLayer');
		// if (middleLayer) {
		// 	const middleLayerComponent = middleLayer.getComponent('middleLayer');
		// 	this.data = middleLayerComponent.getTempData('hw_dictation_data');

		// 	console.log(' this.data: ', this.data);

		// } else {

			this.data = this.getDefaultData();
			console.log(' this.data: ', this.data);

		// }

		this.preloadItem()
		return;



		let getData = this.getData.bind(this);
		if (window && window.courseware) {
			getData = window.courseware.getData;

			console.log(' in start 2 ');

		}
		getData((data) => {
			console.log('data:', data);
			this.data = data || this.getDefaultData();
			this.preloadItem()
		})






		// const nextBtn = cc.find('middleLayer/BtnRight');
		// if (nextBtn) {
		// 	nextBtn.active = false;
		// }

	},

	getWordData() {
		const data = cc.sys.localStorage.getItem("hw_dictation") || {};
		return data;
	},

	_imageResList: null,
	_audioResList: null,
	_animaResList: null,
	preloadItem() {
		this.addPreloadImage();
		this.addPreloadAudio();
		this.addPreloadAnima();
		this.preload();
	},


	getData(func) {
		if (window && window.courseware) {
			window.courseware.getData(func, 'dfzx_cocos_dqq');
			return;
		}
		
		const middleLayer = cc.find('middleLayer');
		if (middleLayer) {
			const middleLayerComponent = middleLayer.getComponent('middleLayer');
			middleLayerComponent.getData(func);
			return;
		}
		
		func(this.getDefaultData());
	},

	getDefaultData() {

		return {
			"code": 200,
			"msg": "success",
			"rows": [
				
				{
					"id":4,
					"pid":3,
					"text_en":"tài yáng",
					"text_cn":"太阳",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/7cfce7bce8926aad79b1a502c7ebd40a.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/7cfce7bce8926aad79b1a502c7ebd40a.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},

				{
					"id":4,
					"pid":3,
					"text_en":"yuè liang",
					"text_cn":"月亮",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/3ef80e11d49c5947e8747f47db993ab6.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/3ef80e11d49c5947e8747f47db993ab6.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},
				
				

				{
					"id":4,
					"pid":3,
					"text_en":"xiǎo cǎo",
					"text_cn":"小草",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/90195409ada945a52098e4bfc34f4799.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/90195409ada945a52098e4bfc34f4799.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},

				{
					"id":4,
					"pid":3,
					"text_en":"huā duǒ",
					"text_cn":"花朵",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/ffa19150ddd51dcd8239fb4d40891272.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/ffa19150ddd51dcd8239fb4d40891272.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},
				
				{
					"id":4,
					"pid":3,
					"text_en":"tiān kōng",
					"text_cn":"天空",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/9e66d5f0f585e77168336717dabc99be.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/9e66d5f0f585e77168336717dabc99be.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},

				{
					"id":4,
					"pid":3,
					"text_en":"xīng xing",
					"text_cn":"星星",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/bf1b7a07bbf140ee2f74d6d4418844a3.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/bf1b7a07bbf140ee2f74d6d4418844a3.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},

				{
					"id":4,
					"pid":3,
					"text_en":"dà shù",
					"text_cn":"大树",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/71bcecaa0050578ddcfa5cbc6286aa2b.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/71bcecaa0050578ddcfa5cbc6286aa2b.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},

				{
					"id":4,
					"pid":3,
					"text_en":"máo jīn",
					"text_cn":"毛巾",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/c27fd753caea2eae6476b6c3669591e8.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/c27fd753caea2eae6476b6c3669591e8.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},


				{
					"id":4,
					"pid":3,
					"text_en":"qiān bǐ",
					"text_cn":"铅笔",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/4f0d438dfe8b02e20e16d210440a22b3.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/4f0d438dfe8b02e20e16d210440a22b3.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},


				{
					"id":4,
					"pid":3,
					"text_en":"chǐ zi",
					"text_cn":"尺子",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/7c9f691e35cb50619d1a9b196ce64404.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/7c9f691e35cb50619d1a9b196ce64404.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},

				{
					"id":4,
					"pid":3,
					"text_en":"shí tou",
					"text_cn":"石头",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/c187145a56a876cb5939d22f6b408c5d.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/c187145a56a876cb5939d22f6b408c5d.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},

				{
					"id":4,
					"pid":3,
					"text_en":"qì chē",
					"text_cn":"汽车",
					"audio_url":"https://staging-teach.cdn.ireadabc.com/2ea4af210404fd4347a4181635a81c45.mp3",
					"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/2ea4af210404fd4347a4181635a81c45.mp3",
					"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
					"phonetic":"[hə'ləu]",
					"description":null,
					"mlk":null,
					"data":null,
					"seq":1,
					"has_child":0,
					"depth":4,
					"created_date":"2023-02-01T10:07:13.000Z",
					"updated_date":"2023-02-10T03:31:34.000Z",
					"del":0
				},


				// {
				// 	"id":4,
				// 	"pid":3,
				// 	"text_en":"wǎn shang",
				// 	"text_cn":"晚上",
				// 	"audio_url":"https://staging-teach.cdn.ireadabc.com/aa2af9d7c48e0a8af92852450009668f.mp3",
				// 	"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/aa2af9d7c48e0a8af92852450009668f.mp3",
				// 	"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
				// 	"phonetic":"[hə'ləu]",
				// 	"description":null,
				// 	"mlk":null,
				// 	"data":null,
				// 	"seq":1,
				// 	"has_child":0,
				// 	"depth":4,
				// 	"created_date":"2023-02-01T10:07:13.000Z",
				// 	"updated_date":"2023-02-10T03:31:34.000Z",
				// 	"del":0
				// },

				// {
				// 	"id":4,
				// 	"pid":3,
				// 	"text_en":"bái tiān",
				// 	"text_cn":"白天",
				// 	"audio_url":"https://staging-teach.cdn.ireadabc.com/5d648b33cf14edbc50f851a451a6b366.mp3",
				// 	"audio_cn_url":"https://staging-teach.cdn.ireadabc.com/5d648b33cf14edbc50f851a451a6b366.mp3",
				// 	"image_url":"[\"http://teach.cdn.ireadabc.com/37c45828a0e536f96a6c13fedd40b4d7.webp\"]",
				// 	"phonetic":"[hə'ləu]",
				// 	"description":null,
				// 	"mlk":null,
				// 	"data":null,
				// 	"seq":1,
				// 	"has_child":0,
				// 	"depth":4,
				// 	"created_date":"2023-02-01T10:07:13.000Z",
				// 	"updated_date":"2023-02-10T03:31:34.000Z",
				// 	"del":0
				// },
			]
		}

			

				
		

		return  {
			"code": 200,
			"msg": "success",
			"rows": [
				{
					"id": 1301,
					"pid": 1300,
					"text_en": "can",
					"text_cn": "can",
					"audio_url": "http://teach.cdn.ireadabc.com/7146fd98f16ea1fc580c508e238164f3.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/950acc37df35c3f8b82b2823c74fa2b6.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/7cf22e530a6ab18e4a3a54478a386124.jpg\",\"http://teach.cdn.ireadabc.com/bb2531bb3e92856d54dbdd810ff5f224.jpeg\",\"http://teach.cdn.ireadabc.com/5815237ea67ed5694adc4ca70e4d10ce.webp\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 1,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1302,
					"pid": 1300,
					"text_en": "ram",
					"text_cn": "ram",
					"audio_url": "http://teach.cdn.ireadabc.com/717fb741707975c2383d5a04868b405e.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/7b266fb7469ceeacf62f7fbd01c0a7d3.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/9614af1ba1511225178b47b537b0ea2c.jpg\",\"http://teach.cdn.ireadabc.com/e40619d96bf24b0316df6044a8a2a2a2.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 2,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1303,
					"pid": 1300,
					"text_en": "fan",
					"text_cn": "fan",
					"audio_url": "http://teach.cdn.ireadabc.com/e314bbdec7df6e6d92e1bfdb64edbeb2.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/83c16cbf439fe163326fc98bd9b3b308.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/edd4a15e80ed86cce167cb517bcf9ea9.jpg\",\"http://teach.cdn.ireadabc.com/e1f9dd0f1114c393240b05d3a6a8b95f.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 3,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1304,
					"pid": 1300,
					"text_en": "dam",
					"text_cn": "dam",
					"audio_url": "http://teach.cdn.ireadabc.com/0a25cf3096147ab3278368666375a073.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/308a5e478d1de06f8b7087a529073940.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/5c7f1c9ef3ecff0fdd2c5a2a29960a25.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 4,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1305,
					"pid": 1300,
					"text_en": "pan",
					"text_cn": "pan",
					"audio_url": "http://teach.cdn.ireadabc.com/e24396e9abca23932e0740ac652cb892.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/1a4d97462b4e155cb7ff4210bd6cf37b.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/913dca39a7ac4598a740f274f33ce3bf.webp\",\"http://teach.cdn.ireadabc.com/64580530e9d9df587914b257c692bca5.webp\",\"http://teach.cdn.ireadabc.com/cc22164f6436f431ef0de782d25488db.webp\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 5,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1306,
					"pid": 1300,
					"text_en": "jam",
					"text_cn": "jam",
					"audio_url": "http://teach.cdn.ireadabc.com/344070143e6a32e3795ecf48140ef804.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/8324f125f5ef342a6b06bdc84e11fd13.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/2d47ee18a14fc1f3b41b834b390a60c7.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 6,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1307,
					"pid": 1300,
					"text_en": "man",
					"text_cn": "man",
					"audio_url": "http://teach.cdn.ireadabc.com/4f01d61ccfee16f7bead3521205d7a33.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/abde4e66a080f67d00f8e6426a1e7823.mp3",
					"image_url": null,
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 7,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				}
			]
		}

		return  {
			"code": 200,
			"msg": "success",
			"rows": [
				{
					"id": 1301,
					"pid": 1300,
					"text_en": "book",
					"text_cn": "书，书本",
					"audio_url": "http://teach.cdn.ireadabc.com/7146fd98f16ea1fc580c508e238164f3.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/950acc37df35c3f8b82b2823c74fa2b6.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/7cf22e530a6ab18e4a3a54478a386124.jpg\",\"http://teach.cdn.ireadabc.com/bb2531bb3e92856d54dbdd810ff5f224.jpeg\",\"http://teach.cdn.ireadabc.com/5815237ea67ed5694adc4ca70e4d10ce.webp\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 1,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1302,
					"pid": 1300,
					"text_en": "ruler",
					"text_cn": "尺子",
					"audio_url": "http://teach.cdn.ireadabc.com/717fb741707975c2383d5a04868b405e.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/7b266fb7469ceeacf62f7fbd01c0a7d3.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/9614af1ba1511225178b47b537b0ea2c.jpg\",\"http://teach.cdn.ireadabc.com/e40619d96bf24b0316df6044a8a2a2a2.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 2,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1303,
					"pid": 1300,
					"text_en": "pencil",
					"text_cn": "铅笔",
					"audio_url": "http://teach.cdn.ireadabc.com/e314bbdec7df6e6d92e1bfdb64edbeb2.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/83c16cbf439fe163326fc98bd9b3b308.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/edd4a15e80ed86cce167cb517bcf9ea9.jpg\",\"http://teach.cdn.ireadabc.com/e1f9dd0f1114c393240b05d3a6a8b95f.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 3,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1304,
					"pid": 1300,
					"text_en": "schoolbag",
					"text_cn": "书包",
					"audio_url": "http://teach.cdn.ireadabc.com/0a25cf3096147ab3278368666375a073.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/308a5e478d1de06f8b7087a529073940.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/5c7f1c9ef3ecff0fdd2c5a2a29960a25.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 4,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1305,
					"pid": 1300,
					"text_en": "teacher",
					"text_cn": "教师",
					"audio_url": "http://teach.cdn.ireadabc.com/e24396e9abca23932e0740ac652cb892.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/1a4d97462b4e155cb7ff4210bd6cf37b.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/913dca39a7ac4598a740f274f33ce3bf.webp\",\"http://teach.cdn.ireadabc.com/64580530e9d9df587914b257c692bca5.webp\",\"http://teach.cdn.ireadabc.com/cc22164f6436f431ef0de782d25488db.webp\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 5,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1306,
					"pid": 1300,
					"text_en": "I",
					"text_cn": "我",
					"audio_url": "http://teach.cdn.ireadabc.com/344070143e6a32e3795ecf48140ef804.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/8324f125f5ef342a6b06bdc84e11fd13.mp3",
					"image_url": "[\"http://teach.cdn.ireadabc.com/2d47ee18a14fc1f3b41b834b390a60c7.jpg\"]",
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 6,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1307,
					"pid": 1300,
					"text_en": "have",
					"text_cn": "有",
					"audio_url": "http://teach.cdn.ireadabc.com/4f01d61ccfee16f7bead3521205d7a33.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/abde4e66a080f67d00f8e6426a1e7823.mp3",
					"image_url": null,
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 7,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				},
				{
					"id": 1308,
					"pid": 1300,
					"text_en": "a/an",
					"text_cn": "一（个）",
					"audio_url": "http://teach.cdn.ireadabc.com/69280aedfbcc98e3e3727ba8eeff8274.mp3",
					"audio_cn_url": "http://teach.cdn.ireadabc.com/63862c6504bedd237b58d7fd311b27ef.mp3",
					"image_url": null,
					"phonetic": null,
					"description": null,
					"data": null,
					"seq": 8,
					"has_child": 0,
					"depth": 4,
					"created_date": "2023-02-02T02:44:13.000Z",
					"updated_date": "2023-02-07T23:33:49.000Z",
					"del": 0
				}
			]
		}

		return {"bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/59da1fefadfd1b0f6b460fa4ac625b78.png","rect":{"x":235.28,"y":0,"width":1257.44,"height":649}},"hotZoneItemArr":[{"id":"1670914497021","index":0,"text":"手套","audio_url":"http://staging-teach.cdn.ireadabc.com/f5be3c6b388c670d8dd9a54d880b01cc.mp3","itemType":"text","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.4964666138565},"gIdx":"0","fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"width":81,"height":40.5,"x":86.79,"y":140.27},"quesLabelId":7},{"id":"1670916557822","index":1,"text":"手表","audio_url":"http://staging-teach.cdn.ireadabc.com/ad2845e20de010817c0551ff4152b8c9.mp3","itemType":"text","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.498233302119},"gIdx":"0","fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"width":81,"height":40.5,"x":660.47,"y":139.95},"quesLabelId":8},{"id":"1670916591068","index":2,"text":"手提包","audio_url":"http://staging-teach.cdn.ireadabc.com/bc7193f3d96273edfb68d909b68b2d21.mp3","itemType":"text","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.498233302119},"gIdx":"0","fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"width":121.5,"height":40.5,"x":67.82,"y":323.67},"quesLabelId":9},{"id":"1670916620460","index":3,"text":"靴子","audio_url":"http://staging-teach.cdn.ireadabc.com/f5dcb8437d5805d99c7ee5ab7a29e281.mp3","itemType":"text","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.498233302119},"gIdx":"0","fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"width":81,"height":40.5,"x":660.64,"y":323.75},"quesLabelId":10},{"id":"1670916653146","index":4,"text":"眼镜","audio_url":"http://staging-teach.cdn.ireadabc.com/d23bec6bf236fac4b226e4a3a6fe96dd.mp3","itemType":"text","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.498233302119},"gIdx":"0","fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"width":81,"height":40.5,"x":85.58,"y":526.15},"quesLabelId":11},{"id":"1670916666198","index":5,"text":"围巾","audio_url":"http://staging-teach.cdn.ireadabc.com/dac30c644e09b6febdd4b4ae0c3e962b.mp3","itemType":"text","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.498233302119},"gIdx":"0","fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"width":81,"height":40.5,"x":663.22,"y":528.8},"quesLabelId":12},{"id":"1670918062283","index":6,"itemType":"rect","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.5},"gIdx":"1","labelText":"glove","posX":505,"posY":102,"fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"x":266.88,"y":88.85,"width":309.05,"height":84.99},"rectNew":1},{"id":"1670918363773","index":7,"itemType":"rect","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.5},"gIdx":"1","labelText":"watch","posX":949,"posY":100,"fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"x":838.61,"y":86.28,"width":309.05,"height":84.99},"rectNew":2},{"id":"1670918395630","index":8,"itemType":"rect","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.5},"gIdx":"1","labelText":"handbag","posX":505,"posY":247,"fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"x":266.88,"y":275.57,"width":309.05,"height":84.99},"rectNew":3},{"id":"1670918405376","index":9,"itemType":"rect","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.5},"gIdx":"1","labelText":"boot","posX":949,"posY":247,"fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"x":838.61,"y":275.57,"width":309.05,"height":84.99},"rectNew":4},{"id":"1670918427293","index":10,"itemType":"rect","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.5},"gIdx":"1","labelText":"glasses","posX":502,"posY":406,"fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"x":263.01,"y":480.31,"width":309.05,"height":84.99},"rectNew":5},{"id":"1670918438688","index":11,"itemType":"rect","fontScale":1.35,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.35,"dragDot":{"x":864,"y":324.5},"gIdx":"1","labelText":"scarf","posX":947,"posY":404,"fontSize":"30","fontName":"ahronbd-1","ontColor":"#8f3758","rect":{"x":836.04,"y":477.74,"width":309.05,"height":84.99},"rectNew":6}],"typeArr":[{"gIdx":"0","name":"连线"},{"gIdx":"1","name":"手写"}],"hotZoneFontObj":{"size":"30","name":"ahronbd-1","color":"#8f3758"},"fontSize":"30","bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/6c89926eecf0075d89a50faef9eab604.png","rect":{"x":151,"y":0,"width":1030,"height":1374}},"hotZoneItemArr2":[{"id":"1670918564043","index":0,"itemType":"rect","fontScale":1.040625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.040625,"dragDot":{"x":666,"y":686.9960937666581},"gIdx":"0","labelText":"glove","posX":720,"posY":205,"rect":{"x":272,"y":147,"width":594,"height":116}},{"id":"1670918601658","index":1,"itemType":"rect","fontScale":1.040625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.040625,"dragDot":{"x":666,"y":686.994140658316},"gIdx":"0","labelText":"watch","posX":719.999846479694,"posY":397.9994171914314,"rect":{"x":272,"y":340,"width":594,"height":116}},{"id":"1670918612616","index":2,"itemType":"rect","fontScale":1.040625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.040625,"dragDot":{"x":666,"y":686.9921875555267},"gIdx":"0","labelText":"handbag","posX":718.999846479694,"posY":589.9988684984862,"rect":{"x":271,"y":532,"width":594,"height":116}},{"id":"1670918623960","index":3,"itemType":"rect","fontScale":1.040625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.040625,"dragDot":{"x":666,"y":686.9902344582899},"gIdx":"0","labelText":"boot","posX":719.9998493226627,"posY":783.9983226485095,"rect":{"x":272,"y":726,"width":594,"height":116}},{"id":"1670918632987","index":4,"itemType":"rect","fontScale":1.040625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.040625,"dragDot":{"x":666,"y":686.9882813666057},"gIdx":"0","labelText":"glasses","posX":719.999846479694,"posY":977.9977711125957,"rect":{"x":272,"y":920,"width":594,"height":116}},{"id":"1670918643283","index":5,"itemType":"rect","fontScale":1.040625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.040625,"dragDot":{"x":666,"y":686.9863282804741},"gIdx":"0","labelText":"scarf","posX":718.999846479694,"posY":1168.9972195766818,"rect":{"x":271,"y":1111,"width":594,"height":116}}],"isDebug":true,"finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/bec1cb55e513e4cbcf2651f78d106f4e.mp3","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3843b53f7c3fad6580b2ac05858c5ffe.mp3","page_id":"12","book_id":"OCPD_Simp_U1-3","part_name":"a","quesArr":[{"word":"glove","text":"手套","text_audio_url":"http://staging-teach.cdn.ireadabc.com/f5be3c6b388c670d8dd9a54d880b01cc.mp3","word_audio_url":"http://staging-teach.cdn.ireadabc.com/83372fc4dbab79a1ea6c8c6ed52e6b26.mp3","time":"3"},{"word":"watch","text":"手表","word_audio_url":"http://staging-teach.cdn.ireadabc.com/4af9587096a9438931406c7a8db88559.mp3","text_audio_url":"http://staging-teach.cdn.ireadabc.com/ad2845e20de010817c0551ff4152b8c9.mp3","time":"4"},{"word":"handbag","text":"手提包","word_audio_url":"http://staging-teach.cdn.ireadabc.com/e3aa9a82e6c53e094b22c226771e1f1d.mp3","text_audio_url":"http://staging-teach.cdn.ireadabc.com/bc7193f3d96273edfb68d909b68b2d21.mp3","time":"5"},{"word":"boot","text":"靴子","word_audio_url":"http://staging-teach.cdn.ireadabc.com/ce21e31a6829704c14a623e7186ed764.mp3","text_audio_url":"http://staging-teach.cdn.ireadabc.com/f5dcb8437d5805d99c7ee5ab7a29e281.mp3","time":"4"},{"text":"眼镜","word":"glasses","text_audio_url":"http://staging-teach.cdn.ireadabc.com/d23bec6bf236fac4b226e4a3a6fe96dd.mp3","word_audio_url":"http://staging-teach.cdn.ireadabc.com/1b83a8b989df9a4fd9e1e231590ee646.mp3","time":"3"},{"text":"围巾","word":"scarf","word_audio_url":"http://staging-teach.cdn.ireadabc.com/f7513fe1f6120cd40b279873cca9347f.mp3","text_audio_url":"http://staging-teach.cdn.ireadabc.com/dac30c644e09b6febdd4b4ae0c3e962b.mp3","time":"2"}]}
		
		// return this.item = {"page_id":"20","book_id":"Oxford_Phonics_World_1_SB","part_name":"a","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/71cfecfde4376fc071d5caf3f795acbd.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/2e94de58766a736327ebb5fd906cce9d.png","rect":{"x":684.8,"y":0,"width":545.41,"height":724}},"hotZoneItemArr":[{"id":"1669082439621","index":0,"audio_url":"http://staging-teach.cdn.ireadabc.com/fca7401421aa107edcc5d2eb89e333b4.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/c5c6cd890660a3c22fde393a3770458f.json","name":"小汽车_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/cea107517406463474d907e306163226.json","name":"小汽车_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/84bce64cd4259e604a458d08ddd75bec.png","name":"小汽车_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":1},{"id":"1669083581882","index":1,"audio_url":"http://staging-teach.cdn.ireadabc.com/d519dce28617e2417ad5e145fe835bb2.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/d2d7de9f8079f36e8354d16e4ca26476.json","name":"房子_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/204ea18018a352a30fd233a46f9a0a1a.json","name":"房子_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/cf8da0ab00a7d9f34bdf8f490c29dcbf.png","name":"房子_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":2},{"id":"1669083620508","index":2,"audio_url":"http://staging-teach.cdn.ireadabc.com/f8683521643ae53cacfd46dc8041e551.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/ed2ac4931a9c00ff6c4298381722676e.json","name":"牛_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/0e153093ee7265b6a843847543d6110b.json","name":"牛_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/631661e13616eea6cde9f9e6610f5008.png","name":"牛_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":3},{"id":"1669083664690","index":3,"audio_url":"http://staging-teach.cdn.ireadabc.com/154d6f8cc4a7d8e7f1861ebbc6dec687.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/bd3c2cc93b1593433a58d8482972ff66.json","name":"苹果_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/1f54df317a8c86271e29d6db3ffb55ce.json","name":"苹果_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/734ac06a7ef018b457e7ac7692789ffa.png","name":"苹果_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":4},{"id":"1669083697453","index":4,"audio_url":"http://staging-teach.cdn.ireadabc.com/9614be8b758626d1397ded87108953dd.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/1d4b251caf0c0b8245fb17cd8445672c.json","name":"农夫_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/1fdd04cacb6d543cf05ce64e8124a6ff.json","name":"农夫_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/8f582cb39eb349da08e06289b0ce6c16.png","name":"农夫_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":5},{"id":"1669083713146","index":5,"audio_url":"http://staging-teach.cdn.ireadabc.com/fac93b824769af4b45147693b158b971.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/4503721901880d0b6c3ad6d4261e958b.json","name":"小女孩_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/fc4fd0b2f672dff7c7b2148830164090.json","name":"小女孩_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/4be41c15972caf99eef956ba48759c91.png","name":"小女孩_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":6},{"id":"1669083737551","index":6,"audio_url":"http://staging-teach.cdn.ireadabc.com/a82fce34e4e1f528aa2132f3fe338380.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/55951c794b414ab58cca023642819e37.json","name":"母鸡_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/47b93323b1d1e1e6020704c537f46820.json","name":"母鸡_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/dd66021ff860b02a559d59817c71e27f.png","name":"母鸡_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":7},{"id":"1669083753282","index":7,"audio_url":"http://staging-teach.cdn.ireadabc.com/1596ffb6a1870cd3d39190dcb5c9b3ef.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/cd7c7a756c0f79d28f419576e3b85b0c.json","name":"鸭子_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/7613f30893a5f64773a77723c1d67f0d.json","name":"鸭子_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/59b2293ef4eea9d64ff9821bc5d69a6d.png","name":"鸭子_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":8},{"id":"1669083768477","index":8,"audio_url":"http://staging-teach.cdn.ireadabc.com/bce0907fa65f7bfb1528b9b337156eee.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/b9fa85c227daa6539f12cab5a5058052.json","name":"鸡蛋_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/99aa8de7b69000ac6c5e0fb6a508b692.json","name":"鸡蛋_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/09bd0a34a4508613fd7c167724e4a969.png","name":"鸡蛋_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":9},{"id":"1669083786912","index":9,"audio_url":"http://staging-teach.cdn.ireadabc.com/691607b201247c70151d8a00487131dc.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/357fef8204228afb43d0ce73746228e5.json","name":"鱼_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/f694e5442095a317fc7d8b1390e630c7.json","name":"鱼_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/f566cca10fd83f62a465b144ac73d483.png","name":"鱼_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":10},{"id":"1669083807406","index":10,"audio_url":"http://staging-teach.cdn.ireadabc.com/cfd674ef6232b3bac047c05e6db31c80.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/20cbf3d186a197baaed38204dd017f51.json","name":"猫_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/d7de5a32de3ee1ad660dc509ba8adf1d.json","name":"猫_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/af86e967aab8632cd0b26d60a62f0675.png","name":"猫_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":11},{"id":"1669083833311","index":11,"audio_url":"http://staging-teach.cdn.ireadabc.com/209a9867f5d689b8ab1afce4a643e163.mp3","itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/d8506ebddb29c8d08b4b93376b45f5c9.json","name":"鸟_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/9fad47c99025b7b229df52afb797ec5c.json","name":"鸟_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/e86b136b9706768c5ca0dba3dc0aab21.png","name":"鸟_tex.png"},"dragDot":{"x":957.5,"y":362},"gIdx":"5","rect":{"x":172.7,"y":262,"width":200,"height":200},"fingerItem":12}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/66bc1f3cda8645faa5afb01f6270abf6.png","rect":{"x":195.88,"y":0,"width":1523.25,"height":1971}},"hotZoneItemArr2":[{"id":"1669083908936","index":0,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":760.5,"posY":530.5,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":408.11,"y":407,"width":313.01,"height":247}},{"id":"1669083945302","index":1,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":1343.495219620412,"posY":620.4994086006523,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":787.09,"y":344,"width":721.02,"height":553}},{"id":"1669083988090","index":2,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":741.495219620412,"posY":796.4994086006523,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":371.1,"y":630,"width":349.02,"height":333}},{"id":"1669084008776","index":3,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":433.48558751428334,"posY":617.4993183021655,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":-12.91,"y":364,"width":501.03,"height":507}},{"id":"1669084046225","index":4,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":1304.4855875142835,"posY":872.4993183021654,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":943.07,"y":613,"width":331.03,"height":519}},{"id":"1669084101586","index":5,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":553.4754426019342,"posY":1032.4988344806443,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":210.07,"y":823,"width":295.05,"height":419}},{"id":"1669084121938","index":6,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":814.470162793679,"posY":1069.49379658315,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":455.06,"y":887,"width":327.06,"height":364.99}},{"id":"1669084134246","index":7,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":1072.4698863242386,"posY":1236.4936171009726,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":711.06,"y":1074,"width":331.06,"height":324.99}},{"id":"1669084148370","index":8,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":702.4698863242386,"posY":1458.4936171009726,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":341.06,"y":1281,"width":331.06,"height":354.99}},{"id":"1669084159031","index":9,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":1372.4695373930492,"posY":1354.4934721774755,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":1023.05,"y":1213,"width":307.06,"height":282.99}},{"id":"1669084170572","index":10,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":364.4695373930492,"posY":1424.4934721774755,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":-41.94,"y":1225,"width":421.06,"height":398.99}},{"id":"1669084184504","index":11,"itemType":"rect","fontScale":1.49609375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.49609375,"dragDot":{"x":957.5,"y":985.5},"gIdx":"9","posX":1125.4706611075499,"posY":364.4934119784846,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":806.09,"y":241,"width":246.99,"height":246.99}}],"isDebug":false,"typeArr":[{"gIdx":"5","name":"手指"}]}
		// return {"page_id":"a","book_id":"Oxford_Phonics_World_1_SB","part_name":"20","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/71cfecfde4376fc071d5caf3f795acbd.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","change_step_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_2_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/66bc1f3cda8645faa5afb01f6270abf6.png","rect":{"x":477.84,"y":0,"width":400.33,"height":518}},"hotZoneItemArr":[{"id":"1668416652990","index":0,"audio_url":"http://staging-teach.cdn.ireadabc.com/7250e6fab849d61e5db835369652a283.mp3","itemType":"rect","fontScale":1.059375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.059375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/adbca2a648c02720af989d820e9e0a91.json","name":"right_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/50ca8e843c9dbdee0fd128ccb15c1878.json","name":"right_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/b75b2e4273b7e422d732ca39654feb6c.png","name":"right_tex.png"},"dragDot":{"x":678,"y":255.43826322930798},"gIdx":"5","posX":885.5,"posY":265.5,"rect":{"x":1.48,"y":107.58,"width":123.75,"height":115.04},"fingerItem":1},{"id":"1668417158088","index":1,"audio_url":"http://staging-teach.cdn.ireadabc.com/c8c7fe89675dbd45bb9a141592a3c4ad.mp3","itemType":"rect","fontScale":1.059375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.059375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/adbca2a648c02720af989d820e9e0a91.json","name":"right_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/50ca8e843c9dbdee0fd128ccb15c1878.json","name":"right_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/b75b2e4273b7e422d732ca39654feb6c.png","name":"right_tex.png"},"dragDot":{"x":678,"y":255.43826322930798},"gIdx":"5","posX":1209.4958382417722,"posY":405.49898841757914,"rect":{"x":202.96,"y":161.06,"width":123.75,"height":182.2},"fingerItem":2},{"id":"1668417177436","index":2,"audio_url":"http://staging-teach.cdn.ireadabc.com/3f786c430d5599b75b4f4c54e6929600.mp3","itemType":"rect","fontScale":1.059375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.059375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/adbca2a648c02720af989d820e9e0a91.json","name":"right_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/50ca8e843c9dbdee0fd128ccb15c1878.json","name":"right_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/b75b2e4273b7e422d732ca39654feb6c.png","name":"right_tex.png"},"dragDot":{"x":678,"y":255.43826322930798},"gIdx":"5","posX":852.4946037683094,"posY":602.49845500312,"rect":{"x":1.47,"y":333.3,"width":82.71,"height":82.71},"fingerItem":3}],"typeArr":[{"gIdx":"5","name":"手指"}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/66bc1f3cda8645faa5afb01f6270abf6.png","rect":{"x":228.72,"y":0,"width":1753.55,"height":2269}},"hotZoneItemArr2":[{"id":"1668417351868","index":0,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"9","posX":495.5,"posY":708.5,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":21.28,"y":485,"width":491,"height":447}},{"id":"1668417373147","index":1,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"9","posX":1498.5044092894038,"posY":1009.5006861014557,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":1080.29,"y":717,"width":378.99,"height":585}},{"id":"1668417417277","index":2,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"9","posX":403.51038058536824,"posY":1621.500977585631,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":6.3,"y":1431,"width":336.98,"height":381}}],"isDebug":false}
		 return {"page_id":"14","book_id":"opw1","part_name":"c","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","change_step_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_2_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/ed41e8c2b5c9d5bf19cf2adb9a3b66d0.jpg","rect":{"x":811.44,"y":0,"width":588.12,"height":833}},"hotZoneItemArr":[{"id":"1668410555384","index":0,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":416.5},"gIdx":"0","posX":1040.5,"posY":371.5,"rect":{"x":203.56,"y":346,"width":51,"height":51},"linkItem":2,"pointItem":1},{"id":"1668410563779","index":1,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":416.5},"gIdx":"0","posX":1188.499770916734,"posY":212.50130929897438,"rect":{"x":351.56,"y":187,"width":51,"height":51},"linkItem":1,"pointItem":2},{"id":"1668410570729","index":2,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":416.5},"gIdx":"0","posX":1044.500292521709,"posY":527.500748926062,"rect":{"x":207.56,"y":502,"width":51,"height":51},"linkItem":4,"pointItem":3},{"id":"1668410576114","index":3,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":416.5},"gIdx":"0","posX":1192.4997850141658,"posY":675.5018590988128,"rect":{"x":355.56,"y":650,"width":51,"height":51},"linkItem":3,"pointItem":4},{"id":"1668410581125","index":4,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":416.5},"gIdx":"0","posX":1044.500306619141,"posY":675.5023807037878,"rect":{"x":207.56,"y":650,"width":51,"height":51},"linkItem":6,"pointItem":5},{"id":"1668410585953","index":5,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":416.5},"gIdx":"0","posX":1188.4997850141658,"posY":370.5023807037878,"rect":{"x":351.56,"y":345,"width":51,"height":51},"linkItem":5,"pointItem":6}],"typeArr":[{"gIdx":"0","name":"连线"}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/ed41e8c2b5c9d5bf19cf2adb9a3b66d0.jpg","rect":{"x":304.51,"y":0,"width":1601.98,"height":2269}},"hotZoneItemArr2":[{"id":"1668410599603","index":0,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"0","posX":929.5,"posY":1011.5,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":576.49,"y":963,"width":97,"height":97}},{"id":"1668410630452","index":1,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"0","posX":1328.50004707677,"posY":579.4997294423139,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":975.49,"y":531,"width":97,"height":97}},{"id":"1668410638133","index":2,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"0","posX":927.4999403515928,"posY":1441.4998449943855,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":574.49,"y":1393,"width":97,"height":97}},{"id":"1668410678972","index":3,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"0","posX":1336.5000476117334,"posY":1834.4996144252057,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":983.49,"y":1786,"width":97,"height":97}},{"id":"1668410684885","index":4,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"0","posX":935.4999382117396,"posY":1834.4995093049183,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":582.49,"y":1786,"width":97,"height":97}},{"id":"1668410690774","index":5,"itemType":"rect","fontScale":1.72734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.72734375,"dragDot":{"x":1105.5,"y":1134.5},"gIdx":"0","posX":1331.5000454718802,"posY":1007.4995093049183,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":978.49,"y":959,"width":97,"height":97}}]}
		return {"page_id":"9","book_id":"opw1","part_name":"d","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3229f6873c4294acd59fb89dc7eab0aa.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3229f6873c4294acd59fb89dc7eab0aa.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/1911e3568e927257c91a8fd25d118398.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/739005c0435dcb9f32da08998711b4f9.png","rect":{"x":313.64,"y":0,"width":1130.71,"height":666}},"hotZoneItemArr":[{"id":"1668059700120","index":0,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":774,"posY":221,"rect":{"x":434.36,"y":195,"width":52,"height":52},"linkItem":2,"pointItem":1},{"id":"1668059708822","index":1,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":840.0046289463639,"posY":286.00078101674904,"rect":{"x":500.36,"y":260,"width":52,"height":52},"linkItem":1,"pointItem":2},{"id":"1668059715388","index":2,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":999.0048621911851,"posY":221.00101072755757,"rect":{"x":659.4,"y":195,"width":52,"height":52},"linkItem":4,"pointItem":3},{"id":"1668059723401","index":3,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":949.0054240991628,"posY":285.00078101674904,"rect":{"x":609.41,"y":259,"width":52,"height":52},"linkItem":3,"pointItem":4},{"id":"1668059730444","index":4,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1199.015247433881,"posY":294.00100719354515,"rect":{"x":859.42,"y":268,"width":52,"height":52},"linkItem":6,"pointItem":5},{"id":"1668059737547","index":5,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1011.026130972331,"posY":322.0010389996571,"rect":{"x":671.43,"y":296,"width":52,"height":52},"linkItem":5,"pointItem":6},{"id":"1668059742714","index":6,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1206.0354666133326,"posY":463.00113795200537,"rect":{"x":866.44,"y":437,"width":52,"height":52},"linkItem":8,"pointItem":7},{"id":"1668059747117","index":7,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1011.0461557810982,"posY":415.00163624775934,"rect":{"x":671.45,"y":389,"width":52,"height":52},"linkItem":7,"pointItem":8},{"id":"1668059754005","index":8,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1017.0554666840126,"posY":508.00146661516226,"rect":{"x":677.46,"y":482,"width":52,"height":52},"linkItem":10,"pointItem":9},{"id":"1668059760443","index":9,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":949.0654879234274,"posY":451.0017952783191,"rect":{"x":609.47,"y":425,"width":52,"height":52},"linkItem":9,"pointItem":10},{"id":"1668059768151","index":10,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":767.0752476459216,"posY":505.00159383961,"rect":{"x":427.44,"y":479,"width":52,"height":52},"linkItem":12,"pointItem":11},{"id":"1668059772490","index":11,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":836.0846044909979,"posY":451.0017846762818,"rect":{"x":496.44,"y":425,"width":52,"height":52},"linkItem":11,"pointItem":12},{"id":"1668059780036","index":12,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":569.0848483378562,"posY":455.00159383961005,"rect":{"x":229.44,"y":429,"width":52,"height":52},"linkItem":14,"pointItem":13},{"id":"1668059786972","index":13,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":770.0839047565349,"posY":416.0016079756598,"rect":{"x":430.44,"y":390,"width":52,"height":52},"linkItem":13,"pointItem":14},{"id":"1668059793504","index":14,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":567.0846150930352,"posY":293.0014701491747,"rect":{"x":227.44,"y":267,"width":52,"height":52},"linkItem":16,"pointItem":15},{"id":"1668059803802","index":15,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":770.0838976885101,"posY":321.00103546564463,"rect":{"x":430.44,"y":295,"width":52,"height":52},"linkItem":15,"pointItem":16},{"id":"1668062996049","index":16,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/8d6671efb002131453b527eeed3bf97f.json","name":"C大黑_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/73fe384407514cdb6367e836a45cfa03.json","name":"C大黑_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/ef6a958b04c1fed3a47881a592483df7.png","name":"C大黑_tex.png"},"dragDot":{"x":879,"y":333},"gIdx":"1","posX":890,"posY":368,"rect":{"x":464.36,"y":293,"width":224,"height":150},"rectNew":17}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/587034b4ac726f8f7a3c94d2ace95ded.png","rect":{"x":177.27,"y":0,"width":1403.46,"height":1816}},"hotZoneItemArr2":[{"id":"1668060479065","index":0,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":908},"gIdx":"0","posX":761,"posY":837,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":555.73,"y":809,"width":56,"height":56}},{"id":"1668060505242","index":1,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":831.0000317275176,"posY":909.9997749497267,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":627.73,"y":884,"width":52,"height":52}},{"id":"1668060522174","index":2,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1010.0000129061089,"posY":836.9997553216862,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":806.73,"y":811,"width":52,"height":52}},{"id":"1668060535017","index":3,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":951.9999647770779,"posY":906.9997749497267,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":748.73,"y":881,"width":52,"height":52}},{"id":"1668060544062","index":4,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1228.9999803719595,"posY":917.9997561283179,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":1025.73,"y":892,"width":52,"height":52}},{"id":"1668060551250","index":5,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1021.9999058929563,"posY":947.999753170668,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":818.73,"y":922,"width":52,"height":52}},{"id":"1668060557455","index":6,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1236.9999615505508,"posY":1105.99974510435,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":1033.73,"y":1080,"width":52,"height":52}},{"id":"1668060563678","index":7,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1020.9999037419382,"posY":1052.9997026217416,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":817.73,"y":1027,"width":52,"height":52}},{"id":"1668060572236","index":8,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1028.9999618194279,"posY":1155.9997168722368,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":825.73,"y":1130,"width":52,"height":52}},{"id":"1668060578650","index":9,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":951.9999596684097,"posY":1092.9996891778783,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":748.73,"y":1067,"width":52,"height":52}},{"id":"1668060585215","index":10,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":750.9999803719595,"posY":1152.9997061171462,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":547.73,"y":1127,"width":52,"height":52}},{"id":"1668060594729","index":11,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":830.0000344162903,"posY":1092.99968998451,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":626.73,"y":1067,"width":52,"height":52}},{"id":"1668060603472","index":12,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":530.0000131749862,"posY":1095.9997061171462,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":326.73,"y":1070,"width":52,"height":52}},{"id":"1668060610498","index":13,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":755.0000938381665,"posY":1050.9997053105142,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":551.73,"y":1025,"width":52,"height":52}},{"id":"1668060616544","index":14,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":528.0000333407812,"posY":914.9997174099913,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":324.73,"y":889,"width":52,"height":52}},{"id":"1668060624038","index":15,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":754.0000943759211,"posY":947.9997539772997,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":550.73,"y":922,"width":52,"height":52}},{"id":"1668060653013","index":16,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":908},"gIdx":"6","labelText":"Cc","posX":890,"posY":1001,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":583.73,"y":913,"width":258,"height":176}}],"typeArr":[{"gIdx":"0","name":"连线"},{"gIdx":"1","name":"手写"}],"firstGIdx":"0","change_step_audio_url":"http://staging-teach.cdn.ireadabc.com/5d328902664fecfc2c17552394c29921.mp3","idle_2_audio_url":"http://staging-teach.cdn.ireadabc.com/13b05d0e777233d9fd9b661c76ebee2e.mp3","isDebug":true}
		return {"page_id":"9","book_id":"opw1","part_name":"d","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3229f6873c4294acd59fb89dc7eab0aa.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3229f6873c4294acd59fb89dc7eab0aa.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/1911e3568e927257c91a8fd25d118398.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/739005c0435dcb9f32da08998711b4f9.png","rect":{"x":313.64,"y":0,"width":1130.71,"height":666}},"hotZoneItemArr":[{"id":"1668059700120","index":0,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":774,"posY":221,"rect":{"x":434.36,"y":195,"width":52,"height":52},"linkItem":2,"pointItem":1},{"id":"1668059708822","index":1,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":840.0046289463639,"posY":286.00078101674904,"rect":{"x":500.36,"y":260,"width":52,"height":52},"linkItem":1,"pointItem":2},{"id":"1668059715388","index":2,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":999.0048621911851,"posY":221.00101072755757,"rect":{"x":659.4,"y":195,"width":52,"height":52},"linkItem":4,"pointItem":3},{"id":"1668059723401","index":3,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":949.0054240991628,"posY":285.00078101674904,"rect":{"x":609.41,"y":259,"width":52,"height":52},"linkItem":3,"pointItem":4},{"id":"1668059730444","index":4,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1199.015247433881,"posY":294.00100719354515,"rect":{"x":859.42,"y":268,"width":52,"height":52},"linkItem":6,"pointItem":5},{"id":"1668059737547","index":5,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1011.026130972331,"posY":322.0010389996571,"rect":{"x":671.43,"y":296,"width":52,"height":52},"linkItem":5,"pointItem":6},{"id":"1668059742714","index":6,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1206.0354666133326,"posY":463.00113795200537,"rect":{"x":866.44,"y":437,"width":52,"height":52},"linkItem":8,"pointItem":7},{"id":"1668059747117","index":7,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1011.0461557810982,"posY":415.00163624775934,"rect":{"x":671.45,"y":389,"width":52,"height":52},"linkItem":7,"pointItem":8},{"id":"1668059754005","index":8,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":1017.0554666840126,"posY":508.00146661516226,"rect":{"x":677.46,"y":482,"width":52,"height":52},"linkItem":10,"pointItem":9},{"id":"1668059760443","index":9,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":949.0654879234274,"posY":451.0017952783191,"rect":{"x":609.47,"y":425,"width":52,"height":52},"linkItem":9,"pointItem":10},{"id":"1668059768151","index":10,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":767.0752476459216,"posY":505.00159383961,"rect":{"x":427.44,"y":479,"width":52,"height":52},"linkItem":12,"pointItem":11},{"id":"1668059772490","index":11,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":836.0846044909979,"posY":451.0017846762818,"rect":{"x":496.44,"y":425,"width":52,"height":52},"linkItem":11,"pointItem":12},{"id":"1668059780036","index":12,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":569.0848483378562,"posY":455.00159383961005,"rect":{"x":229.44,"y":429,"width":52,"height":52},"linkItem":14,"pointItem":13},{"id":"1668059786972","index":13,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":770.0839047565349,"posY":416.0016079756598,"rect":{"x":430.44,"y":390,"width":52,"height":52},"linkItem":13,"pointItem":14},{"id":"1668059793504","index":14,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":567.0846150930352,"posY":293.0014701491747,"rect":{"x":227.44,"y":267,"width":52,"height":52},"linkItem":16,"pointItem":15},{"id":"1668059803802","index":15,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":333},"gIdx":"0","posX":770.0838976885101,"posY":321.00103546564463,"rect":{"x":430.44,"y":295,"width":52,"height":52},"linkItem":15,"pointItem":16},{"id":"1668062996049","index":16,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/8d6671efb002131453b527eeed3bf97f.json","name":"C大黑_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/73fe384407514cdb6367e836a45cfa03.json","name":"C大黑_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/ef6a958b04c1fed3a47881a592483df7.png","name":"C大黑_tex.png"},"dragDot":{"x":879,"y":333},"gIdx":"1","posX":890,"posY":368,"rect":{"x":464.36,"y":293,"width":224,"height":150},"rectNew":17}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/587034b4ac726f8f7a3c94d2ace95ded.png","rect":{"x":177.27,"y":0,"width":1403.46,"height":1816}},"hotZoneItemArr2":[{"id":"1668060479065","index":0,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":908},"gIdx":"0","posX":761,"posY":837,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":555.73,"y":809,"width":56,"height":56}},{"id":"1668060505242","index":1,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":831.0000317275176,"posY":909.9997749497267,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":627.73,"y":884,"width":52,"height":52}},{"id":"1668060522174","index":2,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1010.0000129061089,"posY":836.9997553216862,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":806.73,"y":811,"width":52,"height":52}},{"id":"1668060535017","index":3,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":951.9999647770779,"posY":906.9997749497267,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":748.73,"y":881,"width":52,"height":52}},{"id":"1668060544062","index":4,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1228.9999803719595,"posY":917.9997561283179,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":1025.73,"y":892,"width":52,"height":52}},{"id":"1668060551250","index":5,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1021.9999058929563,"posY":947.999753170668,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":818.73,"y":922,"width":52,"height":52}},{"id":"1668060557455","index":6,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1236.9999615505508,"posY":1105.99974510435,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":1033.73,"y":1080,"width":52,"height":52}},{"id":"1668060563678","index":7,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1020.9999037419382,"posY":1052.9997026217416,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":817.73,"y":1027,"width":52,"height":52}},{"id":"1668060572236","index":8,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":1028.9999618194279,"posY":1155.9997168722368,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":825.73,"y":1130,"width":52,"height":52}},{"id":"1668060578650","index":9,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":951.9999596684097,"posY":1092.9996891778783,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":748.73,"y":1067,"width":52,"height":52}},{"id":"1668060585215","index":10,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":750.9999803719595,"posY":1152.9997061171462,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":547.73,"y":1127,"width":52,"height":52}},{"id":"1668060594729","index":11,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":830.0000344162903,"posY":1092.99968998451,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":626.73,"y":1067,"width":52,"height":52}},{"id":"1668060603472","index":12,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":530.0000131749862,"posY":1095.9997061171462,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":326.73,"y":1070,"width":52,"height":52}},{"id":"1668060610498","index":13,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":755.0000938381665,"posY":1050.9997053105142,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":551.73,"y":1025,"width":52,"height":52}},{"id":"1668060616544","index":14,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":528.0000333407812,"posY":914.9997174099913,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":324.73,"y":889,"width":52,"height":52}},{"id":"1668060624038","index":15,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":907.9999999999999},"gIdx":"0","posX":754.0000943759211,"posY":947.9997539772997,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":550.73,"y":922,"width":52,"height":52}},{"id":"1668060653013","index":16,"itemType":"rect","fontScale":1.3734375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.3734375,"dragDot":{"x":879,"y":908},"gIdx":"6","labelText":"Cc","posX":890,"posY":1001,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":583.73,"y":913,"width":258,"height":176}}],"typeArr":[{"gIdx":"0","name":"连线"},{"gIdx":"1","name":"手写"}],"firstGIdx":"0","change_step_audio_url":"http://staging-teach.cdn.ireadabc.com/5d328902664fecfc2c17552394c29921.mp3","idle_2_audio_url":"http://staging-teach.cdn.ireadabc.com/13b05d0e777233d9fd9b661c76ebee2e.mp3","isDebug":true}
		// return {"page_id":"22","book_id":"opw1","part_name":"c","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/b5fb215276c7afd3779887787bce8ccb.png","rect":{"x":250.35,"y":0,"width":889.29,"height":531}},"hotZoneItemArr":[{"id":"1667901785398","index":0,"itemType":"rect","fontScale":1.0859375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.0859375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/2add1099280b35cd2d1f42f32a2fdf40.json","name":"xiao_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/31a43a4fe41219b8d5ea2a6444ee7945.json","name":"xiao_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/5607c1521c271c88969a814c522b6039.png","name":"xiao_tex.png"},"dragDot":{"x":695,"y":265.5},"gIdx":"4","posX":703,"posY":266.5,"rect":{"x":419.65,"y":233.5,"width":66,"height":66},"signItem":1},{"id":"1667902509387","index":1,"itemType":"rect","fontScale":1.0859375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.0859375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/2add1099280b35cd2d1f42f32a2fdf40.json","name":"xiao_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/31a43a4fe41219b8d5ea2a6444ee7945.json","name":"xiao_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/5607c1521c271c88969a814c522b6039.png","name":"xiao_tex.png"},"dragDot":{"x":695,"y":265.5},"gIdx":"4","posX":984.0050081832392,"posY":266.50027243388246,"rect":{"x":700.65,"y":233.5,"width":66,"height":66},"signItem":2},{"id":"1667902517894","index":2,"itemType":"rect","fontScale":1.0859375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.0859375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/0a7875b1266391503571437db9db3a0f.json","name":"ku_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/422a6815028fe9f40298d9c369492b96.json","name":"ku_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/19bac79724d78938de8a654d47885586.png","name":"ku_tex.png"},"dragDot":{"x":695,"y":265.5},"gIdx":"4","posX":423.0052954399782,"posY":484.50027243388246,"rect":{"x":139.66,"y":451.5,"width":66,"height":66},"signItem":3},{"id":"1667902630462","index":3,"itemType":"rect","fontScale":1.0859375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.0859375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/2add1099280b35cd2d1f42f32a2fdf40.json","name":"xiao_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/31a43a4fe41219b8d5ea2a6444ee7945.json","name":"xiao_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/5607c1521c271c88969a814c522b6039.png","name":"xiao_tex.png"},"dragDot":{"x":695,"y":265.5},"gIdx":"4","posX":701.0052954399782,"posY":484.50027243388246,"rect":{"x":417.66,"y":451.5,"width":66,"height":66},"signItem":4},{"id":"1667902644903","index":4,"itemType":"rect","fontScale":1.0859375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.0859375,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/0a7875b1266391503571437db9db3a0f.json","name":"ku_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/422a6815028fe9f40298d9c369492b96.json","name":"ku_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/19bac79724d78938de8a654d47885586.png","name":"ku_tex.png"},"dragDot":{"x":695,"y":265.5},"gIdx":"4","posX":983.0147219589887,"posY":485.5004952878651,"rect":{"x":699.66,"y":452.5,"width":66,"height":66},"signItem":5}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/8c5a7ff4254cbc7922cb79e4794729c7.png","rect":{"x":143.31,"y":0,"width":1172.38,"height":1517}},"hotZoneItemArr2":[{"id":"1667902765218","index":0,"itemType":"rect","fontScale":1.13984375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.13984375,"dragDot":{"x":729.5,"y":759.4147482014389},"gIdx":"8","posX":716,"posY":443.5,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"dropDownItem":{"label":"smile","key":"4"},"rect":{"x":573.08,"y":429.83,"width":70.24,"height":70.24}},{"id":"1667902778386","index":1,"itemType":"rect","fontScale":1.13984375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.13984375,"dragDot":{"x":729.5,"y":759.4147482014389},"gIdx":"8","posX":1028.9949114424535,"posY":445.49812930355085,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"dropDownItem":{"label":"smile","key":"4"},"rect":{"x":901.22,"y":431.93,"width":70.24,"height":70.24}},{"id":"1667902784590","index":2,"itemType":"rect","fontScale":1.13984375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.13984375,"dragDot":{"x":729.5,"y":759.4147482014389},"gIdx":"8","posX":403.99359119896144,"posY":688.4981208674902,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"dropDownItem":{"label":"cry","key":"2"},"rect":{"x":245.98,"y":686.68,"width":70.24,"height":70.24}},{"id":"1667902791896","index":3,"itemType":"rect","fontScale":1.13984375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.13984375,"dragDot":{"x":729.5,"y":759.4147482014389},"gIdx":"8","posX":716.986227510095,"posY":687.4970958861212,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"dropDownItem":{"label":"smile","key":"4"},"rect":{"x":574.12,"y":685.63,"width":70.24,"height":70.24}},{"id":"1667902798477","index":4,"itemType":"rect","fontScale":1.13984375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.13984375,"dragDot":{"x":729.5,"y":759.4147482014389},"gIdx":"8","posX":1029.9849072666034,"posY":687.4971001041515,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"dropDownItem":{"label":"cry","key":"2"},"rect":{"x":902.26,"y":685.63,"width":70.24,"height":70.24}}]}
		// return {"page_id":"13","book_id":"opw1","part_name":"d","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bg_pic_url":"http://staging-teach.cdn.ireadabc.com/103588a383dfef103f7d88081131a58b.png","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/b11402c53d03d9b8966c1a5386c4d0b4.png","rect":{"x":382.88,"y":0,"width":1467.24,"height":841}},"hotZoneItemArr":[{"id":"1667284178410","index":0,"itemType":"rect","fontScale":1.74453125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.74453125,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/29b438b66c46206a683982c2dec2c1c6.json","name":"draw_circle_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/2e0851230cec969f8a805563c9cbb177.json","name":"draw_circle_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/9531e99ab1f656893c74ee5868632f6a.png","name":"draw_circle_tex.png"},"dragDot":{"x":1116.5,"y":420.5},"gIdx":"2","posX":652.5,"posY":380.5,"rect":{"x":169.62,"y":302,"width":200,"height":157},"circleItem":1},{"id":"1667285795465","index":1,"itemType":"rect","fontScale":1.74453125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.74453125,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/29b438b66c46206a683982c2dec2c1c6.json","name":"draw_circle_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/2e0851230cec969f8a805563c9cbb177.json","name":"draw_circle_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/9531e99ab1f656893c74ee5868632f6a.png","name":"draw_circle_tex.png"},"dragDot":{"x":1116.5,"y":420.5},"gIdx":"2","posX":1004.5005700463794,"posY":566.4995325373978,"rect":{"x":521.62,"y":488,"width":200,"height":157},"circleItem":2},{"id":"1667285801759","index":2,"itemType":"rect","fontScale":1.74453125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.74453125,"skeJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/29b438b66c46206a683982c2dec2c1c6.json","name":"draw_circle_ske.json"},"texJsonData":{"url":"http://staging-teach.cdn.ireadabc.com/2e0851230cec969f8a805563c9cbb177.json","name":"draw_circle_tex.json"},"texPngData":{"url":"http://staging-teach.cdn.ireadabc.com/9531e99ab1f656893c74ee5868632f6a.png","name":"draw_circle_tex.png"},"dragDot":{"x":1116.5,"y":420.5},"gIdx":"2","posX":1679.500137597402,"posY":754.4993040274268,"rect":{"x":1196.62,"y":676,"width":200,"height":157},"circleItem":3}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/ef323091055c36876dfe25b5e8ed0128.png","rect":{"x":196.5,"y":0,"width":1536,"height":1987}},"hotZoneItemArr2":[{"id":"1667284877942","index":0,"itemType":"rect","fontScale":1.50703125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.50703125,"dragDot":{"x":964.5,"y":989.551948051948},"gIdx":"7","posX":620.5,"posY":1160.5,"multRect":[{"color":"#ff0000","width":20,"height":20,"x":20,"y":20},{"color":"#00ff00","width":20,"height":20,"x":20,"y":20},{"color":"#00ff00","width":20,"height":20,"x":20,"y":20},{"color":"#00ff00","width":20,"height":20,"x":20,"y":20}],"rect":{"x":184.68,"y":904.39,"width":306.26,"height":204.23}},{"id":"1667284894146","index":1,"itemType":"rect","fontScale":1.50703125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.50703125,"dragDot":{"x":964.5,"y":989.551948051948},"gIdx":"7","posX":988.5001409500544,"posY":1354.4996702166568,"multRect":[{"color":"#ffff00","width":20,"height":20,"x":20,"y":20},{"color":"#ffff00","width":20,"height":20,"x":20,"y":20},{"color":"#ffff00","width":20,"height":20,"x":20,"y":20}],"rect":{"x":525.99,"y":1079.53,"width":261.98,"height":190.46}},{"id":"1667284911442","index":2,"itemType":"rect","fontScale":1.50703125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.50703125,"dragDot":{"x":964.5,"y":989.551948051948},"gIdx":"7","posX":1700.5000363742076,"posY":1549.4996150869986,"multRect":[{"color":"#0000ff","width":20,"height":20,"x":20,"y":20},{"color":"#0000ff","width":20,"height":20,"x":20,"y":20}],"rect":{"x":1140.35,"y":1250.58,"width":268.3,"height":186.62}}],"isDebug":false}
		// return {"page_id":"9","book_id":"opw1","part_name":"d","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/739005c0435dcb9f32da08998711b4f9.png","rect":{"x":234.22,"y":0,"width":867.56,"height":511}},"hotZoneItemArr":[{"id":"1667887774583","index":0,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":590,"posY":170.5,"rect":{"x":336.28,"y":151,"width":39,"height":39},"linkItem":2,"pointItem":1},{"id":"1667887788202","index":1,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":638.0000145894242,"posY":221.4999681090152,"rect":{"x":384.28,"y":202,"width":39,"height":39},"linkItem":1,"pointItem":2},{"id":"1667887795720","index":2,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":761.000005611317,"posY":170.49995856977634,"rect":{"x":507.28,"y":151,"width":39,"height":39},"linkItem":4,"pointItem":3},{"id":"1667887801441","index":3,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":720.9999826049174,"posY":220.4999681090152,"rect":{"x":467.28,"y":201,"width":39,"height":39},"linkItem":3,"pointItem":4},{"id":"1667887806805","index":4,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":911.9999900866734,"posY":226.49995875682023,"rect":{"x":658.28,"y":207,"width":39,"height":39},"linkItem":6,"pointItem":5},{"id":"1667887814385","index":5,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":767.9999543612886,"posY":247.49995763455684,"rect":{"x":514.28,"y":228,"width":39,"height":39},"linkItem":5,"pointItem":6},{"id":"1667887820091","index":6,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":919.99998129561,"posY":356.499953706635,"rect":{"x":666.28,"y":337,"width":39,"height":39},"linkItem":8,"pointItem":7},{"id":"1667887826462","index":7,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":769.9999528649374,"posY":320.4999333188499,"rect":{"x":516.28,"y":301,"width":39,"height":39},"linkItem":7,"pointItem":8},{"id":"1667887833937","index":8,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":771.9999809215223,"posY":389.49994005243036,"rect":{"x":518.28,"y":370,"width":39,"height":39},"linkItem":10,"pointItem":9},{"id":"1667887840312","index":9,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":720.9999805474345,"posY":348.4999271464013,"rect":{"x":467.28,"y":329,"width":39,"height":39},"linkItem":9,"pointItem":10},{"id":"1667887846297","index":10,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":580.9999900866734,"posY":388.4999348152012,"rect":{"x":327.28,"y":369,"width":39,"height":39},"linkItem":12,"pointItem":11},{"id":"1667887879817","index":11,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":637.0000162728193,"posY":347.49992733344516,"rect":{"x":383.28,"y":328,"width":39,"height":39},"linkItem":11,"pointItem":12},{"id":"1667887885876","index":12,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":431.0000057983608,"posY":349.499935002245,"rect":{"x":177.28,"y":330,"width":39,"height":39},"linkItem":14,"pointItem":13},{"id":"1667887891550","index":13,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":584.0000443294042,"posY":320.49993462815723,"rect":{"x":330.28,"y":301,"width":39,"height":39},"linkItem":13,"pointItem":14},{"id":"1667887898232","index":14,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":429.0000157116875,"posY":226.49994005243036,"rect":{"x":175.28,"y":207,"width":39,"height":39},"linkItem":16,"pointItem":15},{"id":"1667887904615","index":15,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":255.5},"gIdx":"0","posX":585.000044703492,"posY":247.49995763455684,"rect":{"x":331.28,"y":228,"width":39,"height":39},"linkItem":15,"pointItem":16}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/587034b4ac726f8f7a3c94d2ace95ded.png","rect":{"x":129.72,"y":0,"width":1076.55,"height":1393}},"hotZoneItemArr2":[{"id":"1667887944389","index":0,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":577,"posY":643.5,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":424.78,"y":621,"width":45,"height":45}},{"id":"1667887960040","index":1,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":632.004792675414,"posY":698.5014661615592,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":479.78,"y":676,"width":45,"height":45}},{"id":"1667887965560","index":2,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":769.0049179883678,"posY":641.5015914745129,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":616.79,"y":619,"width":45,"height":45}},{"id":"1667887978234","index":3,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":724.0052301315435,"posY":698.5014616047245,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":571.8,"y":676,"width":45,"height":45}},{"id":"1667887985592","index":4,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":936.0151276255474,"posY":705.5015914745129,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":783.81,"y":683,"width":45,"height":45}},{"id":"1667887992372","index":5,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":779.0256106728078,"posY":728.5016074234343,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":626.82,"y":706,"width":45,"height":45}},{"id":"1667887999027","index":6,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":942.0352529840694,"posY":848.5016598270331,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":789.83,"y":826,"width":45,"height":45}},{"id":"1667888007133","index":7,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":778.0456243888804,"posY":807.501933237114,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":625.84,"y":785,"width":45,"height":45}},{"id":"1667888014504","index":8,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":784.0552507512206,"posY":886.501839822003,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":631.85,"y":864,"width":45,"height":45}},{"id":"1667888022599","index":9,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":724.0652644445088,"posY":839.5020198169731,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":571.86,"y":817,"width":45,"height":45}},{"id":"1667888029229","index":10,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":570.0751277622525,"posY":884.501912731358,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":417.86,"y":862,"width":45,"height":45}},{"id":"1667888036936","index":11,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":630.084776908766,"posY":839.5020152601384,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":477.86,"y":817,"width":45,"height":45}},{"id":"1667888043743","index":12,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":401.08491361380663,"posY":842.501912731358,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":248.86,"y":820,"width":45,"height":45}},{"id":"1667888050282","index":13,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":573.0843918562354,"posY":807.50191956661,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":420.86,"y":785,"width":45,"height":45}},{"id":"1667888056672","index":14,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":399.0847837440182,"posY":702.501839822003,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":246.86,"y":680,"width":45,"height":45}},{"id":"1667888064637","index":15,"itemType":"rect","fontScale":1.04375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.04375,"dragDot":{"x":668,"y":696.5},"gIdx":"0","posX":572.0843872994008,"posY":727.5016005881822,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":419.86,"y":705,"width":45,"height":45}}],"isDebug":false}
		// return {"page_id":"82","book_id":"opw3","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/48ecdccc083571a554a0393e88aa8e17.png","rect":{"x":0,"y":44.55,"width":2178,"height":731.91}},"hotZoneItemArr":[{"id":"1667527075823","index":0,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1027,"posY":353.49534883720935,"rect":{"x":987.5,"y":269.45,"width":79,"height":79},"circleItem":1,"signItem":1},{"id":"1667527184155","index":1,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1299,"posY":353.49534883720935,"rect":{"x":1259.5,"y":269.45,"width":79,"height":79},"circleItem":2,"signItem":2},{"id":"1667527190579","index":2,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1027,"posY":460.49534883720935,"rect":{"x":987.5,"y":376.45,"width":79,"height":79},"signItem":3},{"id":"1667527194988","index":3,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1300,"posY":463.49534883720935,"rect":{"x":1260.5,"y":379.45,"width":79,"height":79},"signItem":4},{"id":"1667527200554","index":4,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1028,"posY":571.4953488372093,"rect":{"x":988.5,"y":487.45,"width":79,"height":79},"signItem":5},{"id":"1667527205347","index":5,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1300,"posY":570.4953488372093,"rect":{"x":1260.5,"y":486.45,"width":79,"height":79},"signItem":6},{"id":"1667527210543","index":6,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1027,"posY":677.4953488372093,"rect":{"x":987.5,"y":593.45,"width":79,"height":79},"signItem":7},{"id":"1667527216357","index":7,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1299,"posY":678.4953488372093,"rect":{"x":1259.5,"y":594.45,"width":79,"height":79},"signItem":8},{"id":"1667527221859","index":8,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1628,"posY":355.49534883720935,"rect":{"x":1588.5,"y":271.45,"width":79,"height":79},"signItem":9},{"id":"1667527229299","index":9,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1900,"posY":353.49534883720935,"rect":{"x":1860.5,"y":269.45,"width":79,"height":79},"signItem":10},{"id":"1667527237415","index":10,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1627,"posY":460.49534883720935,"rect":{"x":1587.5,"y":376.45,"width":79,"height":79},"signItem":11},{"id":"1667527242936","index":11,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1900,"posY":461.49534883720935,"rect":{"x":1860.5,"y":377.45,"width":79,"height":79},"signItem":12},{"id":"1667527249982","index":12,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1626,"posY":569.4953488372093,"rect":{"x":1586.5,"y":485.45,"width":79,"height":79},"signItem":13},{"id":"1667527256608","index":13,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1900,"posY":571.4953488372093,"rect":{"x":1860.5,"y":487.45,"width":79,"height":79},"signItem":14},{"id":"1667527262126","index":14,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1627,"posY":678.4953488372093,"rect":{"x":1587.5,"y":594.45,"width":79,"height":79},"signItem":15},{"id":"1667527269087","index":15,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":410.5},"gIdx":"4","posX":1900,"posY":679.4953488372093,"rect":{"x":1860.5,"y":595.45,"width":79,"height":79},"signItem":16}],"part_name":"e","begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/cdc23fe114c7fbe4ce688c5b7cdff70e.png","rect":{"x":224.98,"y":0,"width":1728.05,"height":2236}},"hotZoneItemArr2":[{"id":"1667527318185","index":0,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1068,"posY":1726,"rect":{"x":811.02,"y":1694,"width":64,"height":64}},{"id":"1667527349948","index":1,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1265.9950206411086,"posY":1725.9983039012782,"rect":{"x":1009.02,"y":1694,"width":64,"height":64}},{"id":"1667527354975","index":2,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1067.9948260712667,"posY":1803.9983039012782,"rect":{"x":811.01,"y":1772,"width":64,"height":64}},{"id":"1667527363008","index":3,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1266.9850206509354,"posY":1803.9982272525526,"rect":{"x":1010.01,"y":1772,"width":64,"height":64}},{"id":"1667527368695","index":4,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1068.9848250984178,"posY":1883.9982272525526,"rect":{"x":812,"y":1852,"width":64,"height":64}},{"id":"1667527374694","index":5,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1266.9750196780863,"posY":1882.9981486384752,"rect":{"x":1010,"y":1851,"width":64,"height":64}},{"id":"1667527380289","index":6,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1066.9748251082444,"posY":1962.998149621151,"rect":{"x":809.99,"y":1931,"width":64,"height":64}},{"id":"1667527388175","index":7,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1266.965021653265,"posY":1960.9980710070736,"rect":{"x":1009.99,"y":1929,"width":64,"height":64}},{"id":"1667527393603","index":8,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1506.964825118071,"posY":1724.9980729724255,"rect":{"x":1249.98,"y":1693,"width":64,"height":64}},{"id":"1667527399645","index":9,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1705.9545892856654,"posY":1724.998304883954,"rect":{"x":1448.97,"y":1693,"width":64,"height":64}},{"id":"1667527406504","index":10,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1505.9443937429746,"posY":1803.998304883954,"rect":{"x":1248.96,"y":1772,"width":64,"height":64}},{"id":"1667527414914","index":11,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1705.934590287995,"posY":1804.9982272525526,"rect":{"x":1448.95,"y":1773,"width":64,"height":64}},{"id":"1667527423039","index":12,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1506.924393762628,"posY":1883.9982262698766,"rect":{"x":1249.94,"y":1852,"width":64,"height":64}},{"id":"1667527431966","index":13,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1705.9145893249724,"posY":1883.9981486384752,"rect":{"x":1448.93,"y":1852,"width":64,"height":64}},{"id":"1667527439422","index":14,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1507.9043937822817,"posY":1962.9981486384752,"rect":{"x":1250.92,"y":1931,"width":64,"height":64}},{"id":"1667527445613","index":15,"itemType":"rect","fontScale":1.7015625,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.7015625,"dragDot":{"x":1089,"y":1118},"gIdx":"8","posX":1705.8945883619504,"posY":1963.9980710070736,"rect":{"x":1448.91,"y":1932,"width":64,"height":64}}],"isDebug":false}
		return this.item = {"begin_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","idle_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_right_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","finish_wrong_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_link_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","error_write_audio_url":"http://staging-teach.cdn.ireadabc.com/3d307a02663e1cd667b7c951340ec98b.mp3","page_id":"7","book_id":"opw1","part_name":"d","bgItem":{"url":"http://staging-teach.cdn.ireadabc.com/75bcd934bdd589d901b1d1dcf9e05e2b.png","rect":{"x":455.89,"y":0,"width":1729.22,"height":992}},"hotZoneItemArr":[{"id":"1667291729830","index":0,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":496},"gIdx":"0","posX":714.5,"posY":509,"rect":{"x":232.61,"y":483,"width":52,"height":52},"linkItem":2,"pointItem":1},{"id":"1667291758660","index":1,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":863.4985828918223,"posY":708.0011902773308,"rect":{"x":381.61,"y":682,"width":52,"height":52},"linkItem":1,"pointItem":2},{"id":"1667291766274","index":2,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1038.4989313227106,"posY":767.0016556313363,"rect":{"x":556.61,"y":741,"width":52,"height":52},"linkItem":4,"pointItem":3},{"id":"1667291773931","index":3,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1208.4993405536202,"posY":565.0017936006144,"rect":{"x":726.61,"y":539,"width":52,"height":52},"linkItem":3,"pointItem":4},{"id":"1667291781144","index":4,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1365.499738092218,"posY":554.0013212312218,"rect":{"x":883.61,"y":528,"width":52,"height":52},"linkItem":6,"pointItem":5},{"id":"1667291787620","index":5,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1519.500105230805,"posY":368.0012955081361,"rect":{"x":1037.61,"y":342,"width":52,"height":52},"linkItem":5,"pointItem":6},{"id":"1667291794068","index":6,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1697.5004653540052,"posY":452.00086055414096,"rect":{"x":1215.61,"y":426,"width":52,"height":52},"linkItem":8,"pointItem":7},{"id":"1667291799074","index":7,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1762.5008816003017,"posY":565.0010569849775,"rect":{"x":1280.61,"y":539,"width":52,"height":52},"linkItem":7,"pointItem":8},{"id":"1667291806543","index":8,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1672.501033600354,"posY":721.0013212312218,"rect":{"x":1190.61,"y":695,"width":52,"height":52},"linkItem":10,"pointItem":9},{"id":"1667291814677","index":9,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1477.5008231387435,"posY":705.0016860313468,"rect":{"x":995.61,"y":679,"width":52,"height":52},"linkItem":9,"pointItem":10},{"id":"1667291823228","index":10,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1371.5003671385873,"posY":813.0016486159494,"rect":{"x":889.61,"y":787,"width":52,"height":52},"linkItem":12,"pointItem":11},{"id":"1667291830926","index":11,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1199.5001192615794,"posY":812.0019011698821,"rect":{"x":717.61,"y":786,"width":52,"height":52},"linkItem":11,"pointItem":12},{"id":"1667291842195","index":12,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1326.4997170460567,"posY":247.00189883141968,"rect":{"x":844.61,"y":221,"width":52,"height":52},"linkItem":14,"pointItem":13},{"id":"1667291853247","index":13,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1130.500014030774,"posY":267.00057760019786,"rect":{"x":648.61,"y":241,"width":52,"height":52},"linkItem":13,"pointItem":14},{"id":"1667291861161","index":14,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":1060.4995556921554,"posY":407.00062436944467,"rect":{"x":578.61,"y":381,"width":52,"height":52},"linkItem":16,"pointItem":15},{"id":"1667291869501","index":15,"itemType":"rect","fontScale":2.06328125,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":2.06328125,"dragDot":{"x":1320.5,"y":495.99999999999994},"gIdx":"0","posX":891.4993919997917,"posY":447.0009517541722,"rect":{"x":409.61,"y":421,"width":52,"height":52},"linkItem":15,"pointItem":16}],"bgItem2":{"url":"http://staging-teach.cdn.ireadabc.com/71e68ebc76a7ce04eef418353d3f1844.png","rect":{"x":191.67,"y":0,"width":1499.67,"height":1940}},"hotZoneItemArr2":[{"id":"1667380287432","index":0,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":670.5,"posY":1410.5,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":277.93,"y":1022.76,"width":36.15,"height":36.15}},{"id":"1667380314762","index":1,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":827.4994456359115,"posY":1617.5012714317836,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":393.79,"y":1175.51,"width":36.15,"height":36.15}},{"id":"1667380322503","index":2,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1007.4995871564998,"posY":1680.5014580226232,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":526.61,"y":1222,"width":36.15,"height":36.15}},{"id":"1667380329891","index":3,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1185.4997494094036,"posY":1470.5015148111395,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":657.96,"y":1067.03,"width":36.15,"height":36.15}},{"id":"1667380339099","index":4,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1346.4999098594978,"posY":1458.5013255160848,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":776.77,"y":1058.18,"width":36.15,"height":36.15}},{"id":"1667380346091","index":5,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1507.5000549857066,"posY":1264.5013146992246,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":895.57,"y":915.02,"width":36.15,"height":36.15}},{"id":"1667380353829","index":6,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1690.500200111915,"posY":1351.5011398266504,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":1030.61,"y":979.22,"width":36.15,"height":36.15}},{"id":"1667380360920","index":7,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1756.500365069034,"posY":1469.5012182488872,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight","value":true}]},"rect":{"x":1079.31,"y":1066.3,"width":36.15,"height":36.15}},{"id":"1667380368760","index":8,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1664.5004245617654,"posY":1629.5013246146798,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":1011.42,"y":1184.36,"width":36.15,"height":36.15}},{"id":"1667380374561","index":9,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1462.5003416325035,"posY":1613.5014688394833,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":862.36,"y":1172.56,"width":36.15,"height":36.15}},{"id":"1667380381923","index":10,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1350.500159548689,"posY":1725.501454417003,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":779.72,"y":1255.2,"width":36.15,"height":36.15}},{"id":"1667380387739","index":11,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1174.5000585913265,"posY":1723.5015553743654,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":649.84,"y":1253.73,"width":36.15,"height":36.15}},{"id":"1667380395200","index":12,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1306.4998999440427,"posY":1140.5015535715554,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":747.24,"y":823.52,"width":36.15,"height":36.15}},{"id":"1667380402254","index":13,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1101.5000189295056,"posY":1160.5010280524275,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":595.97,"y":838.28,"width":36.15,"height":36.15}},{"id":"1667380408975","index":14,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":1028.499834141476,"posY":1304.501046080528,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":542.1,"y":944.53,"width":36.15,"height":36.15}},{"id":"1667380417184","index":15,"itemType":"rect","fontScale":1.47109375,"imgScale":1,"imgSizeW":0,"imgSizeH":0,"mapScale":1.47109375,"dragDot":{"x":941.5,"y":962.739595488137},"gIdx":"0","posX":853.4997683389092,"posY":1346.5011758828512,"checkbox":{"title":"答案","list":[{"label":"正确","key":"isRight"}]},"rect":{"x":412.97,"y":975.53,"width":36.15,"height":36.15}}],"isDebug":true}
	
	},

	preload() {
		const preloadArr = this._imageResList.concat(this._audioResList).concat(this._animaResList);
		console.log(' in preload preloadArr: ', preloadArr);
		cc.assetManager.loadAny(preloadArr, null, null, (err, data) => {
			console.log(' preload data, ', data);


			this.addServerListener();
			// if (window && window["air"]) {
			// 	window["air"].hideAirClassLoading();
			// }
		});
	},

	addServerListener() {
		
		if (window && window["air"]) {
			// cc.find('Canvas').opacity = 0;
			// window.air.onCourseInScreen = (next) => {
			// 	//  cc.find('Canvas').opacity = 255;
			// 	this.loadEnd();
			// 	next();
			// }
			this.loadEnd();
			window.air.hideAirClassLoading();
		} else {
			this.loadEnd();
		}



		if (window.air) {
			window.air.osmoHandwritingMlkitCallback = (data) => {

				if (!data) {
					console.log('data is not exist!!!');
					return;
				}

				console.log('@ data: ', data);

				if (typeof (data) == 'string') {
					console.log('data is string ');
					const dataObj = JSON.parse(data);

					this.photoEnd(dataObj);
					return;
				}

				// 哲学逻辑
				this.photoEnd(data);

			}
		}

		// if (window.air) {

		// 	window.air.osmoHandwritingCallback = (data) => {

		// 		if (!data) {
		// 			console.log('data is not exist!!!');
		// 			return;
		// 		}

		// 		console.log('osmoHandwritingCallback data: ', data);

		// 		if (typeof (data) == 'string') {
		// 			console.log('data is string ');
		// 			const dataObj = JSON.parse(data);

		// 			this.photoEnd(dataObj);
		// 			return;
		// 		}

		// 		// 哲学逻辑
		// 		this.photoEnd(data);

		// 	}

			
		// }

	},

	addPreloadImage() {
	
		if (this.data.bg_pic_url) {
			this._imageResList.push({ url: this.data.bg_pic_url || ''});
		}

		if (this.data.bgItem) {
			this._imageResList.push({ url: this.data.bgItem.url || ''});
		}

		if (this.data.bgItem2) {
			this._imageResList.push({ url: this.data.bgItem2.url || ''});
		}

		if (!this.data.hotZoneItemArr) {
			return;
		}
		this.data.hotZoneItemArr.forEach((item) => {
			if (item.pic_url) {
				this._imageResList.push({ url: item.pic_url || ''});
			}
		})
	},

	addPreloadAudio() {

		const arr = this.data.rows;

		if (arr) {
			for (let i=0 ;i<arr.length; i++) {
				this._audioResList.push({url: arr[i].audio_url || ''});
				this._audioResList.push({url: arr[i].audio_cn_url || ''});
			}
		}

	},

	addPreloadAnima() {
		if (!this.data.hotZoneItemArr) {
			return;
		}
		this.data.hotZoneItemArr.forEach((item) => {
			if (item.skeJsonData) {
				this._animaResList.push({ url: item.skeJsonData.url || '' });
				this._animaResList.push({ url: item.texJsonData.url || ''});
				this._animaResList.push({ url: item.texPngData.url || ''});
			}
		})
	},

	loadEnd() {
		console.log(' in loadEnd');

		// this.data.isDebug = true;

		this.initData();
		this.initView();
		// this.initMusic();

		// this.startTesting();

		// cc.debug.setDisplayStats(true);

	},

	initMusic() {
		cc.assetManager.loadRemote(this.data.bg_audio_url, (err, clip) => {
			cc.audioEngine.setMusicVolume(0.3);
			const audioID = cc.audioEngine.playMusic(clip, true);
		});
	},

	curGroupIndex: null,
	curQuestionIndex: null,
	curQuestionData: null,

	picNodeArr: null,


	firstItemData: null,
	bottomItemData: null,
	animaNodeArr: null,
	circleAnimaNodeArr: null,
	signAnimaNodeArr: null,

	initData() {
		console.log(' in initData');


		this.CHECK_TYPE_LINE = 'LINE';
		this.CHECK_TYPE_WRITE = 'WRITE';
		this.CHECK_TYPE_CIRCLE = 'CIRCLE';
		this.CHECK_TYPE_SIGN = 'SIGN';
		this.CHECK_TYPE_FINGER = 'FINGER';


		this.poolArr = [];

		this.quesNodeArr = [];

		this.totalLineArr = [];
		this.rectNodeArr = [];

		this.animaNodeArr = [];

		this.circleAnimaNodeArr = [];
		this.signAnimaNodeArr = [];
		this.fingerAnimaNodeArr = [];

		this.picNodeArr = [];
		this.initAudioEffect();

		this.linkRectGroup = [];


		// this.newRectArr = this.getGroupArrByGIdx(this.data.hotZoneItemArr2, '0');

		this.titleWidth = 70;
		if (this.canvas.width < this.canvas.height) {
			this.isVertical = true;
			this.titleWidth = 50;
		}

		// this.isVertical = true;

		this.wordBgArr = [];


		// this.data.quesArr = this.data.quesArr.concat( JSON.parse( JSON.stringify(this.data.quesArr)));

		console.log("this.data.quesArr: ", this.data.quesArr);

	},

	initTypeArr() {
		const typeArr = this.data.typeArr;
		
		if (!this.data.firstGIdx) {
			this.data.firstGIdx = typeArr[0].gIdx;
		}

		this.typeArr = [];
		const firstType = typeArr.find((t) => {
			return t.gIdx == this.data.firstGIdx;
		})

		const index = typeArr.indexOf(firstType);
		typeArr.splice(index, 1);

		this.typeArr = [firstType];
		this.typeArr = this.typeArr.concat(typeArr)
		this.typeArrIndex = 0;

		console.log("this.typeArr: ", this.typeArr);
	},

	initCheckBase() {


		console.log('benchmark1Data: ', this.benchmark1Data);
		console.log('benchmark2Data: ', this.benchmark2Data);
		console.log('centerItemArr: ', this.centerItemArr);

		const benchmark1Rect = this.benchmark1Data.rect;
		const benchmark2Rect = this.benchmark2Data.rect;
		
		const benchmark1CenterY = (benchmark1Rect.y + benchmark1Rect.height / 2);
		const benchmark2CenterY = (benchmark2Rect.y + benchmark2Rect.height / 2);
		
		let unitH = benchmark2CenterY - benchmark1CenterY;
		let unitW = benchmark2Rect.x + benchmark2Rect.width - benchmark1Rect.x;
		let baseX = benchmark1Rect.x;
		let baseY = benchmark1CenterY;


		if (this.firstItemData) {
			const firstItemRect = this.firstItemData.rect;
			baseX = firstItemRect.x + firstItemRect.width / 2;
			baseY = firstItemRect.y + firstItemRect.height / 2;
			unitW = benchmark1Rect.x + benchmark1Rect.width - (firstItemRect.x + firstItemRect.width / 2);
			unitH = (firstItemRect.y + firstItemRect.height / 2) - benchmark1CenterY;
		}


		for(let i=0; i<this.centerItemArr.length; i++) {

			const itemRect = this.centerItemArr[i].rect;
			const x = itemRect.x + itemRect.width / 2;
			const y = itemRect.y + itemRect.height / 2;

			const unitX = (x - baseX) / unitW;
			const unitY = (y - baseY) / unitH;
			const unitW2 = itemRect.width / unitW;
			const unitH2 = itemRect.height / unitH;


			this.centerItemArr[i].unitX = unitX;
			this.centerItemArr[i].unitY = unitY;
			this.centerItemArr[i].unitW = unitW2;
			this.centerItemArr[i].unitH = unitH2;

			// console.log('unitX: ', unitX)
			// console.log('unitY: ', unitY)
		}

		console.log('unitH: ', unitH)
		console.log('unitW: ', unitW)
		console.log('baseX: ', baseX)
		console.log('baseY: ', baseY)

	
		const centerX = this.data.bgItem2.rect.width / 2;
		this.centerUnitW = (centerX - baseX) / unitW;



	},

	getGroupArrByGIdx(arr, gIdx) {
		const groupArr = [];
		for (let i=0; i<arr.length; i++) {
			if (arr[i].gIdx == gIdx) {

				const data = JSON.parse(JSON.stringify(arr[i]));
				groupArr.push(data);
				// groupArr.push(arr[i]);
			}
		}

		return groupArr;
	},

	curGroup: null,
	setCurGroupAndQuestion() {
		this.curGroup = this.data.groupArr[this.curGroupIndex];

		if (!this.curGroup) {
			this.gameEnd();
		} else {
			this.curQuestionIndex = 0;
			this.setCurQuestionData();
		}
	},

	setCurQuestionData() {
		this.curQuestionData = this.curGroup.questionArr[this.curQuestionIndex];

		if (!this.curQuestionData) {

			this.hideVideo();
			this.showBigStar();
		}
	},

	hideVideo() {
		this.videoNode.active = false;

		this.videoNode.player.pause();
		this.videoNode.pauseBtn.active = false;
		this.videoNode.playBtn.active = true;
	},


	rightClip: null,
	wrongClip: null,
	bigStarClip: null,
	btnClip: null,
	finishClip: null,
	selectClip: null,
	starCountClip: null,
	beginTipClip: null,
	initAudioEffect() {
		this.rightClip = cc.find('Canvas/res/audio/right').getComponent(cc.AudioSource).clip;
		this.wrongClip = cc.find('Canvas/res/audio/wrong').getComponent(cc.AudioSource).clip;
		this.bigStarClip = cc.find('Canvas/res/audio/big_star').getComponent(cc.AudioSource).clip;
		this.btnClip = cc.find('Canvas/res/audio/btn').getComponent(cc.AudioSource).clip;
		this.finishClip = cc.find('Canvas/res/audio/finish').getComponent(cc.AudioSource).clip;
		this.selectClip = cc.find('Canvas/res/audio/select').getComponent(cc.AudioSource).clip;
		this.starCountClip = cc.find('Canvas/res/audio/star_count').getComponent(cc.AudioSource).clip;

		this.beginTipClip = cc.find('Canvas/res/audio/begin_tip').getComponent(cc.AudioSource).clip;

	},



	initView() {

		console.log(' in initView');


		this.data.isDebug = false;
		this.initQuesArr();

		this.initBg();

		this.initParticle();

		this.initWord();


		this.initDebugLayer();



		this.initCurQues();

		this.initTipPanel();

		cc.find("Canvas/senderr").zIndex = 10;
		cc.find("Canvas/senderr").active = false;

		this.initVideoNode();

		this.initRestartNode();
		// this.showStartAudio();

		this.showFanGuangJing();
	},

	initParticle() {

		const particleLayer = new cc.Node();
		this.canvas.addChild(particleLayer);
		this.particleLayer = particleLayer;

		this.addOneStar();

	},

	addOneStar() {

		const star = this.getOneParticle();
		const scale = 0.1 + Math.random() * 2;
		const px = -this.canvas.width / 2 + Math.random() * this.canvas.width;
		const py = -this.canvas.height / 2 + Math.random() * this.canvas.height;
		const showTime = 1 + Math.random() * 3;
		const delayTime = 0.1 + Math.random() * 2;
		star.x = px;
		star.y = py;

		star.scale = 0;
		star.opacity = 0;
		cc.tween(star)
			.to(showTime / 2, {scale, opacity: 255}, {easing: "sineInOut"})
			.delay(delayTime)
			.to(showTime / 2, {scale: 0, opacity: 0}, {easing: "sineInOut"})
			.call(() => {
				this.addPoolParticle(star);
			})
			.start()

			delayCall(0.05, () => {
				if (this.isDestroy) {
					return;
				}
				this.addOneStar();
			})
	},

	getOneParticle() {

		let star;
		if (this.poolArr.length > 0) {
			// console.log('this.poolArr.length: ', this.poolArr.length);
			star = this.poolArr.pop();
		} else {
			star = getSprNode('new/star');
			this.particleLayer.addChild(star);
		}
	
		return star;
	},

	addPoolParticle(particle) {
		if (this.poolArr.indexOf(particle) == -1) {
			this.poolArr.push(particle);
			particle.opacity = 0;
		}
	},

	// removePoolParticle() {

	// },

	showTipAnim() {
		const tipAnimNode = cc.find("Canvas/tip_node/tip_panel/yindao_benzi");
		const anim = tipAnimNode.getComponent(dragonBones.ArmatureDisplay);
		anim.playAnimation('newAnimation', -1);
	},


	showFanGuangJing() {
		this.showTipAnim();
		return;

		const middleLayer = cc.find('middleLayer');
		if (middleLayer) {
			const script = middleLayer.getComponent('middleLayer');
			if (script.showTipReflector) {
				script.showTipReflector(() => {
					if (this.isDestroy) {
						return;
					}
					this.showTipAnim();
				})
			}

			delayCall(5, () => {
				if (this.isDestroy) {
					return;
				}
				if (script.closeTipAnim) {
					script.closeTipAnim()
				}
			})
		} else {
			this.showTipAnim();
		}
	},

	initRestartNode() {
		this.restartNode = cc.find("Canvas/restart_node");
		this.restartNode.zIndex = 10;
		this.restartNode.active = false;

		const restartBtn = cc.find("btn_restart", this.restartNode);

		restartBtn.on('click', () => {
			console.log('in restartNode ');

			if (this.isDestroy) {
				return;
			}

			const middleLayer = cc.find('middleLayer');
			if (middleLayer) {
				middleLayer.getComponent('middleLayer').reloadBundle();
			}
		})
	},

	initVideoNode() {
		const videoNode = cc.find("Canvas/video_node");
		this.videoNode = videoNode;
		videoNode.zIndex = 11;


		// videoNode.width = 720;
		// videoNode.height = 1280;

		const closeBtn = cc.find("videoCloseBtn", videoNode)
		closeBtn.on("click", () => {
			console.log(' in closeBtn')

			if (this.isDestroy) {
				return;
			}
			this.hideVideoNode();
		})


		const videoPlayerNode = cc.find("videoPlayer", videoNode);
		const video = videoPlayerNode.getComponent(cc.VideoPlayer);

		video.stayOnBottom = true;

		this.video = video;

		video.node.on('meta-loaded', (e) => {
			console.log('meta-loaded e:', e);
		})
		video.node.on('ready-to-play', async (e) => {

			console.log('e: ', e);
			if (this.isDestroy) {
				return;
			}

			// video.play();
			// checkIsPlaying();

		})

		const checkIsPlaying = () => {

			delayCall(0.05, () => {


				if (this.isDestroy) {
					return;
				}
				
				if (video.currentTime > 0) {
		
					video.node.isLoadEnd = true;
					video.pause();

					// this.checkCanPlayVideo();
				} else {
					checkIsPlaying();
				}
			})

		}

		video.node.on('completed', () => {
			console.log(' in completed!!!!');

			// if (this.isLast && this.playTimes > 0) {
			// 		this.showGoodjob();
			// } else {
			// 	this.showMask(() => {
			// 		if (!this.isLocal) {
			// 			callMiddleLayerFunction('PSQS_play_animate_over', null, () => {})
			// 		}
			// 	})
			// }
		})
	},

	showVideoNode() {
		// if (!this.video.node.isLoadEnd) {
		// 	delayCall(0.1, () => {
		// 		this.showVideoNode();
		// 	})
		// 	return
		// }

		this.videoNode.active = true;
		this.video.play();

		this.bgLayer.active = false;
		this.scrollView.node.active = false;
		this.tipNode.active = false;
		console.log(" in showVideoNode");

	},

	hideVideoNode() {
		this.video.pause();
		this.video.currentTime = 0;
		this.videoNode.active = false;

		this.bgLayer.active = true;
		this.scrollView.node.active = true;
		this.tipNode.active = true;

	},

	initTipPanel() {
		const tipNode = cc.find("Canvas/tip_node");
		tipNode.zIndex = 10;

		if (this.isVertical) {
			tipNode.scale = this.canvas.width / 1080;
		}
		this.tipNode = tipNode;

		
		const clickFunc = () => {

			if (this.isDestroy) {
				return;
			}
			tipNode.active = false;
			this.showStartAudio();
		}


		const guideVideoNode = cc.find("tip_panel/btn_guide_video", tipNode);
		guideVideoNode.on("click", () => {
			this.showVideoNode();
		});

		const guideJumpNode = cc.find("tip_panel/btn_guide_jump", tipNode);
		guideJumpNode.on("click", clickFunc);

		// const okBtn = cc.find("tip_panel/ok_btn", tipNode);
		// okBtn.on("click", clickFunc);

		const closeBtn = cc.find("tip_panel/close_btn", tipNode);
		closeBtn.on("click", clickFunc);
	},


	async initWord() {

		if (this.isVertical || true) {
			this.initVerticalWord();
			return;
		}


		this.wordBgArr = [];

	
		const sv = this.getScrollView(); 
		this.scrollView = sv;

		
		const content = sv.content;
		content.width = sv.node.width;
		content.height = sv.node.height;
		

		const offX = this.titleWidth;
		const baseX = -460;
		const baseY = 0 //sv.node.height / 2 //-200 //300 - this.bg.height / 2;
		const disX = 50;
		const disY = 100;
		const lineBaseY = -150;
		const lineDisY = 220;
		let curY;
		let row = 0;
		let col = 0;
		const quesArr = this.quesArr
		let curPage;

		console.log("quesArr: " + JSON.stringify(quesArr));

		for (let i=0; i<quesArr.length; i++) {

			let pageBg;
			if (i % 6 == 0) {
				pageBg = getSprNode("h_page_1");
				curPage = pageBg;
				content.addChild(pageBg, 1);
				pageBg.anchorY = 1;
				pageBg.x = -pageBg.width / 2 - disX / 2;
				if (curY == null) {
					pageBg.y = baseY;
				} else {
					pageBg.y = curY - disY - pageBg.height; 
				}
				curY = pageBg.y;

				col = 0;
				row = 0;
			}

			if ( (i + 3) % 6 == 0 ) {
				const itemBttom = getSprNode("h_book_item_b");
				itemBttom.y = curPage.y - curPage.height / 2;
				const itemTop = getSprNode("h_book_item_t");
				itemTop.y = itemBttom.y;

				content.addChild(itemBttom);
				content.addChild(itemTop, 2);

				pageBg = getSprNode("h_page_2");
				curPage = pageBg;
				content.addChild(pageBg, 1);
				pageBg.anchorY = 1;
				pageBg.x = pageBg.width / 2 + disX / 2;
				pageBg.y = curY;

				row = 0;
				col = 0;
			}

			const bgResName = 'bg_line';
			const wordBg = getSprNode(bgResName)

			curPage.addChild(wordBg);

			wordBg.x = curPage.width / 2 - wordBg.width / 2 - 50 //baseX + col * disX + offX;
			wordBg.y = lineBaseY - row * lineDisY;

			row ++;

			// if ((i+1) % 2 == 0) {
			// 	row ++;
			// 	col = 0;
			// }

			wordBg.data = quesArr[i];
			// content.addChild(wordBg);
			// this.bg.addChild(wordBg);

			this.wordBgArr.push(wordBg);


			this.setWordQuesText(quesArr[i], wordBg);

			this.setTitleSound(quesArr[i], wordBg)
			
			this.setWordCountdown(quesArr[i], wordBg);
			
			this.setOneWord(quesArr[i], wordBg);

			this.setWordAnswerIcon(quesArr[i], wordBg);

			this.setWordSound(quesArr[i], wordBg);

			console.log('i: ', i);
			console.log('wordBg: ', wordBg);

			// const curTempH = Math.abs( wordBg.y - wordBg.height / 2 - disY /2);
			const curTempH = Math.abs(curY) + curPage.height + disY / 2;
			console.log('curTempH: ', curTempH);

			if (content.height < curTempH) {
				content.height = curTempH;
				console.log('curTempH 2: ', curTempH);
			}
		
		}
	},

	addOnePageBg(content, curY) {


		const pageBg = getSprNode("bg_write_2");
		pageBg.anchorY = 0.96;
		pageBg.scale = content.width / pageBg.width;
		pageBg.y = -curY;

		const pageH = pageBg.height * pageBg.scaleY * pageBg.anchorY;
		if (curY + pageH > content.height) {
			content.height = curY + pageH
		}

		const pageLine = getSprNode("bg_write_line");
		pageLine.scale = pageBg.scale;
		pageLine.y = -curY;
		pageLine.anchorY = 0.8;
		content.lineLayer.addChild(pageLine);


		content.addChild(pageBg)

		return pageBg.y;
	},

	getScrollView() {

		const svNode = cc.find("Canvas/ScrollView");
		svNode.x = this.bg.x;
		svNode.y = this.bg.y;
		svNode.zIndex = 10;
		svNode.width = this.bg.width * 0.9;
		svNode.height = this.bg.height * 0.98;

		const svMaskNode = cc.find("Canvas/ScrollView/view");
		svMaskNode.width = svNode.width;
		svMaskNode.height = svNode.height;

		const sv = svNode.getComponent(cc.ScrollView);
		return sv;
	},

	setWordQuesText(quesData, wordBg) {

		let rate = 1;
		if (this.isVertical) {
			rate = wordBg.scale;
		}

		const quesBg = getSprNode("new/ques_bg");
		const spr = quesBg.getComponent(cc.Sprite);
		spr.type = cc.Sprite.Type.SLICED;
		delayCall(0.01, () => {
		})

		wordBg.addChild(quesBg);
		quesBg.x = -wordBg.width / 2 + 5;
		quesBg.y = wordBg.height / 2 + 5;
		quesBg.anchorX = 0;
		quesBg.anchorY = 0;


		let textMaxW = (quesBg.width * quesBg.scaleX) * 0.9;
		wordBg.textMaxW = textMaxW;

		// const labelNode = this.getLabel(quesData.text_cn || '', 37);
		// const labelNode = this.getRichText(quesData.text_cn || '', 50, "#ffffff", 4, "#197585");
		const labelNode = this.getRichText(quesData.text_en || '', 50, "#ffffff", 4, "#197585");
		labelNode.color = this.getColor('#ffffff');


		// labelNode.x = //wordBg.x - wordBg.width / 2 * wordBg.scaleX - textMaxW / 2;
		// labelNode.y = //wordBg.y + 40 * rate;
		// labelNode.scale = wordBg.scale * 0.8;
		quesBg.addChild(labelNode);

		quesBg.active = false;
		wordBg.titleNode = quesBg;

		delayCall(0.01, () => {
			const maxW = textMaxW ;
			// console.log("width: ", labelNode.width);
			if (labelNode.width > maxW) {
				labelNode.scale = maxW / labelNode.width;
			}

			spr.node.height *= 1.2;
			labelNode.x = quesBg.width / 2;
			labelNode.y = quesBg.height / 2;

		})

	},


	getRichText(text, fontSize, color, outlineWidth, outlineColor, isBlod=false, isFont=false) {

		const labelNode = new cc.Node();
		const label = labelNode.addComponent(cc.RichText);

		label.string = `<outline color=${outlineColor} width=${outlineWidth}><color=${color}><size=${fontSize}>${text}</></color></outline>`
		if (isBlod) {
			label.string = `<b>${label.string}</b>`
		}
		
		labelNode.color = cc.Color.BLACK;

		labelNode.baseFontSize = fontSize;
		labelNode.baseColor = color;
		labelNode.baseOutlineColor = outlineColor;
		labelNode.baseOutlineWidth = outlineWidth;

		label.lineHeight = fontSize * 1.2;

		label.horizontalAlign = cc.macro.TextAlignment.CENTER;

		if (isFont) {
			label.font = cc.find('Canvas/res/font/MMTB').getComponent(cc.Label).font;
		}
	
		return labelNode;
	},

	setTitleSound(quesData, wordBg) {

		let rate = 1;
		if (this.isVertical) {
			rate = wordBg.scale;
		}

		const soundNode = new cc.Node();
		soundNode.parent = wordBg.parent;
		// soundNode.x = wordBg.x - wordBg.width / 2 * wordBg.scaleX - 200;//wordBg.x - 450;
		// soundNode.x = wordBg.x - wordBg.width / 2 * wordBg.scaleX - 200;//wordBg.x - 450;
		soundNode.x = wordBg.titleNode.x - 50;

		soundNode.y = wordBg.y - 40;

		// const soundIcon = getSprNode("sound_ani_1");
		// soundNode.addChild(soundIcon);
		const soundAnimNode = cc.instantiate( cc.find("Canvas/res/anim/laba") );
		soundNode.addChild(soundAnimNode);
		const soundAnim = soundAnimNode.getComponent(cc.Animation);


		// soundAnim.play('laba');
		soundNode.active = false;
		// soundAnimNode.active = false;
		
		wordBg.textSoundNode = soundNode;
		// wordBg.textSoundAnimNode = soundAnimNode;
		wordBg.textSoundAnim = soundAnim;

	},

	setWordCountdown(quesData, wordBg) {

		let rate = 1;
		if (this.isVertical) {
			rate = wordBg.scale;
		}

		const cdNode = cc.instantiate( cc.find("Canvas/res/progress/cd") );
		cdNode.parent = wordBg.parent;
		cdNode.x = wordBg.x + (wordBg.width / 2 - 150) * wordBg.scaleX;
		cdNode.y = wordBg.y + (wordBg.height / 2 - 5) * wordBg.scaleY;
		cdNode.scale = wordBg.scale * 1.2;
		// cdNode.x = wordBg.height / 2;
		// cdNode.x = wordBg.titleNode.x + 50;
		// cdNode.y = wordBg.y - 40;
		// cdNode.scale = 0.8;

		const cd = cdNode.getComponent(cc.ProgressBar);

		const labelNode = this.getLabel(0, 40);
		const label = labelNode.getComponent(cc.Label);
		label.font = '';
		labelNode.color = this.getColor("#a9be67");
		labelNode.parent = cdNode;
		// labelNode.x = cdNode.x;
		labelNode.y = - 3;
		
		labelNode.active = false;

		console.log('cdNode: ', cdNode);
		cdNode.active = false;
		cdNode.label = label;

		const pointer = getSprNode("new/cd_pointer");
		cdNode.addChild(pointer);
		pointer.anchorY = 0;
		pointer.scale = 0.76;

		const dot = getSprNode("new/pointer_dot");
		cdNode.addChild(dot, 2);

		wordBg.cdNode = cdNode;
		wordBg.cd = cd;
		wordBg.cdPointer = pointer;
	},

	setOneWord(quesData, wordBg) {

		let rate = 1;
		if (this.isVertical) {
			rate = wordBg.scale;
		}

		const labelNode = this.getRichText(quesData.text_cn || '', 90, "#ffffff", 5, "#6604d4", null, true);
		// const labelNode = this.getRichText(quesData.text_en || '', 90, "#ffffff", 5, "#6604d4", null, true);


		// const labelNode = this.getLabel(quesData.text_en || '', 120);
		labelNode.parent = wordBg;
		labelNode.y = 10;
		// labelNode.x = wordBg.x;
		// labelNode.y = wordBg.y - 5 * rate;

		labelNode.active = false;
		labelNode.data = quesData;

		labelNode.scale = rate;

		const maxW = wordBg.width * 0.9;
		if (labelNode.width > maxW) {
			labelNode.scale = maxW / labelNode.width;
		}

		wordBg.on('touchstart', () => {
			// this.showLetterLabel(labelNode, true);
			// this.showAnswerIcon(wordBg, true)
		})

		wordBg.wordNode = labelNode;
	},

	setWordAnswerIcon(quesData, wordBg) {

		let rate = 1;
		if (this.isVertical) {
			rate = wordBg.scale;
		}

		
		const answerNode = new cc.Node();
		answerNode.parent = wordBg.parent;
		answerNode.zIndex = 10;
		answerNode.x = wordBg.x + wordBg.width/2 * wordBg.scaleX + 0 * rate;
		answerNode.y = wordBg.y;
		answerNode.scale = 1 * rate;

		const rightIcon = getSprNode("new/icon_right");
		answerNode.addChild(rightIcon);
		rightIcon.x = rightIcon.width / 2;

		const rightAnimNode = cc.instantiate( cc.find("Canvas/res/anim/rightIcon") );
		const rightAnim = rightAnimNode.getComponent(dragonBones.ArmatureDisplay);
		// rightAnim.playAnimation('newAnimation', 1);
		rightAnimNode.scale = 1 / answerNode.scale;
		rightAnimNode.y = 20 * rate;
		rightAnimNode.x = -wordBg.width / 3;
		answerNode.addChild(rightAnimNode);

		const wrongIcon = getSprNode("new/icon_wrong");
		answerNode.addChild(wrongIcon);
		wrongIcon.x = rightIcon.x;

		const wrongAnimNode = cc.instantiate( cc.find("Canvas/res/anim/wrongIcon") );
		const wrongAnim = wrongAnimNode.getComponent(dragonBones.ArmatureDisplay);
		// wrongAnim.playAnimation('newAnimation', 1);
		wrongAnimNode.scale = 1 / answerNode.scale;
		wrongAnimNode.y = 15 * rate;
		wrongAnimNode.x = rightAnimNode.x
		answerNode.addChild(wrongAnimNode);

		rightAnimNode.active = false;
		wrongAnimNode.active = false;
		rightIcon.active = false;
		wrongIcon.active = false;

		wordBg.rightIcon = rightIcon;
		wordBg.rightAnim = rightAnim;
		wordBg.wrongIcon = wrongIcon;
		wordBg.wrongAnim = wrongAnim;

	},

	setWordSound(quesData, wordBg) {

		let rate = 1;
		if (this.isVertical) {
			rate = wordBg.scale;
		}


		const soundBtn = getSprNode("sound_1");
		soundBtn.parent = wordBg.parent;
		soundBtn.x = wordBg.x + wordBg.width/2 * wordBg.scaleX + 50 * rate;
		soundBtn.y = wordBg.y - 50 * rate;
		soundBtn.scale = 0.8 * rate;


		soundBtn.active = false;
		wordBg.wordSoundBtn = soundBtn;

		soundBtn.on("touchstart", () => {
			playAudioByUrl(quesData.audio_url, () => {

			})
		})
	},


	getColor(colorText) {
		const temp = new cc.Color();
		const color = temp.fromHEX(colorText)
		return color;
	},

	async initVerticalWord() {


		const sv = this.getScrollView(); 
		this.scrollView = sv;

		
		const content = sv.content;
		content.width = sv.node.width;
		content.height = 0;

		// const lineLayer = new cc.Node();
		// content.addChild(lineLayer);
		// content.lineLayer = lineLayer;

		// const pageBg1 = getSprNode("bg_write_1");
		// pageBg1.anchorY = 1;
		// pageBg1.scale = content.width / pageBg1.width;
		// content.addChild(pageBg1);
		// pageBg1.opacity = 50;

		this.wordBgArr = [];

		const offX = this.titleWidth;
		const baseX = 50;
		const baseY = -300;
		const disX = -baseX * 2;
		const disY = 380;
		let row = 0;
		let col = 0;

		console.log('baseY: ', baseY);
		let curY = 0;
		let pageY = 0;
		let lastWordBg;
		const quesArr = this.quesArr;

		for (let i=0; i<quesArr.length; i++) {



			const wordBg = getSprNode("new/word_bg")
			// wordBg.x = baseX + col * disX;
			wordBg.y = baseY - row * disY;

			const wordSpr = wordBg.getComponent(cc.Sprite);
			wordSpr.type = cc.Sprite.Type.SLICED;
			wordBg.baseW = wordBg.width;
			wordBg.baseH = wordBg.height;


			const itemW = this.canvas.width * 0.6;
			delayCall(0.01, () => {
				wordBg.width = Math.max( itemW, wordBg.baseW ) /// wordBg.baseW;

				this.setWordQuesText(quesArr[i], wordBg);

				// this.setTitleSound(quesArr[i], wordBg)
				
				this.setWordCountdown(quesArr[i], wordBg);
				
				this.setOneWord(quesArr[i], wordBg);

				this.setWordAnswerIcon(quesArr[i], wordBg);

				// this.setWordSound(quesArr[i], wordBg);


				
			})

			
			console.log('wordBg.baseW: ', wordBg.baseW);
			console.log('itemW: ', itemW);
			console.log('wordBg.width: ', wordBg.width);

			if (lastWordBg) {
				wordBg.y = lastWordBg.y - disY;
			}

			content.addChild(wordBg, 2);

	


			wordBg.data = quesArr[i];
			wordBg.scale = this._mapScaleMin;

			this.wordBgArr.push(wordBg);

			const curTempH = Math.abs( wordBg.y - wordBg.height / 2 * wordBg.scale - disY /2);
			console.log('curTempH: ', curTempH);

			if (content.height < curTempH) {
				content.height = curTempH;
				console.log('curTempH 2: ', curTempH);
			} 
			curY = content.height;

			lastWordBg = wordBg;
		
		}

	},


	initQuesArr() {
		this.quesArr = [];
		for (let i=0; i<this.data.rows.length; i++) {
			this.quesArr.push(this.data.rows[i]);
		}

		// this.quesArr = randomSortByArr(this.quesArr);

		// for (let i=0; i<this.quesArr.length; i++) {
		// 	this.sortOneSameWord(this.quesArr[i], i);
		// }



		console.log('this.quesArr: ', this.quesArr);

		this.quesArrIndex = 0;
	},

	sortOneSameWord(wordData, index) {

		const word = wordData.text_en;
		
		let replaceIndex = -1;
		let replaceData;

		for (let i = index+1; i<this.quesArr.length; i++) {
			const {text_en} = this.quesArr[i];

			const newWord = this.trimWord(word);
			const newTextEn = this.trimWord(text_en);

			if (newWord.indexOf(newTextEn) != -1) {

				if (!replaceData) {
					replaceData = this.quesArr[i];
					replaceIndex = i;
				} else {
					if (text_en.length < replaceData.text_en.length) {
						replaceData = this.quesArr[i];
						replaceIndex = i;
					}
				}

			}
		}

		if (replaceData) {
			const temp = this.quesArr[replaceIndex]
			this.quesArr[replaceIndex] = wordData;
			this.quesArr[index] = temp;
		}
	},

	trimWord(_text) {

		let text;
		text = _text.toLowerCase();
		text = text.replace(/(^\s+)|(\s+)|(\s+$)/g,"");
		text = text.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");
		text = text.replace(/(\(+.*\)+)/g, "");
		text = text.replace(/(\（+.*\）+)/g, "");
		return text;
	},

	initCurQues() {

		this.curQues = this.quesArr[this.quesArrIndex];
	},

	initFingerQuesData() {

		const fingerQuesArr = [];

		const fingerAnimaNodeArr = this.fingerAnimaNodeArr;
		for (let i=0; i<fingerAnimaNodeArr.length; i++) {
			const quesData = fingerAnimaNodeArr[i].data;
			fingerQuesArr.push(quesData);
		}

		this.fingerQuesArr = randomSortByArr(fingerQuesArr);

		this.nextFingerQues();

		console.log('fingerQuesArr: ', this.fingerQuesArr);
	},

	showStartAudio() {

		console.log(' in showStartAudio ', this.data.begin_audio_url)
		if (!this.data.begin_audio_url) {
			this.startAudioPlayend();
			return;
		}

		playAudioByUrl(this.data.begin_audio_url, () => {

			console.log(' in playAudio ~~ ')
			if (this.isDestroy) {
				return;
			}

			this.startAudioPlayend();
		}) 
	},

	startAudioPlayend() {

		console.log(' in startAudioPlayend ')

		this.isBeginAudioEnd = true;

		this.checkStart();


		// if (this.fingerRectArr && this.fingerRectArr.length > 0) {
		// 	this.checkShowFingerQues();
		// }


		// this.startTesting();
	},

	playCurQuesAudio() {
		
		if (this.curQues && !this.curQues.isFirstEnd) {
			this.curQues.isFirstEnd = true;
			this.curQues.playTimes = 0;
			this.showCurQuesNode();

			
			// delayCall(this.curQues.time, () => {
			// 	this.changeNextQues();
			// })
		}

		if (!this.curQues) {
			return;
		}
		// playAudioByUrl(this.curQues.audio_url, () => {

		// })

		console.log(' this.curQues: ', this.curQues);


		let audio_url;
		if (this.curQues.isPlayingCN) {
			audio_url = this.curQues.audio_url;
			this.curQues.isPlayingCN = false;
		} else {
			audio_url = this.curQues.audio_cn_url;
			this.curQues.isPlayingCN = true;
		}

		cc.assetManager.loadRemote(audio_url, (err, audioClip) => {


			const playAudioFunc = (duration) => {
				playAudio(audioClip, () => {

					if (!this.curQues) {
						return;
					}
					if (!this.curQues.isAudioPlayed) {
						this.curQues.isAudioPlayed = true;
						this.isCanCheck = true;
					}

					// let time = 0.1;
					// const minDisTime = 3;
					// if (Number(duration) < minDisTime) {
					// 	time = minDisTime - Number(duration);
					// }
	
					// console.log('2 duration is : ', duration);
	
					// if (this.curQues.playTimes >= 3) {
					// 	this.changeNextQues();
					// } 
	
					// delayCall(time, () => {
					// 	this.playCurQuesAudio();
					// })

					delayCall(2, () => {
						if (this.isDestroy) {
							return;
						}
						this.playCurQuesAudio();
					})
					
				});
	
				this.curQues.playTimes ++;
			}
      



			const audioId = cc.audioEngine.play(audioClip, false, 0);
			delayCall(0.05, () => {
				if (this.isDestroy) {
					return;
				}
				const duration = cc.audioEngine.getDuration(audioId)
				// cc.audioEngine.pause(audioId)
				
				console.log('1 duration is : ', duration);
				playAudioFunc(duration);
			})

		});
	
	},

	changeScrollViewPos(wordBg) {

		let curH;
		if (this.isVertical) {
			curH = Math.abs(wordBg.y);
		} else {
			curH = Math.abs(wordBg.y);
			// curH = Math.abs(wordBg.y + wordBg.parent.y);
		}
		const tempH = this.scrollView.node.height / 2;

		this.scrollView.scrollToOffset(cc.v2(0, curH - tempH), 1);
	},


	checkCurQuesWrong() {
		if (!this.curQues.isRight) {
			this.showCurQuesWrong();
		}
	},

	showCurQuesWrong() {
		
		
		const curWordBg = this.wordBgArr[this.quesArrIndex];
		const {wordNode} = curWordBg;

		this.showLetterLabel(wordNode, false);
		this.showAnswerIcon(curWordBg, false)


		return;

		const wordKey = this.curQues.quesLabelId;
		let curQuesWordNode;
		for (let i=0; i<this.animaNodeArr.length; i++) {

			const key = this.animaNodeArr[i].data.index + 1;
			if (wordKey == key) {
				curQuesWordNode = this.animaNodeArr[i];
			}
		}

		if (curQuesWordNode) {
			this.showLetterLabel(curQuesWordNode, false);
		}
		
	},

	hideCurTitle() {
		const curWordBg = this.wordBgArr[this.quesArrIndex];
		const {textSoundNode, cdNode} = curWordBg;

		// this.disappearAnim(textSoundNode);
		this.disappearAnim(cdNode);
	},

	changeNextQues() {

		this.isCanCheck = false;

		this.hideJumpBtn();
		this.hideCurTitle();
		this.checkCurQuesWrong();

		this.quesArrIndex ++;
		this.initCurQues();
		if (!this.curQues) {
			// delayCall(1,() => {
				this.gameEnd();
			// })
			return;
		}

	},

	showCurQuesNode() {
		const wordBg = this.wordBgArr[this.quesArrIndex];
		const titleNode = wordBg.titleNode;
		// const textSoundNode = wordBg.textSoundNode;
		// const textSoundAnim = wordBg.textSoundAnim;
		const cdNode = wordBg.cdNode;
		const cd = wordBg.cd;
		const cdPointer = wordBg.cdPointer;


		this.countDown(cdNode, cd, cdPointer);
		// textSoundAnim.play('laba');

		this.appearAnim(titleNode);
		// this.appearAnim(textSoundNode)
		this.appearAnim(cdNode)

		this.changeScrollViewPos(wordBg);

	},

	countDown(cdNode, cdProgress, cdPointer) {
		const data = this.curQues;
		let maxTime = data.text_cn.length * 1.5 // data.time;
		// console.log('data.text_en: ' , data.text_cn);
		// if (maxTime < 7) {
		// 	maxTime = 7;
		// }

		cdProgress.progress = 0;
		

		maxTime = 30;
		const baseTime = maxTime;

		let saveTime = new Date().getTime();
		let curTime = saveTime;

		const updateFunc = () => {
			if (this.isDestroy) {
				return;
			}

			if (this.curQues.isRight) {
				cdProgress.progress = 0;
				this.changeNextQues();
				return;
			}

			curTime = new Date().getTime();
			maxTime -= (curTime - saveTime)/1000;

			saveTime = curTime;

			const rate = maxTime / baseTime;
			cdProgress.progress = rate;

			cdPointer.angle = 90 - rate * 180

			cdNode.label.string = Math.ceil(maxTime);

			if (baseTime - maxTime > 6) {
				this.showJumpBtn();
			}
			if (this.isJump) {
				cdProgress.progress = 0;
				this.isJump = false;
				this.changeNextQues();
				return;
			}

			if (maxTime > 0) {
				delayCall(0.05, () => {
					updateFunc();
				})
			} else {
				cdProgress.progress = 0;

				this.changeNextQues();
			}
			
		}
		
		updateFunc();
	},

	takePictureHide(callback) {
		// 隐藏的拍一张照片
		if (!window["courseware"]) {
			return;
		}
		return;

		const middleLayerComponent = cc.find('middleLayer').getComponent('middleLayer');
		middleLayerComponent.showLoadingTips(`正在收集日志信息，请稍等...`);


		window["courseware"].closeOsmoHandwritingMlkit();
		window["courseware"].openRecognitionCamera({x:1,y:1,width:1,height:1});
		window["courseware"].takePicture((res) => {
			const msg = { word: this.curQue, pic: JSON.parse(res).url };
			// 上报友盟 {单词 , 拍照URL}
			window["courseware"].behaviorToCollectWithParam("mlkUnrecognizedWord", JSON.stringify(msg));
			window["courseware"].closeRecognitionCamera();

			window["courseware"].openOsmoHandwritingMlkit(0.3);
			middleLayerComponent.hideLoadingTips();
			// showTips(JSON.stringify(msg));
			showTips("感谢您的反馈。我们会持续不断地优化算法。");
		});

	},

	initJumpBtn() {
		this.jumpBtn = getSprNode("btn_skip")
		this.jumpBtn.x = this.canvas.width / 2 - this.jumpBtn.width / 2 - 20 * this._mapScaleMin;
		this.jumpBtn.y = -this.canvas.height / 2 + 110 * this._mapScaleMin;
		// this.jumpBtn.y = -this.canvas.height / 2 / 4 * 3;
		this.canvas.addChild(this.jumpBtn, 11);
		this.jumpBtn.on("touchstart", () => {
			this.isJump = true;
			this.hideJumpBtn();
		})

		// 添加一个问题反馈采集
		cc.find(`Canvas/senderr`).active = true;
		cc.find(`Canvas/senderr`).on("touchstart", () => {
			cc.find(`Canvas/senderr`).active = false;
			this.takePictureHide();
		})
	},
	showJumpBtn() {
		// console.log(' in showJumpBtn')
		if (!this.jumpBtn) {
			this.initJumpBtn();
		}
		if (this.jumpBtn.active) {
			return;
		}
		this.jumpBtn.active = true;
		cc.find(`Canvas/senderr`).active = true;
	},
	hideJumpBtn() {
		if (!this.jumpBtn) {
			return;
		}
		this.jumpBtn.active = false;
		cc.find(`Canvas/senderr`).active = false;
	},

	appearAnim(node, time = 1) {
		node.active = true;
		node.opacity = 0
		cc.tween(node)
			.to(time, {opacity: 255}, {easing: "cubicIn"})
			.start();
	},

	disappearAnim(node) {
		node.active = true;
		node.opacity = 255
		cc.tween(node)
			.to(1, {opacity: 0}, {easing: "cubicOut"})
			.start();
	},

	checkShowFingerQues() {

		console.log(' in checkShowFingerQues')
		if (this.curFingerQues && this.isBeginAudioEnd) {
			if (this.curFingerQues.audio_url) {

				this.isStopFingerCheck = true;
				playAudioByUrl(this.curFingerQues.audio_url, () => {
					if (this.isDestroy) {
						return;
					}
					this.isStopFingerCheck = false;
				});
			}
		}
	},

	initTestPointArr() {
		
		const linkeItemArr = this.data.hotZoneItemArr.filter(hzItem => {
			return hzItem.gIdx == '0';
		})

		const bgRect = this.data.bgItem2.rect;

		const setDebugCenterPos = (hzItem) => {

			const debugItemIndex = (Number(hzItem.pointItem) - 1) 
			const debugItem = this.data.hotZoneItemArr2[debugItemIndex];
			const {rect} = debugItem

			const left = Math.round( (rect.x ) / bgRect.width  * 1000 ) / 1000;
			const right =  Math.round( (rect.x + rect.width) / bgRect.width * 1000 ) / 1000;
			const top =  Math.round( (rect.y ) / bgRect.height * 1000 ) / 1000;
			const bottom =  Math.round( (rect.y + rect.height) / bgRect.height * 1000 ) / 1000;
	
			
			const x = left + (right - left) / 2;
			const y = bottom - (bottom - top) / 2;

			hzItem.debugCenterPos = [x, y];
		}

		console.log('linkeItemArr: ', linkeItemArr);

		linkeItemArr.forEach(hzItem => {
			return setDebugCenterPos(hzItem);
		})

		const startPosObj = {};
		const endPosObj = {};

		for (let i=0; i<linkeItemArr.length; i++) {
			const index = this.data.hotZoneItemArr.indexOf(linkeItemArr[i]);
			const key = (index + 1).toString();
			if (!startPosObj[key] && !endPosObj[key]) {
				startPosObj[key] = linkeItemArr[i];


				const endKey = linkeItemArr[i].linkItem.toString();
				const endIndex = Number(endKey) - 1;
				const endItem = this.data.hotZoneItemArr[endIndex];
				endPosObj[endKey] = endItem;
			}
		}

		console.log('startPosObj: ', startPosObj);
		console.log('endPosObj: ', endPosObj);

		
		console.log('this.end_points: ', this.end_points);

	
	},

	checkStart() {

		console.log(' in checkStart')

		// if (this.debugBgImg && this.isBeginAudioEnd) {

		playAudio(this.beginTipClip, () => {
			

			this.playCurQuesAudio();
		

			delayCall(0.2 ,( ) =>{

				this.startTesting();

			})
		})

		// }
		

	},

	getSendCirclePoints(tempCirclePointArr) {

		console.log('tempCirclePointArr: ' , tempCirclePointArr);


		
		const sendCirclePointArr = [];

		for (let i=0; i<tempCirclePointArr.length; i++) {
			const {left, top, right, bottom} = tempCirclePointArr[i];

			const newLeft = left + (right - left) / 2;
			const newTop = top + (bottom - top) / 2;
			const data = {
				left: newLeft,
				right: newLeft,
				top: newTop,
				bottom: newTop
			}

			sendCirclePointArr.push(data);
			// const tempLink1 = tempCirclePointArr[i];
			// const key2 = tempLink1.linkItem;
			// const tempLink2 = tempCirclePointArr[Number(key2)-1];

			// if (!tempLink1.isGetLinked && !tempLink2.isGetLinked) {
			// 	tempLink1.isGetLinked = true;
			// 	tempLink2.isGetLinked = true;

			// 	const pKey1 = tempLink1.pointItem;
			// 	const pKey2 = tempLink2.pointItem;

			// 	const pointItem1 = this.data.hotZoneItemArr2[Number(pKey1) - 1];
			// 	const pointItem2 = this.data.hotZoneItemArr2[Number(pKey2) - 1];

			// 	const region1 = this.getRegionByRect(pointItem1.rect, bgRect);
			// 	const region2 = this.getRegionByRect(pointItem2.rect, bgRect);

			// 	let x1 = region1.left + (region1.right - region1.left) / 2;
			// 	let y1 = region1.top + (region1.bottom - region1.top) / 2;

			// 	let x2 = region2.left + (region2.right - region2.left) / 2;
			// 	let y2 = region2.top + (region2.bottom - region2.top) / 2;

			// 	x1 = Math.floor(x1 * 1000) / 1000;
			// 	y1 = Math.floor(y1 * 1000) / 1000;
			// 	x2 = Math.floor(x2 * 1000) / 1000;
			// 	y2 = Math.floor(y2 * 1000) / 1000;

			// 	sendCirclePointArr.push( {left:x1, top: y1, right:x2, bottom: y2} )
			// }
		}

		console.log("sendCirclePointArr: ", sendCirclePointArr);
		return sendCirclePointArr;
	},


	getSendLinePoints() {

		const hotZoneItemArr = JSON.parse( JSON.stringify(this.data.hotZoneItemArr) );

		const tempLinkArr = this.getGroupArrByGIdx(hotZoneItemArr, '0');
		console.log('tempLinkArr: ' , tempLinkArr);

		const bgRect = this.data.bgItem2.rect;
		
		const sendLinkPointArr = [];

		for (let i=0; i<tempLinkArr.length; i++) {
			const tempLink1 = tempLinkArr[i];
			const key2 = tempLink1.linkItem;
			const tempLink2 = hotZoneItemArr[Number(key2)-1];

			if (!tempLink1.isGetLinked && !tempLink2.isGetLinked) {
				tempLink1.isGetLinked = true;
				tempLink2.isGetLinked = true;

				const pKey1 = tempLink1.pointItem;
				const pKey2 = tempLink2.pointItem;

				const pointItem1 = this.data.hotZoneItemArr2[Number(pKey1) - 1];
				const pointItem2 = this.data.hotZoneItemArr2[Number(pKey2) - 1];

				const region1 = this.getRegionByRect(pointItem1.rect, bgRect);
				const region2 = this.getRegionByRect(pointItem2.rect, bgRect);

				let x1 = region1.left + (region1.right - region1.left) / 2;
				let y1 = region1.top + (region1.bottom - region1.top) / 2;

				let x2 = region2.left + (region2.right - region2.left) / 2;
				let y2 = region2.top + (region2.bottom - region2.top) / 2;

				x1 = Math.floor(x1 * 1000) / 1000;
				y1 = Math.floor(y1 * 1000) / 1000;
				x2 = Math.floor(x2 * 1000) / 1000;
				y2 = Math.floor(y2 * 1000) / 1000;

				sendLinkPointArr.push( {left:x1, top: y1, right:x2, bottom: y2} )
			}
		}

		console.log("sendLinkPointArr: ", sendLinkPointArr);
		return sendLinkPointArr;

		// for (let i=0; i<regions.length; i++) {
		// 	const oneRegion = regions[i];
		// 	console.log('oneRegion: ', oneRegion);
		// 	const x = oneRegion.left + (oneRegion.right - oneRegion.left) / 2;
		// 	const y = oneRegion.top + (oneRegion.bottom - oneRegion.top) / 2;
		// }
	},


	//调起检测
	startTesting() {


		// setInterval(() => {
		// 	this.getPhotoData((data) => {
		// 		this.photoEnd(data);
		// 	});           

		// }, 1000);
		// return;


		const cw = window.courseware;
		if (!cw || !cw.openOsmoHandwritingMlkit) {

			console.log('cw.openOsmoHandwritingMlkit not exist');
			return;
		}
		cw.openOsmoHandwritingMlkit(0.3);

	},

	endTesting() {
		const cw = window.courseware;
		if (!cw || !cw.closeOsmoHandwritingMlkit) {

			return;
		}
		cw.closeOsmoHandwritingMlkit();
		// this.isTesting = false;
	},
	

	changeRegionTo4Pos(regions) {

		for (let i=0; i<regions.length; i++) {
			const {left, top, right, bottom} = regions[i];
			regions[i] = [

					left, top,
					right, top,
					right, bottom,
					left, bottom

			]
		}
		
	},

	getRegionsByGidx(gIdx) {

		const arr = this.getGroupArrByGIdx(this.data.hotZoneItemArr2, gIdx);
		const bgRect = this.data.bgItem2.rect;
		
		console.log("arr:", arr);
		const newLocationArr = [];
		for (let i=0; i<arr.length; i++) {

			const hzItem = arr[i];
			const regionRect = hzItem.rect;

			const region = this.getRegionByRect(regionRect, bgRect);

			newLocationArr.push(region)
		}

		return newLocationArr;

	},

	getRegionByRect(regionRect, bgRect) {

		const left = Math.round( (regionRect.x ) / bgRect.width  * 1000 ) / 1000;
		const right =  Math.round( (regionRect.x + regionRect.width) / bgRect.width * 1000 ) / 1000;
		const top =  Math.round( (regionRect.y ) / bgRect.height * 1000 ) / 1000;
		const bottom =  Math.round( (regionRect.y + regionRect.height) / bgRect.height * 1000 ) / 1000;

		return {left, top, right, bottom};
	},



	changeWriteData(result) {
		const curTextArr = result.text;
		const bboxTextArr = [];
		for (let i=0; i<curTextArr.length; i++) {

			const score = curTextArr[i].score;

			const {left, right, top, bottom} = curTextArr[i];
			const text = curTextArr[i].content;

			console.log('text..', JSON.stringify( curTextArr[i] ));
			console.log('text..', text);
			const disW = (right - left) / text.length;
			const disH = (bottom - top);
			for (let j=0; j<text.length; j++) {

				const x1 = left + j * disW;
				const y1 = top;

				const x2 = x1 + disW;
				const y2 = y1;

				const x3 = x2;
				const y3 = y2 + disH;

				const x4 = x1;
				const y4 = y3;

				// const bbox = [{x1, y1}, {x2, y2}, {x3, y3}, {x4, y4}]
				const bbox = {left: x1, right: x2, top: y1, bottom: y3}


				// this.changeBboxPos(bbox);

				const content = text[j];
				bboxTextArr.push({bbox, content, score});
			}

		}

		result.text = bboxTextArr;

	},


	locate(x1, y1, x2, y2, x3, y3) {
			var a, b;
			a = (y2 - y1) / (x2 - x1);
			b = y1 - a * x1;

			var xMiddle = (x1 + x2) / 2;
			var yMiddle = (y1 + y2) / 2;
			var c, lastX, lastY;
			if (a != 0) {
					c = yMiddle - (-1 / a) * xMiddle;
					lastX = (Math.pow(x1, 2) + Math.pow(y1, 2) - Math.pow(x3, 2) - Math.pow(y3, 2) - 2 * c * y1 + 2 * c * y3) / (2 * ((x1 - x3) - (1 / a) * (y1 - y3)));
					lastY = (-1 / a) * lastX + c;
			} else {
					lastX = c = xMiddle;
					lastY = (Math.pow(x1, 2) + Math.pow(y1, 2) - Math.pow(x3, 2) - Math.pow(y3, 2) + 2 * lastX * (x3 - x1)) / (2 * (y1 - y3));
			}
			console.log("定位点X坐标: " + lastX);
			console.log("定位点Y坐标: " + lastY);

			return {x: lastX, y: lastY};
	},

	

	setOneAnswerDataCircle(colorRect, answerData) {
		const rect = colorRect.ccRect;
		const dotV2 = new cc.Vec2(rect.x + rect.width/2, rect.y + rect.height / 2);


		// const targetLabelText = colorRect.labelText;

		// const newRectCheckArr = this.newRectCheckArr;
		const checkArr = this.circleRectCheckArr;

		for (let i=0; i<checkArr.length; i++) {

			const checkRect = checkArr[i].ccRect;
			const key = checkArr[i].data.index + 1;

			// if (labelText.toLowerCase().indexOf(targetLabelText.toLowerCase()) != -1 && rect.intersects(dotRect)) {
			if (checkRect.contains(dotV2)) {

				answerData[key] = {isFinish: true};

			}

		}

	},


	setOneAnswerDataLink(firstPos, lastPos, answerData) {


		const w = this.debugLayer.width;
    const h = this.debugLayer.height;
    const checkP1 = cc.v2(firstPos.x * w, -firstPos.y * h);
    const checkP2 = cc.v2(lastPos.x * w, -lastPos.y * h);



		let firstPosRectId = -1;
		let lastPosRectId = -1;

		const worldPos1 = this.debugLayer.convertToWorldSpaceAR(cc.v2(checkP1.x, checkP1.y));
		const worldPos2 = this.debugLayer.convertToWorldSpaceAR(cc.v2(checkP2.x, checkP2.y));


		// console.log('worldPos1: ', JSON.stringify(worldPos1));
		// console.log('worldPos2: ', JSON.stringify(worldPos2));

		for (let i=0; i<this.linkRectGroup.length; i++) {
			const rect = this.linkRectGroup[i].ccRect;

			// console.log('rect: ', JSON.stringify(rect));


      if (rect.contains(worldPos1)) {
        firstPosRectId = i;
        // break;
			} 
      if (rect.contains(worldPos2)) {
        lastPosRectId = i;
        // break;
			} 
		}

		console.log('firstPosRectId: ', firstPosRectId);
		console.log('lastPosRectId: ', lastPosRectId);

		if (firstPosRectId != -1 && lastPosRectId != -1 && firstPosRectId != lastPosRectId) {

      answerData[firstPosRectId.toString()] = [firstPosRectId, lastPosRectId];
      this.addDebugLayerDot(checkP1.x, checkP1.y, 10, cc.Color.GREEN);
      this.addDebugLayerDot(checkP2.x, checkP2.y, 10, cc.Color.GREEN);
    }

	},

	addDebugLayerDot(x, y, r=10, color = null) {
    const dotNode = new cc.Node();

    const ctx = dotNode.addComponent(cc.Graphics);
    ctx.fillColor = color || cc.Color.BLUE;
    ctx.circle(x, y, r);
    ctx.fill();

    this.debugDrawLayer.addChild(dotNode);

    const w = this.debugLayer.width;
    const h = this.debugLayer.height;
    const rateX = x / w;
    const rateY = y / h;
    
    console.log('ratePos: {x: ' + rateX + ', y: ' + rateY + '}')
  },

	photoEndLineRect(data) {
		const textArr = data?.result?.text;
		if (!textArr) {
			return;
		}



		const answerData = {};

		for (let i=0; i<textArr.length; i++) {
			const oneTextData = textArr[i];
			const points = oneTextData.points;

			const point1_x = points[0];
			const point1_y = points[1];
			const point2_x = points[2];
			const point2_y = points[3];

			// const rect1 = {
			// 	x:point1_x,
			// 	y: -point1_y,
			// 	width: 0.01,
			// 	height: 0.01
			// }

			// const colorRect1 = this.getColorDot(rect1.x, rect1.y, rect1.width, rect1.height, "purple");
			// this.debugDrawLayer.addChild(colorRect1, 1);
		

			// const rect2 = {
			// 	x:point2_x,
			// 	y: -point2_y,
			// 	width: 0.01,
			// 	height: 0.01
			// }

			// const colorRect2 = this.getColorDot(rect2.x, rect2.y, rect1.width, rect1.height, "purple");
			// this.debugDrawLayer.addChild(colorRect2, 1);

			this.drawUserLine([{x:point1_x, y: point1_y}, {x: point2_x, y: point2_y}]);

			this.setOneAnswerDataLink({x:point1_x, y: point1_y}, {x: point2_x, y: point2_y}, answerData);
		}


		this.showLinkAnswer(answerData);
	},

	drawUserLine(path) {
		this.drawOnePath(path);
	},

	drawOnePath(path) {
    const lineNode = new cc.Node();
    this.debugDrawLayer.addChild(lineNode);

    const w = this.debugLayer.width;
    const h = this.debugLayer.height;



    const subY = 0; //-canvas.height / 2;
    const ctx = lineNode.addComponent(cc.Graphics);
    ctx.lineWidth = 10;
    ctx.strokeColor = cc.Color.RED;
    ctx.fillColor = cc.Color.BLACK;
    

    ctx.moveTo(path[0].x * w, -path[0].y * h + subY);

    for (let i = 1; i < path.length; i++) {
      const x = path[i].x * w;
      const y = -path[i].y * h + subY;

      ctx.lineTo(x, y);
    }
    ctx.stroke();
  },

	showLinkAnswer(answerData) {

    for (let key in answerData) {

      const tempArr = answerData[key];

      const firstItemIndex = tempArr[0];
      const lastItemIndex = tempArr[1];

			const debugFirstItem = this.linkRectGroup[firstItemIndex];
			const debugLastItem = this.linkRectGroup[lastItemIndex];

			console.log('linkdebugId: ', debugFirstItem.linkData.linkDebugItemId);
			console.log('debugLastItem.linkData.debugItemId: ', debugLastItem.linkData.debugItemId)
			console.log('debugFirstItem.isRightPoint: ', debugFirstItem.isRightPoint)

			const hzItemIdFirst = debugFirstItem.linkData.hzItemId
			const hzItemIdLast = debugLastItem.linkData.hzItemId
			const startItem = this.getItemById(hzItemIdFirst);
			const endItem = this.getItemById(hzItemIdLast);
			if (startItem.isShowEnd || endItem.isShowEnd) {
				return;
			}

			if ((startItem.isRightPoint && endItem.isRightPoint) && debugFirstItem.linkData.linkDebugItemId == debugLastItem.linkData.debugItemId) {
				
				const {hzItemId, linkHzItemId} = debugFirstItem.linkData
				this.showSuccess(hzItemId, linkHzItemId);

			} else {			

			}

    }


		// for (let key in answerData) {

    //   const tempArr = answerData[key];

    //   const firstItemIndex = tempArr[0];
    //   const lastItemIndex = tempArr[1];

		// 	const debugFirstItem = this.linkRectGroup[firstItemIndex];
		// 	const debugLastItem = this.linkRectGroup[lastItemIndex];

		// 	console.log('linkdebugId: ', debugFirstItem.linkData.linkDebugItemId);
		// 	console.log('debugLastItem.linkData.debugItemId: ', debugLastItem.linkData.debugItemId)
		// 	console.log('debugFirstItem.isRightPoint: ', debugFirstItem.isRightPoint)

		// 	const hzItemIdFirst = debugFirstItem.linkData.hzItemId
		// 	const hzItemIdLast = debugLastItem.linkData.hzItemId
		// 	const startItem = this.getItemById(hzItemIdFirst);
		// 	const endItem = this.getItemById(hzItemIdLast);
		// 	if (startItem.isShowEnd || endItem.isShowEnd) {
		// 		return;
		// 	}

		// 	if (debugFirstItem.isRightPoint && debugFirstItem.linkData.linkDebugItemId == debugLastItem.linkData.debugItemId) {
				
		// 		// const {hzItemId, linkHzItemId} = debugFirstItem.linkData
		// 		// this.showSuccess(hzItemId, linkHzItemId);

		// 	} else {			

				
		// 		this.showFail(hzItemIdFirst, hzItemIdLast);
		// 		this.playCatAudio(this.data.error_link_audio_url);

		// 	}

    // }


  },

	showSuccess(startItemId, endItemId) {

		console.log( ' in showSuccess');

		const startItem = this.getItemById(startItemId);
		const endItem = this.getItemById(endItemId);

		if (startItem.isShowEnd || endItem.isShowEnd) {
			return;
		}
		startItem.isShowEnd = true;
		endItem.isShowEnd = true;

		const isLinked = this.checkIsLinked(startItem, endItem);
		if (isLinked) {
			return;
		}

		this.addLinkItem(startItem, endItem);
		this.addLinkItem(endItem, startItem);




		const pos1 = startItem.getPosition();
		pos1.x += startItem.width / 2;
		pos1.y += startItem.height / 2;
		const pos2 = endItem.getPosition();
		pos2.x += endItem.width / 2;
		pos2.y += endItem.height / 2;

		const greenColor = new cc.Color();
		greenColor.fromHEX("#519F00"); 
		const line = this.getLine(pos1, pos2, greenColor);
		this.addLinkLine(startItem, endItem, line);
		line.isRight = true;

		const maskNode = new cc.Node();
		maskNode.width = 0;
		maskNode.height = 0;
		maskNode.x = pos1.x;
		maskNode.y = pos1.y;
		this.hotZoneBg.addChild(maskNode);


		const mask = maskNode.addComponent(cc.Mask);
		mask.type = cc.Mask.Type.ELLIPSE;
		mask.segments = 32;

		maskNode.addChild(line);
		// line.mask = mask;

		this.isCurLinked = true;

		cc.tween(maskNode)
			.to(1.5, {width: this.canvas.width * 2, height: this.canvas.height * 2}, {easing: 'sineOut'})
			.call(() => {
				maskNode.removeComponent(cc.Mask);
			})
			.start();
		
		playAudio(this.rightClip, () => {
			
		})
		
		if (!this.isGameEnd) {
			const arr = this.rectNodeArr.filter((r) => {
				return r.isRightPoint == true;
			})
			this.checkGameEnd(arr);
		}
	},

	addLinkLine(item1, item2, line) {
		if ( !item1.lineArr ) {
			item1.lineArr = [];
		}

		if (!item2.lineArr) {
			item2.lineArr = [];
		}
		
		item1.lineArr.push(line);
		item2.lineArr.push(line);
		line.itemArr = [item1, item2];
		this.totalLineArr.push(line);
	},

	checkIsLinked(startItem, endItem) {
		const linkItemArr1 = startItem.linkItemArr || [];
		const linkItemArr2 = endItem.linkItemArr || [];

		return (linkItemArr1.indexOf(endItem) != -1 && linkItemArr2.indexOf(startItem) != -1);
	},

	addLinkItem(item, linkItem) {
		if (!item.linkItemArr) {
			item.linkItemArr = [];
		}

		if (item.linkItemArr.indexOf(linkItem) == -1) {
			item.linkItemArr.push(linkItem);
		}
	},

	getLine(item1, item2, color=cc.Color.BLACK) {
		const lineNode = new cc.Node();


		const ctx = lineNode.addComponent(cc.Graphics);
		ctx.lineWidth = 5;
    ctx.strokeColor = color;
    ctx.fillColor = color;

    ctx.moveTo(0, 0);
		ctx.lineTo(item2.x - item1.x, item2.y - item1.y);
		ctx.stroke();

		const dot1 = this.getDot(0, 0, ctx.lineWidth/2, ctx.strokeColor);
		dot1.parent = lineNode;

		const dot2 = this.getDot(item2.x - item1.x, item2.y - item1.y, ctx.lineWidth/2, ctx.strokeColor);
		dot2.parent = lineNode;

		return lineNode;
	},

	getDot(x, y, r, color) {

		const dotNode = new cc.Node();

    const ctx = dotNode.addComponent(cc.Graphics);
    ctx.fillColor = color || cc.Color.BLUE;
    ctx.circle(x, y, r);
    ctx.fill();

		return dotNode;
	},


	getItemById(id) {

		console.log('getItemById id:', id);
		console.log('this.rectNodeArr: ', this.rectNodeArr);

		const targetItem = this.rectNodeArr.find( node => {

			const data = node.data;

			console.log('data~~: ', JSON.stringify(data));


			if (data && (data.index + 1 == id)) {
				return true;
			}
		})
		return targetItem;
	},

	photoEndSignRect(data) {

		const textArr = data?.result?.text;
		if (!textArr) {
			return;
		}

		const symbol = textArr[0]?.symbol
		if (!symbol) {
			return;
		}

		// return 
		const answerData = {};


		for (let i=0; i<this.signRectCheckArr.length; i++) {
			
			const signDebugItem = this.signRectCheckArr[i];
			const dropDownItem = signDebugItem.data.dropDownItem;

			const curSignKey = symbol[i].toString();
			
			if (dropDownItem.key == curSignKey) {


				const label = this.getLabel(dropDownItem.label, signDebugItem.ccRect.width);
				label.x = signDebugItem.x;
				label.y = signDebugItem.y;
				label.color = cc.Color.BLACK;
	
				this.debugDrawLayer.addChild(label, 2);


				const key = signDebugItem.data.index + 1;
				answerData[key] = {isFinish: true};

			}
		}

		this.showSignAnswer(answerData);

		return ;

		for (let i=0; i<textArr.length; i++) {
			const oneTextData = textArr[i];

			const signId = '2'

			// const points = oneTextData.points;

			// const tempDisNum = Math.floor(points.length / 2);
			// const point1_x = points[0];
			// const point1_y = points[1];
			// const point2_x = points[tempDisNum];
			// const point2_y = points[tempDisNum + 1];

			// let centerPX = Number(point1_x) + (point2_x - point1_x) / 2;
			// let centerPY = Number(point1_y) + (point2_y - point1_y) / 2;

			// console.log('centerPX: ' ,centerPX);
			// console.log('centerPY: ' ,centerPY);

			// const colorRect = this.getColorDot(centerPX, -centerPY, 0.02, 0.02, "purple");
			// this.debugDrawLayer.addChild(colorRect, 1);


			// this.setOneAnswerDataCircle(colorRect, answerData);

		}

		console.log('answerData: ' , answerData);


		// this.showCircleAnswer(answerData);

	},

	showSignAnswer(answerData) {

		console.log('answerData: ', answerData);
		if (Object.keys(answerData).length == 0) {
			return;
		}

		console.log("signAnimaNodeArr: ", this.signAnimaNodeArr);

		for (let i = 0; i < this.signAnimaNodeArr.length; i++) {

			const animaNode = this.signAnimaNodeArr[i];

			const key = animaNode.data.signItem // i.toString();


			console.log('~animaNode.data: ', animaNode.data)
			console.log('~key: ', key)

			if (!animaNode.hitCount) {
				animaNode.hitCount = 0;
			}

			if (answerData[key] && answerData[key].isFinish) {
				console.log('~showSign')
				this.showSign(animaNode);

			} else {

				animaNode.hitCount = 0;
			}
		}

	},

	showSign(node, isRight = true) {

		console.log('in showCircle 1');


		node.hitCount++;
		if (node.hitCount < 1) {
			return;
		}


		console.log('in showCircle 2');


		if (node.isShowEnd) {
			return;
		}

		console.log('in showCircle 3');

		node.isShowEnd = true;
		node.isRight = isRight;


		// node.playRightAnim();
		this.playRightAnim(node);

		if (!this.isGameEnd) {
			this.checkGameEnd(this.signAnimaNodeArr);
		}

		return;

	},

	photoEndCircleRect(data) {
		const textArr = data?.result?.text;
		if (!textArr) {
			return;
		}

		const answerData = {};

		for (let i=0; i<textArr.length; i++) {
			const oneTextData = textArr[i];
			const points = oneTextData.points;

			const tempDisNum = Math.floor(points.length / 2);
			const point1_x = points[0];
			const point1_y = points[1];
			const point2_x = points[tempDisNum];
			const point2_y = points[tempDisNum + 1];
			// const point3_x = points[tempDisNum*2];
			// const point3_y = points[tempDisNum*2 + 1];

			// let centerP = this.locate(point1_x, point1_y, point2_x, point2_y, point3_x, point3_y);
			let centerPX = Number(point1_x) + (point2_x - point1_x) / 2;
			let centerPY = Number(point1_y) + (point2_y - point1_y) / 2;

			console.log('centerPX: ' ,centerPX);
			console.log('centerPY: ' ,centerPY);


			const colorRect = this.getColorDot(centerPX, -centerPY, 0.02, 0.02, "purple");
			this.debugDrawLayer.addChild(colorRect, 1);


			this.setOneAnswerDataCircle(colorRect, answerData);


			// console.log('points: ', points);
		
			// for (let j=0; j<points.length; j+=2) {
			// 	const x = points[j]//centerP.x
			// 	const y = -points[j+1]//-centerP.y
			// 	const w = 0.01;
			// 	const h = 0.01;
	
			// 	const rect = {
			// 		x, y,
			// 		width: w,
			// 		height: h
			// 	}
	

	
			// 	const colorRect = this.getColorDot(rect.x, rect.y, w, h, "red");
			// 	this.debugDrawLayer.addChild(colorRect, 1);


			// 	// this.setCirclePosInRectArr(colorRect);
				
	
			// }
		


		}

		console.log('answerData: ' , answerData);


		this.showCircleAnswer(answerData);

		// this.showUserRightNew(answerData);
	},

	showCircleAnswer(answerData) {

		if (Object.keys(answerData).length == 0) {
			return;
		}


		for (let i = 0; i < this.circleAnimaNodeArr.length; i++) {

			const animaNode = this.circleAnimaNodeArr[i];

			const key = animaNode.data.circleItem // i.toString();

			console.log('~animaNode.data: ', animaNode.data)
			console.log('~key: ', key)

			console.log('~key: ', key)

			if (!animaNode.hitCount) {
				animaNode.hitCount = 0;
			}

			if (answerData[key] && answerData[key].isFinish) {
				console.log('~showLetter')
				this.showCircle(animaNode);
				// this.showLetter(animaNode);
			} else {

				animaNode.hitCount = 0;
			}
		}

	},

	showCircle(node, isRight = true) {

		console.log('in showCircle 1');


		node.hitCount++;
		if (node.hitCount < 1) {
			return;
		}


		console.log('in showCircle 2');


		if (node.isShowEnd) {
			return;
		}

		console.log('in showCircle 3');

		node.isShowEnd = true;
		node.isRight = isRight;


		// node.playRightAnim();
		this.playRightAnim(node);

		if (!this.isGameEnd) {
			this.checkGameEnd(this.circleAnimaNodeArr);
		}

		return;

	},
	

	photoEndFingerRect(data) {
		
		console.log('in photoEndFingerRect, data:', data);

		const answerData = {};


		const {x, y} = data;

		const colorDot = this.getColorDot(x, -y, 0.05, 0.05);
		this.debugDrawLayer.addChild(colorDot, 1);


		this.setOneAnswerDataFinger(colorDot, answerData);

		console.log('answerData:' , answerData);
		this.showFingerAnswer(answerData);


	},

	nextFingerQues() {

		if (this.fingerQuesArr.length > 0) {
			this.curFingerQues = this.fingerQuesArr.pop();

			this.checkShowFingerQues();
		}

	},

	setOneAnswerDataFinger(colorDot, answerData) {
		const rect = colorDot.dotRect;
		const dotV2 = new cc.Vec2(rect.x + rect.width/2, rect.y + rect.height / 2);

		const checkArr = this.fingerRectCheckArr;

		for (let i=0; i<checkArr.length; i++) {

			const checkRect = checkArr[i].ccRect;
			const key = checkArr[i].data.index + 1;

			if (checkRect.contains(dotV2)) {
				answerData[key] = {isFinish: true};
			}

		}

	},

	showFingerAnswer(answerData) {

		console.log(' in showFingerAnswer 1')
		if (Object.keys(answerData).length == 0) {
			return;
		}

		for (let i = 0; i < this.fingerAnimaNodeArr.length; i++) {

			const animaNode = this.fingerAnimaNodeArr[i];

			const key = animaNode.data.fingerItem // i.toString();

			console.log('~animaNode.data: ', animaNode.data)
			console.log('~key: ', key)

			if (animaNode.data.id != this.curFingerQues.id) {
				continue;
			}


			if (!animaNode.hitCount) {
				animaNode.hitCount = 0;
			}

			if (answerData[key] && answerData[key].isFinish) {
				console.log('~showFinger')
				this.showFinger(animaNode);
				

			


				// this.showLetter(animaNode);
			} else {

				animaNode.hitCount = 0;
			}
		}


	},

	showFinger(node, isRight = true) {

		console.log('in showFinger 1');

		node.hitCount++;
		if (node.hitCount < 1) {
			return;
		}


		console.log('in showFinger 2');

		if (node.isShowEnd) {
			return;
		}

		console.log('in showFinger 3');

		node.isShowEnd = true;
		node.isRight = isRight;

		delayCall(1.5, () => {
			this.nextFingerQues();
		})

		// node.playRightAnim();
		this.playRightAnim(node);

		if (!this.isGameEnd) {
			this.checkGameEnd(this.fingerAnimaNodeArr);
		}

		return;

	},


	photoEndNewRect(data) {

		const textArr = data?.result?.text;
		if (!textArr) {
			return;
		}

		const answerData = {};

		for (let i=0; i<textArr.length; i++) {
			const oneTextData = textArr[i];
			const x = oneTextData.left//oneTextData.left + (oneTextData.right - oneTextData.left) / 2;
			const y = -oneTextData.bottom//-oneTextData.top - (oneTextData.bottom - oneTextData.top) / 2;
			const w = oneTextData.right - oneTextData.left;
			const h = oneTextData.bottom - oneTextData.top;

			const rect = {
				x, y,
				width: w,
				height: h
			}

			console.log('oneTextData: ', oneTextData);

			const content = oneTextData.content;
			const colorRect = this.getColorRect(rect, "red");
			colorRect.labelText = content;
			this.debugDrawLayer.addChild(colorRect, 1);

			const label = this.getLabel(content, colorRect.scaleX *  colorRect.width);
			label.x = colorRect.x + colorRect.width / 2 * colorRect.scaleX;
			label.y = colorRect.y + colorRect.height / 2 * colorRect.scaleY;
			label.color = cc.Color.BLACK;

			this.debugDrawLayer.addChild(label, 2);

			this.setOneAnswerDataNew(colorRect, answerData);

		}

		console.log('answerData:' , answerData);
		this.showUserRightNew(answerData);
	},

	
	

	showUserRightNew(answerData) {

		if (Object.keys(answerData).length == 0) {
			return;
		}






		for (let i = 0; i < this.wordBgArr.length; i++) {

			const animaNode = this.wordBgArr[i].wordNode;

			const key = (i+1).toString();

			console.log('~animaNode.data: ', animaNode.data)
			console.log('~key: ', key)

			if (!animaNode.hitCount) {
				animaNode.hitCount = 0;
			}

			if (answerData[key] && answerData[key].isFinish) {
				console.log('~showLetter')
				
				this.showLetterLabel(animaNode);
				this.showAnswerIcon(this.wordBgArr[i], true)

			} else {

				animaNode.hitCount = 0;
			}
		}
	},

	photoEnd(data) {

		if (this.isGameEnd) {
			return;
		}

		if (!this.isCanCheck) {
			return;
		}
		
		console.log(' this.photo end ', data);

		loopLog(data);

		// console.log('photoEnd data: ', JSON.stringify(data));

		this.debugLayer.removeAllChildren();

		const answerData = this.getAnswerData(data);

		this.showUserRight(answerData);

		return;

		// this.debugDrawLayer.removeAllChildren();

		// if (this.curCheckGroup == this.CHECK_TYPE_FINGER) {

		// 	if (this.isStopFingerCheck) {
		// 		return;
		// 	}

		// 	this.photoEndFingerRect(data);
		// 	return;
		// }


		// // if (this.newRectArr && this.newRectArr.length > 0) {
		// if (this.curCheckGroup == this.CHECK_TYPE_WRITE) {
		// 	this.photoEndNewRect(data);
		// 	return;
		// }


		// // if (this.circleRectArr && this.circleRectArr.length > 0) {
		// if (this.curCheckGroup == this.CHECK_TYPE_CIRCLE) {
		// 	this.photoEndCircleRect(data);
		// 	return;
		// }

		// // if (this.lineRectArr && this.lineRectArr.length > 0) {
		// if (this.curCheckGroup == this.CHECK_TYPE_LINE) {
		// 	this.photoEndLineRect(data);
		// 	return;
		// }

		// // if (this.signRectArr && this.signRectArr.length > 0) {
		// if (this.curCheckGroup == this.CHECK_TYPE_SIGN) {
		// 	this.photoEndSignRect(data);
		// 	return;
		// }

		


		// // this.changeBboxPos(data);

		// const isRightArea = this.checkIsRightArea(data);
		// if (!isRightArea) {
		// 	console.log('没有检测到区域')
		// 	return;
		// }



		// if (this.isCanDraw) {
		// 	return;
		// }
		// this.isCanDraw = true;


		// delayCall(0.01, () => {
		// 	this.isCanDraw = false;
		// })




		// const answerData = this.getAnswerData(data);

		// this.showUserRight(answerData, data);

		return;


		const answerWrongData = this.getAnswerWrongData(data);
		let isShowWrong = false;
		if (this.oldAnswerWrongData) {
		
			for (let key in answerWrongData) {
				const wrongData = answerWrongData[key];
				const oldWrongData = this.oldAnswerWrongData[key];
				if (oldWrongData && oldWrongData.sentence == wrongData.sentence) {
					wrongData.count += oldWrongData.count;

					if (wrongData.count >= 3) {
						isShowWrong = true;
					}
				}
			}
		}

		if (isShowWrong) {
			this.showUserWrong(answerWrongData);
		}

		this.oldAnswerWrongData = answerWrongData;


		console.log('answerWrongData: ', JSON.stringify( answerWrongData) );
	},







	checkIsRightArea(data) {

		const text = data?.result?.text
		if (!text) {
			return false;
		}

		const benchmark1Text = this.benchmark1Data.labelText
		const benchmark1TextArr = benchmark1Text.split(' ');
		console.log('benchmark1TextArr: ', benchmark1TextArr);
		// const letter = this.data.letter || 'Aa';

		const benchmark1LabelData = this.getPhotoLabelData(benchmark1TextArr, text, false);
		if (!benchmark1LabelData) {
			console.log('!benchmark1LabelData')
			return false;
		}
		this.benchmark1LabelData = benchmark1LabelData;
		console.log('benchmark1LabelData: ', benchmark1LabelData);

		

		if ( this.firstItemData ) {

			const firstText = this.firstItemData.labelText
			const firstTextArr = firstText.split(' ');

			const firstItemLabelData = this.getTopLeftLetter2(firstText, text, this.benchmark1LabelData);

			if (!firstItemLabelData) {
				return false;
			}
			this.firstItemLabelData = firstItemLabelData;

			console.log('firstItemLabelData: ', firstItemLabelData);
			return true

		} else if (this.benchmark2Data) {
		
			const benchmark2Text = this.benchmark2Data.labelText
			const benchmark2TextArr = benchmark2Text.split(' ');
			const benchmark2LabelData = this.getPhotoLabelData(benchmark2TextArr, text, false);
			if (!benchmark2LabelData) {
				return false;
			}
			this.benchmark2LabelData = benchmark2LabelData;
			return true;
		}



		return false;

	


		// const block = data?.block
		// if (!block) {
		// 	return false;
		// }

		// const topText = this.topItemData.labelText
		// const topTextArr = topText.split(' ');
		// console.log('topTextArr: ', topTextArr);
		// // const letter = this.data.letter || 'Aa';

		// const topLabelData = this.getPhotoLabelData(topTextArr, block);
		// if (!topLabelData) {
		// 	console.log('!topLabelData')
		// 	return false;
		// }
		// this.topLabelData = topLabelData;
		// console.log('topLabelData: ', topLabelData);

		

		// if (this.bottomItemData) {
			
		// 	const bottomText = this.bottomItemData.labelText
		// 	const bottomTextArr = bottomText.split(' ');
		// 	const bottomLabelData = this.getPhotoLabelData(bottomTextArr, block);
		// 	if (!bottomLabelData) {
		// 		return false;
		// 	}
		// 	this.bottomLabelData = bottomLabelData;
		// 	return true

		// } else if (this.firstItemData) {

		// 	const firstText = this.firstItemData.labelText
		// 	const firstTextArr = firstText.split(' ');
		// 	const topLeftLetter = this.getPhotoLabelData(firstTextArr, block);


		// 	// const topLeftLetter = this.getTopLeftLetter(this.firstItemData.labelText, block, topLabelData);
		// 	if (!topLeftLetter) {
		// 		return false;
		// 	}
		// 	this.topLeftLetter = topLeftLetter;

		// 	console.log('topLeftLetter: ', topLeftLetter);
		// 	return true;
		// }



		// return false;

	
	},

	changeBboxPos(data) {

		const text = data?.result?.text;
		if (!text) {
			return;
		}


		for (let i=0; i<text.length; i++) {

			let {left, top, right, bottom} = text[i];

			const q_left = this.ques_region[0];
			const q_top = this.ques_region[1];
			const q_right = this.ques_region[2];
			const q_bottom = this.ques_region[7];

			const rect = {x: q_left, y: q_top, width: q_right - q_left, height: q_bottom - q_top};

			text[i].left = q_left + left * rect.width;
			text[i].top = q_top + top * rect.height;
			text[i].right = q_left + right * rect.width;
			text[i].bottom = q_top + bottom * rect.height;

		}

		// console.log('bbox: ', bbox);
		// const x1 = bbox[0].x1;
		// const y1 = bbox[0].y1;
		// const x2 = bbox[1].x2;
		// const y2 = bbox[1].y2;
		// const x3 = bbox[2].x3;
		// const y3 = bbox[2].y3;
		// const x4 = bbox[3].x4;
		// const y4 = bbox[3].y4;

		// const left = this.ques_region[0];
		// const top = this.ques_region[1];
		// const right = this.ques_region[2];
		// const bottom = this.ques_region[7];

		// const rect = {x: left, y:top, width: right - left, height: bottom - top};

		// const y1_new = top + y1 * rect.height;
		// const y2_new = y1_new;
		// const y3_new = top + y3 * rect.height;
		// const y4_new = y3_new;

		// const x1_new = left + x1 * rect.width;
		// const x2_new = left + x2 * rect.width;
		// const x3_new = x2_new;
		// const x4_new = x1_new;

		// bbox[0].x1 = x1_new;
		// bbox[0].y1 = y1_new;
		// bbox[1].x2 = x2_new;
		// bbox[1].y2 = y2_new;
		// bbox[2].x3 = x3_new;
		// bbox[2].y3 = y3_new;
		// bbox[3].x4 = x4_new;
		// bbox[3].y4 = y4_new;

		// console.log('~~rect: ', rect);

	
	},



	getTopLeftLetter2(text, block, topLabelData) {

		const benchmark1Rect = this.benchmark1Data.rect;

		const rect = {
			x: topLabelData.left, 
			y: -topLabelData.bottom, 
			width: Math.abs( topLabelData.right - topLabelData.left ), 
			height: Math.abs( topLabelData.bottom - topLabelData.top ), 
		}                        
		const colorRect = this.getColorRect(rect, "green");
		this.debugDrawLayer.addChild(colorRect);
		


		const tempUnitW = benchmark1Rect.x + benchmark1Rect.width;
		const tempUnitH = benchmark1Rect.y + benchmark1Rect.height;
		const tempBaseX = benchmark1Rect.x + benchmark1Rect.width / 2;
		const tempBaseY = benchmark1Rect.y + benchmark1Rect.height / 2;


		const firstItemData = this.firstItemData;		
		const firstItemRect = this.firstItemData.rect;

	
		const firstItemX = firstItemRect.x + firstItemRect.width / 2;
		const firstItemY = firstItemRect.y + firstItemRect.height / 2;

		const unitX = (firstItemX - tempBaseX) / tempUnitW;
		const unitY = (firstItemY - tempBaseY) / tempUnitH;
		const unitW2 = firstItemRect.width / tempUnitW;
		const unitH2 = firstItemRect.height / tempUnitH;



		console.log('tempUnitW: ', tempUnitW);
		console.log('tempUnitH: ', tempUnitH);
		console.log('tempBaseX: ', tempBaseX);
		console.log('tempBaseY: ', tempBaseY);

		console.log('firstItemY: ', firstItemY);
		console.log('tempBaseY: ', tempBaseY);
		console.log('tempUnitH: ', tempUnitH);

		firstItemData.unitX = unitX;
		firstItemData.unitY = unitY;
		firstItemData.unitW = unitW2;
		firstItemData.unitH = unitH2;



		const topLocationLeft = topLabelData.left;
		const topLocationTop = topLabelData.top;
		const topLocationRight = topLabelData.right;
		const topLocationBottom = topLabelData.bottom;

		const baseX = topLocationLeft + (topLocationRight - topLocationLeft) / 2;
		const baseY =	topLocationTop + (topLocationBottom - topLocationTop) / 2;
		const unitW = topLocationRight;
		const unitH = topLocationTop + (topLocationBottom - topLocationTop);
		

		const checkLetter = firstItemData;

		console.log('baseY: ', baseY);
		console.log('checkLetter.unitY: ', checkLetter.unitY);
		console.log('unitH: ', unitH);


		let x = baseX + checkLetter.unitX * unitW;
		const y = baseY + checkLetter.unitY * unitH;
		const w = checkLetter.unitW * unitW;
		const h = checkLetter.unitH * unitH;
		const r = Math.min(w, h) / 2;


		console.log(' baseX:  ', baseX);
		console.log(' checkLetter.unitX:  ', checkLetter.unitX);
		console.log(' unitW:  ', unitW);
		console.log(' x:  ', x);
		console.log(' y:  ', y);
		console.log(' r:  ', r);
		console.log(' checkLetter:  ', checkLetter);

		const dot = this.getColorDot(x, -y, r, r, 'blue');
		this.debugDrawLayer.addChild(dot, 5);

		dot.labelText = checkLetter.labelText;


		const wordDataArr =  this.getPhotoWordArr(text, block, topLabelData);
		let topLeftLetterData;


		const {dotRect, labelText} = dot
		


		for (let i=0; i<wordDataArr.length; i++) {

			// const tempWordArr = wordDataArr[i].word;
			const tempWordArr = this.getTempWordArr(wordDataArr[i],['']);



			for (let k=0; k<tempWordArr.length; k++) {
					
				const {location , content} = tempWordArr[k];

				const rect = {
					x: location.left, 
					y: -location.bottom, 
					width: Math.abs( location.right - location.left ), 
					height: Math.abs( location.bottom - location.top ), 
				}                        
				const colorRect = this.getColorRect(rect, "purple");
				colorRect.labelText = content;
				this.debugDrawLayer.addChild(colorRect);

				// console.log('colorRect: ', colorRect);

				const label = this.getLabel(content);
				label.x = colorRect.x + colorRect.width / 2 * colorRect.scaleX;
				label.y = colorRect.y - colorRect.height / 2 //* colorRect.scaleY;
				label.color = cc.Color.GREEN;
				this.debugDrawLayer.addChild(label);




				///------

				const checkRect = colorRect.ccRect;
				const targetLabelText = colorRect.labelText;

				const {dotRect, labelText, key} = dot;

				if (labelText.toLowerCase().indexOf(targetLabelText.toLowerCase()) != -1 && checkRect.intersects(dotRect)) {
					return tempWordArr[k];
				}

				///------
				

			}





			// const lineRect = this.getLineRect( wordDataArr[i] );
			// const isInLineRect = lineRect.intersects(dotRect)
			// if (!isInLineRect) {
			// 	continue;
			// }

			// for (let k=0; k<tempWordArr.length; k++) {
			// 	const {location , content} = tempWordArr[k];

			// 	const tempRect = {
			// 		x: location.left, 
			// 		y: -location.bottom, 
			// 		width: Math.abs( location.right - location.left ), 
			// 		height: Math.abs( location.bottom - location.top ), 
			// 	}
			// 	const colorRect = this.getColorRect(tempRect);
			// 	colorRect.labelText = content;
			// 	// this.debugDrawLayer.addChild(colorRect);

			// 	const label = this.getLabel(content);
			// 	label.x = colorRect.x + colorRect.width / 2 * colorRect.scaleX;
			// 	label.y = colorRect.y - colorRect.height / 2 //* colorRect.scaleY;
			// 	label.color = cc.Color.GREEN;
			// 	// this.debugDrawLayer.addChild(label);
				


						
			// 	const rect = colorRect.ccRect;
			// 	const targetLabelText = colorRect.labelText;



			

			// 	// console.log('targetLabelText.toLowerCase() : ', targetLabelText.toLowerCase() );
			// 	// console.log('labelText.toLowerCase()  : ', labelText.toLowerCase()  );


			// 	const isInLineText = this.checkWordIsInLine(wordDataArr[i], labelText);

			// 	if (isInLineText) {
			// 	// if (targetLabelText.toLowerCase().indexOf(labelText.toLowerCase()) != -1  && rect.intersects(dotRect)) {
			// 		topLeftLetterData = wordDataArr[i];
			// 		// answerData[i.toString()] = colorRect;
			// 		// return;
			// 	}

			// }
			
		}

			
		return null;


	},


	getTopLeftLetter(text, block, topLabelData) {

		// const topItemRect = this.topItemData.rect;

		// const tempUnitW = topItemRect.width;
		// const tempUnitH = topItemRect.height;
		// const tempBaseX = topItemRect.x;
		// const tempBaseY = topItemRect.y + topItemRect.height / 2;


		// const firstItemData = this.firstItemData;
		// console.log('firstItemData: ', firstItemData);
		
		// const firstItemRect = this.firstItemData.rect;


	
		// const firstItemX = firstItemRect.x + firstItemRect.width / 2;
		// const firstItemY = firstItemRect.y + firstItemRect.height / 2;

		// const unitX = (firstItemX - tempBaseX) / tempUnitW;
		// const unitY = (firstItemY - tempBaseY) / tempUnitH;
		// const unitW2 = firstItemRect.width / tempUnitW;
		// const unitH2 = firstItemRect.height / tempUnitH;


		// console.log('firstItemY: ', firstItemY);
		// console.log('tempBaseY: ', tempBaseY);
		// console.log('tempUnitH: ', tempUnitH);

		// firstItemData.unitX = unitX;
		// firstItemData.unitY = unitY;
		// firstItemData.unitW = unitW2;
		// firstItemData.unitH = unitH2;



		// // const topLabelData = this.topLabelData;

		// const firstTopWordLocation = topLabelData.word[0].location;
		// const lastTopWordLocation = topLabelData.word[topLabelData.word.length - 1].location
		// const topLocationLeft = firstTopWordLocation.left;
		// const topLocationTop = firstTopWordLocation.top;
		// const topLocationRight = lastTopWordLocation.right;
		// const topLocationBottom = lastTopWordLocation.bottom;

		// const baseX = topLocationLeft;
		// const baseY =	topLocationTop + (topLocationBottom - topLocationTop) / 2;
		// const unitW = topLocationRight - topLocationLeft;
		// const unitH = topLocationBottom - topLocationTop;
		

		// const checkLetter = firstItemData;

		// console.log('baseY: ', baseY);
		// console.log('checkLetter.unitY: ', checkLetter.unitY);
		// console.log('unitH: ', unitH);


		// let x = baseX + checkLetter.unitX * unitW;
		// const y = baseY + checkLetter.unitY * unitH;
		// const w = checkLetter.unitW * unitW;
		// const h = checkLetter.unitH * unitH;
		// const r = Math.min(w, h) / 2;

		// 	// const centerX = baseX + this.centerUnitW * unitW;
		// 	// x += (centerX - x) * 0.005  * (y * 0.05);

		// console.log(' x:  ', x);
		// console.log(' y:  ', y);
		// console.log(' r:  ', r);

		// const dot = this.getColorDot(x, -y, r, r, 'purple');
		// this.debugDrawLayer.addChild(dot, 5);

		// dot.labelText = checkLetter.labelText;


		// const wordDataArr =  this.getPhotoWordArr(text, block, topLabelData);
		// let topLeftLetterData;


		// const {dotRect, labelText} = dot
		


		// for (let i=0; i<wordDataArr.length; i++) {

		// 	const tempWordArr = wordDataArr[i].word;

		// 	const lineRect = this.getLineRect( wordDataArr[i] );
		// 	const isInLineRect = lineRect.intersects(dotRect)
		// 	if (!isInLineRect) {
		// 		continue;
		// 	}

		// 	for (let k=0; k<tempWordArr.length; k++) {
		// 		const {location , content} = tempWordArr[k];

		// 		const tempRect = {
		// 			x: location.left, 
		// 			y: -location.bottom, 
		// 			width: Math.abs( location.right - location.left ), 
		// 			height: Math.abs( location.bottom - location.top ), 
		// 		}
		// 		const colorRect = this.getColorRect(tempRect);
		// 		colorRect.labelText = content;
		// 		// this.debugDrawLayer.addChild(colorRect);

		// 		const label = this.getLabel(content);
		// 		label.x = colorRect.x + colorRect.width / 2 * colorRect.scaleX;
		// 		label.y = colorRect.y - colorRect.height / 2 //* colorRect.scaleY;
		// 		label.color = cc.Color.GREEN;
		// 		// this.debugDrawLayer.addChild(label);
				


						
		// 		const rect = colorRect.ccRect;
		// 		const targetLabelText = colorRect.labelText;



			

		// 		// console.log('targetLabelText.toLowerCase() : ', targetLabelText.toLowerCase() );
		// 		// console.log('labelText.toLowerCase()  : ', labelText.toLowerCase()  );


		// 		const isInLineText = this.checkWordIsInLine(wordDataArr[i], labelText);

		// 		if (isInLineText) {
		// 		// if (targetLabelText.toLowerCase().indexOf(labelText.toLowerCase()) != -1  && rect.intersects(dotRect)) {
		// 			topLeftLetterData = wordDataArr[i];
		// 			// answerData[i.toString()] = colorRect;
		// 			// return;
		// 		}

		// 	}
			
		// }

			
		// return topLeftLetterData;









		// // const topRect = this.topItemData.rect;

		// // const topCenterY = (topRect.y + topRect.height / 2);
		// // const bottomCenterY = (bottomRect.y + bottomRect.height / 2);
		
		// // const unitH = bottomCenterY - topCenterY;
		// // const unitW = topRect.width;
		// // const baseX = topRect.x;
		// // const baseY = topRect.y + topRect.height;


		

		// // const titleBottom = this.getTitleBottom();
		// // console.log("titleBottom: ", titleBottom);

		// // let topLeftLetter;
		// // const wordDataArr =  this.getPhotoWordArr(text, block, topLabelData);
		// // for (let i=0; i<wordDataArr.length; i++) {

		// // 	const tempWordArr = wordDataArr[i].word;
		// // 	for (let k=0; k<tempWordArr.length; k++) {
		// // 		const {location , content} = tempWordArr[k];


		// // 		// console.log('location: ~~ ', location);

		// // 		// if (location.top <= titleBottom) {
		// // 		// 	continue;
		// // 		// }

		// // 		wordDataArr[i].tmpLen = this.getToZeroLen(location)

					



		// // 		if (!topLeftLetter) {
		// // 			topLeftLetter = wordDataArr[i];
		// // 		} else {
		// // 			if (topLeftLetter.tmpLen > wordDataArr[i].tmpLen) {
		// // 				topLeftLetter = wordDataArr[i];
		// // 			}
		// // 		}
		// // 	}
			
		// // }

		// // return topLeftLetter;


	},

	getLineRect(line) {

		const tempWordArr = line.word;

		let sentenceRect;
		let left;
		let right;
		for (let k=0; k<tempWordArr.length; k++) {
			const {location , content} = tempWordArr[k];

			const tempRect = {
				x: location.left, 
				y: -location.bottom, 
				width: Math.abs( location.right - location.left ), 
				height: Math.abs( location.bottom - location.top ), 
			}
			const colorRect = this.getColorRect(tempRect);
			colorRect.labelText = content;
			// this.debugDrawLayer.addChild(colorRect);

					
			const rect = colorRect.ccRect;
			if (!sentenceRect) {
				sentenceRect = rect;
				left = rect.x;
				right = rect.x + rect.width;
			} else {
				if (rect.x + rect.width > right) {
					right = rect.x + rect.width;
				}
			}



		


		}

		if (sentenceRect) {
			sentenceRect.width = right - left;
		}

		return sentenceRect;



	},

	checkWordIsInLine(line, text) {

		console.log(" in checkWordIsInLine ");
		console.log(" line:  ", line);
		console.log(" word:  ", text);

		const textArr = text.trim().toLowerCase().split('');

		const word = line.word;
		let sentence = ''
		word.forEach(item => {
			sentence += item.content + ' ';
		});

		sentence.trim();
		sentence = sentence.toLowerCase();

		line.sentence = sentence;

		console.log(" sentence:  ", sentence);
		

		if (this.checkIsInsert(textArr, sentence)) {
			return true;
		}

		
		return false;

	},


	getTitleBottom() {
		let maxBottom = 0;
		const word = this.topLabelData.word;
		for (let i=0; i<word.length; i++) {
			if (word[i].location.bottom > maxBottom) {
				maxBottom = word[i].location.bottom;
			}
		}

		return maxBottom;
	},

	getToZeroLen(location) {
		const {top, left} = location;
		const len = Math.sqrt( Math.pow(left, 2) + Math.pow(top, 2) );
		return len;
	},



	getPhotoLabelData(textArr, block, isShow=true) {


		for(let j=0; j<block.length; j++) {

			const line = block[j];
			if (!line) {
				continue;
			}

			const sentence = line.content;


			if (isShow) {
				const label = this.getLabel(sentence, 150);
				label.x = line.left * this.debugBgImg.width;
				label.y = -(line.top + (line.bottom - line.top) / 2) * this.debugBgImg.height;
				label.parent = this.debugDrawLayer;
				label.zIndex = 200;
				// label.color = cc.Color.RED;
				const l = label.getComponent(cc.Label);
				label.anchorX = 0;
				console.log(' sentence~:  ', sentence);
			}




			if (this.checkIsInsert(textArr, sentence)) {
				return line;
			}

		}

		return false;

		// for(let j=0; j<block.length; j++) {

		// 	const line = block[j].line;
		// 	if (!line) {
		// 		continue;
		// 	}

		// 	for (let i=0; i<line.length; i++) {

		// 		const word = line[i].word;
		// 		let sentence = ''
		// 		word.forEach(item => {
		// 			sentence += item.content + ' ';
		// 		});
	
		// 		sentence.trim();
		// 		sentence = sentence.toLowerCase();
	
		// 		line[i].sentence = sentence;

		// 		if (this.checkIsInsert(textArr, sentence)) {
		// 			return line[i];
		// 		}
		// 	}
		// }

		// return false;
	},

	checkIsInsert(textArr, sentence) {
		// console.log('textArr: ', textArr);
		// console.log('sentence: ', sentence);

		sentence = sentence.toLowerCase();

		let index = -1;
		for (let i=0; i<textArr.length; i++) {
			index = sentence.indexOf(textArr[i].toLowerCase(), index);
			// console.log('index: ', index);
			if (index == -1) {
				return false;
			}
		}

		return true;
	},

	showUserRight(answerData) {

		console.log('answerData: ', answerData);

		if (Object.keys(answerData).length == 0) {

			const curWordBg = this.wordBgArr[this.quesArrIndex];
			const {wordNode} = curWordBg;
			wordNode.hitCount = 0;
			return;
		}

		this.showCurAnswerPic();
		return;
	},

	showCurAnswerPic() {

		const curWordBg = this.wordBgArr[this.quesArrIndex];
		const {wordNode} = curWordBg;

		if (!wordNode.hitCount) {
			wordNode.hitCount = 0;
		}

		wordNode.hitCount ++;
		if (wordNode.hitCount < 1) {
			return;
		}


		this.showLetterLabel(wordNode, true);
		this.showAnswerIcon(curWordBg, true)
		return;

		// for (let i=0; i<this.wordBgArr.length; i++) {
		// 	const wordBg = this.wordBgArr[i];
		// 	if (wordBg.data == this.curQues) {
		// 		console.log('aaa')
		// 		this.showLetterLabel(wordBg);
		// 		this.showAnswerIcon(this.wordBgArr[i], true)
		// 		return;
		// 	}
		// }

	},

	showUserRight_(answerData, data) {

		const text = data?.result?.text
		if (!text) {
			return false;
		}


		console.log('answerData: ', answerData);
		// console.log('this.picNodeArr: ', this.picNodeArr);

		if (Object.keys(answerData).length == 0) {
			return;
		}



		for (let i = 0; i < this.animaNodeArr.length; i++) {

			const animaNode = this.animaNodeArr[i];

			const key = animaNode.data.rectItem // i.toString();

			console.log('key: ', key)

			console.log('~key: ', key)

			if (!animaNode.hitCount) {
				animaNode.hitCount = 0;
			}

			if (answerData[key] && answerData[key].isFinish) {
				this.showLetter(animaNode);
				// this.removeLine(answerData[key].line, block);
			} else {

				animaNode.hitCount = 0;
			}
		}


		// for (let i = 0; i < this.picNodeArr.length; i++) {

		// 	const picNode = this.picNodeArr[i];

		// 	const key = picNode.data.rectItem // i.toString();

		// 	console.log('key: ', key)

		// 	if (answerData[key] && answerData[key].isFinish) {
		// 		this.showLetter(picNode);
		// 		this.removeLine(answerData[key].line, block);
		// 	} else {

		// 		picNode.hitCount = 0;
		// 	}
		// }


	},

	removeLine(line, block) {

		console.log('block: ', JSON.stringify(block));
		for (let i=0; i<block.length; i++) {
			const lineArr = block[i].line;
	
			const index = lineArr.indexOf(line);
			if (index != -1) {
				lineArr.splice(index, 1);
				console.log(' ```splice lineArr.length: ' , lineArr.length);
			}
		}
	},

	showUserWrong(answerData) {

		console.log('answerData: ', answerData);
		console.log('this.picNodeArr: ', this.picNodeArr);

		if (Object.keys(answerData).length == 0) {
			return;
		}


		for (let i = 0; i < this.picNodeArr.length; i++) {

			const picNode = this.picNodeArr[i];

			const key = picNode.data.rectItem // i.toString();

			console.log('key: ', key)

			if (answerData[key] && answerData[key].count >= 3) {
				this.showLetter(picNode, false);
			}
		}


	},


	showAnswerIcon(wordBg, isRight) {

		if (wordBg.isIconShowEnd) {
			return;
		}
		wordBg.isIconShowEnd = true;

		const {rightIcon, rightAnim, wrongIcon, wrongAnim} = wordBg;
		if (isRight) {
			this.appearAnim(rightIcon, 0.7);
			// rightAnim.node.active = true;
			// rightAnim.playAnimation('right', 1);

		} else {
			this.appearAnim(wrongIcon, 0.7);
			// wrongAnim.node.active = true;
			// wrongAnim.playAnimation('right', 1);
		}

	},
	
	showLetterLabel(picNode, isRight = true) {

		// let writeRect = this.writeNodeArr[Number(index)];

		console.log('in showLetter 1');


		picNode.hitCount++;
		if (picNode.hitCount < 1) {
			return;
		}


		console.log('in showLetter 2');


		if (picNode.isShowEnd) {
			return;
		}

		console.log('in showLetter 3');

		picNode.active = true;
		picNode.isShowEnd = true;
		picNode.isRight = isRight;

		if (picNode.data) {
			picNode.data.isRight = isRight;
		}


		let clip = this.rightClip;
		if (!isRight) {

			
			clip = this.wrongClip;
			picNode.color =  cc.Color.fromHEX(new cc.Color(), '#f35936')//cc.Color.RED;
			
		} else {
			picNode.color =  cc.Color.fromHEX(new cc.Color(), '#2b62b0')
		}



		cc.tween(picNode)
			.to(1, {opacity: 255}, {easing: "cubicOut"})
			.start();

		playAudio(clip, () => {
		
		})

		// picNode.playRightAnim();
		// this.playRightAnim(picNode);

		// if (!this.isGameEnd) {
		// 	this.checkGameEnd(this.animaNodeArr);
		// }
	
	},

	showLetter(picNode, isRight = true) {

		// let writeRect = this.writeNodeArr[Number(index)];

		console.log('in showLetter 1');


		picNode.hitCount++;
		if (picNode.hitCount < 1) {
			return;
		}


		console.log('in showLetter 2');


		if (picNode.isShowEnd) {
			return;
		}

		console.log('in showLetter 3');

		picNode.isShowEnd = true;
		picNode.isRight = isRight;


		// picNode.playRightAnim();
		this.playRightAnim(picNode);

		if (!this.isGameEnd) {
			this.checkGameEnd(this.animaNodeArr);
		}

		return;


		picNode.answerPic.active = true;



		if (!isRight) {
			console.log(' ~ !isRight');
			picNode.answerPic.color = cc.Color.fromHEX(new cc.Color(), '#ef7961')
			playAudio(this.wrongClip);

			if (!this.isGameEnd) {
				this.checkGameEnd();
			}
			return;
		} else {
			picNode.answerPic.color = cc.Color.fromHEX(new cc.Color(), '#548fd4')
			playAudio(this.rightClip);

		}

		this.showAnimaStar(picNode, ()=> {
			
			if (!this.isGameEnd) {
				this.checkGameEnd();
			}

		});

	
	},

	showAnimaStar(node, cb) {

		const resDragonBone = cc.find("Canvas/res/anim/right")
		const dNode = cc.instantiate(resDragonBone)
		node.addChild(dNode, 20);

		const dragonDisplay = dNode.getComponent(dragonBones.ArmatureDisplay);

		dragonDisplay.playAnimation('newAnimation', 1);

		dragonDisplay.on(dragonBones.EventObject.COMPLETE, ()=> {
			console.log('play end');
			cb && cb();
		})
		

	},

	getAnswerData(data) {
		
		const answerData = {};
		const wordData = this.curQues;
		console.log('wordData:' , wordData);
		// let targetText = wordData.text_en;

		let targetText = wordData.text_cn;


		// const hasAnswer = this.checkHasAnswer(data, targetText);
		// console.log('hasAnswer:', hasAnswer);

		// if (hasAnswer) {
		// 	answerData['1'] = true;
		// 	return answerData;
		// } 





		// let targetText = wordData.text_en;
		let targetText1;
		let targetText2;
		if (targetText.indexOf('(') != -1) {
			targetText1 = targetText.replace(/(\(+)|(\)+)/g, "");
			targetText2 = targetText.replace(/(\(+.*\)+)/g, "");
		}
		if (targetText.indexOf('（') != -1) {
			targetText1 = targetText.replace(/(\（+)|(\）+)/g, "");
			targetText2 = targetText.replace(/(\（+.*\）+)/g, "");
		}


		const checkFunc = (targetT) => {
			console.log('targetT: ', targetT);
			const hasAnswer = this.checkHasAnswer2(data, targetT);
			if (hasAnswer) {
				answerData['1'] = true;
			}
		}

		checkFunc(targetText);
		if (answerData['1']) {
			return answerData;
		}

		if (targetText1) {
			checkFunc(targetText1);
			if (answerData['1']) {
				wordData.text_en = targetText1;
				return answerData;
			}
		}
		
		if (targetText2) {
			checkFunc(targetText2);
			if (answerData['1']) {
				wordData.text_en = targetText2;
				return answerData;
			}
		}
		

		// const hasAnswer = this.checkHasAnswer2(data, targetText);
		// // const hasAnswer = this.checkHasAnswer(data, targetText);

		// console.log('hasAnswer:', hasAnswer);
		// if (hasAnswer) {
		// 	answerData['1'] = true;
		// } else if(targetText2) {
			
		// 	const hasAnswer2 = this.checkHasAnswer2(data, targetText2);
		// 	if (hasAnswer2) {
		// 		answerData['1'] = true;
		// 	}
		// }

		// console.log('hasAnswer:', hasAnswer);

		return answerData;
	},


	getTempWordArr(line, splitText) {

		const lineBox = {left: line.left, top: line.top, right: line.right, bottom: line.bottom};
		const baseX = lineBox.left;

		let textIndex = 0;
		const oneDisW = (lineBox.right - lineBox.left) / line.content.length;

		const arr = line.content.split(splitText);
		const wordArr = [];
		for (let i=0; i<arr.length; i++) {
			const content = arr[i];
			const location = {}
			location.left = baseX + textIndex * oneDisW;
			location.right = location.left + oneDisW * content.length;
			location.top = lineBox.top;
			location.bottom = lineBox.bottom;
			
			wordArr.push({content, location});

			textIndex += content.length;
		}

		return wordArr;
	},






	setCirclePosInRectArr(colorRect) {


		const rect = colorRect.ccRect;
		const dotV2 = new cc.Vec2(rect.x + rect.width/2, rect.y + rect.height / 2);

		const circleRectCheckArr = this.circleRectCheckArr;

		for (let i=0; i<circleRectCheckArr.length; i++) {

			const checkRect = circleRectCheckArr[i].ccRect;
			const key = circleRectCheckArr[i].data.index + 1;

			console.log("labelText: ", labelText);
			console.log("key: ", key);

			// if (labelText.toLowerCase().indexOf(targetLabelText.toLowerCase()) != -1 && rect.intersects(dotRect)) {
			if (checkRect.contains(dotV2)) {
				if (!colorRect.inRectArr) {
					colorRect.inRectArr = []
				}
				colorRect.inRectArr.push(key);
			}

		}
	},



	setOneAnswerDataNew(colorRect, answerData) {
		const rect = colorRect.ccRect;
		const dotV2 = new cc.Vec2(rect.x + rect.width/2, rect.y + rect.height / 2);


		const targetLabelText = colorRect.labelText;

		const newRectCheckArr = this.newRectCheckArr;

		for (let i=0; i<newRectCheckArr.length; i++) {

			const labelText = newRectCheckArr[i].data.labelText;
			const checkRect = newRectCheckArr[i].ccRect;
			const key = newRectCheckArr[i].data.index + 1;


			console.log("labelText: ", labelText);
			console.log("key: ", key);

			// if (labelText.toLowerCase().indexOf(targetLabelText.toLowerCase()) != -1 && rect.intersects(dotRect)) {
			// if (labelText == targetLabelText && checkRect.contains(dotV2)) {
			if (checkRect.contains(dotV2)) {
				// const len = targetLabelText.trim().length;

				// console.log('len: ', len);

				// if (labelText.length == 1) {

				// 	if (labelText.toLowerCase().indexOf(targetLabelText.toLowerCase()) != -1 ) {
				// 		answerData[key] = {isFinish: true};
				// 	}

				// } else {
					if (labelText.toLowerCase() == targetLabelText.toLowerCase()) {
						answerData[key] = {isFinish: true};
						console.log('finish key:', key);
					}
				// }


			}

		}
	},

	setOneAnswerData(colorRect, dotArr, answerData, line) {

		console.log(' in setOneAnswerData')
		console.log('colorRect: ', colorRect)
		console.log('dotArr: ', dotArr)
		console.log('answerData: ', answerData)

		
		const rect = colorRect.ccRect;
		const targetLabelText = colorRect.labelText;

		for (let i=0; i<dotArr.length; i++) {

			const {dotRect, labelText, key} = dotArr[i];

				console.log('targetLabelText.toLowerCase() : ', targetLabelText.toLowerCase() );
				console.log('labelText.toLowerCase()  : ', labelText.toLowerCase()  );
				console.log('rect.intersects(dotRect) : ', rect.intersects(dotRect) );

			if (labelText.toLowerCase().indexOf(targetLabelText.toLowerCase()) != -1 && rect.intersects(dotRect)) {
				const len = targetLabelText.trim().length;

				console.log('len: ', len);

				if (!answerData[key]) {
					answerData[key] = {colorRect, count: len};
				} else {
					answerData[key].count += len;

					// console.log('len: ', len);
					// console.log('	answerData[key].count: ', 	answerData[key].count);

				}

				if ( labelText.length <= 1) {
					answerData[key].isFinish = true;
					answerData[key].line = line;

				} else {
					if (answerData[key].count >= labelText.length) {
						answerData[key].isFinish = true;
						answerData[key].line = line;
					}
				}
				

			
				// return;
			}

		}

	},

	getColorRect(rect, color=null) {

		if (!color) {
			color = 'red'
		}


		rect.x *= this.debugBgImg.width;
		rect.y *= this.debugBgImg.height;
		rect.width *= this.debugBgImg.width;
		rect.height *= this.debugBgImg.height;

		const node = getSprNode(color);
		node.anchorX = 0;
		node.anchorY = 0;
		node.x = rect.x;
		node.y = rect.y;
		node.scaleX = rect.width / node.width;
		node.scaleY = rect.height / node.height;

		node.ccRect = new cc.Rect(rect.x, rect.y, rect.width, rect.height);



		return node;
	},



	getColorDot(x, y, w=100, h=100, color='red') {
		const node = new cc.Node();

		if (!h) {
			h = w;
		}

		x *= this.debugBgImg.width;
		y *= this.debugBgImg.height;
		w *= this.debugBgImg.width;
		h *= this.debugBgImg.height;

		if (this.debugLayer.parent && this.debugLayer.active) {

			const rect = {
				x:- w/2,
				y: - h/ 2, 
				width:w, 
				height:h
			}
			// const colorDot = this.getColorRect(rect,'blue');
			// colorDot.fillColor = cc.Color.BLUE;
			// colorDot.fillRect( - r/2, - r/ 2, r, r);

			const colorDot = getSprNode(color);

			
			// colorDot.anchorX = 0;
			// colorDot.anchorY = 0;
			// colorDot.x = rect.x;
			// colorDot.y = rect.y;
			colorDot.scaleX = rect.width / colorDot.width;
			colorDot.scaleY = rect.height / colorDot.height;
			node.addChild(colorDot);



			// const rect1 = new cc.Rect(node.x -r/2, node.y -r/2, r, r);
			// const colorDot = this.getColorRect(rect1, 'green');

			// colorDot.dotRect = rect1;
			// return colorDot;
		}

		node.x = x;
		node.y = y;


		// node.opacity = 0.5;

		const rect = new cc.Rect(node.x -w/2, node.y -h/2, w, h);
		node.dotRect = rect;
		node.ccRect = rect;
		return node;
	},

	
	checkHasAnswer2(_data, text) {

		text = text.toLowerCase();
		text = text.replace(/(^\s+)|(\s+)|(\s+$)/g,"");
		text = text.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");

		let sentenceArr = this.getFilterSentence(_data);

		for (let i=0; i<sentenceArr.length; i++) {
			const sentence = sentenceArr[i];
			if (sentence.indexOf(text) != -1) {
				console.log('sentence: ' + sentence + ', text: ' + text);

				return true;
			}
		}

		return false;



		const targetHitCount = this.getTargetHitCount(text);
		console.log('targetHitCount: ', targetHitCount);
		let curHitCount = 0;
		const block = data.block;
		for (let j = 0; j < block.length; j++) {

			const line = block[j].line;
			if (!line) {
				continue;
			}


			for (let i = 0; i < line.length; i++) {


				const word = line[i].word;



				console.log('word: ', word);
				// for (let k=0; k<word.length; k++) {

				// 	let content = word[k].content;
				
				// 	content = content.trim();
				// 	content = content.toLowerCase();

					

				// 	this.setTestLabel(line[i], word[k])

	
				// 	if (content == text) {
				// 		return true;
				// 	}
				// }


				let sentence = ''
				word.forEach(item => {
					sentence += item.content.trim();
				});

				sentence = sentence.trim();
				sentence = sentence.toLowerCase();
				sentence = sentence.replace(/(\'+)|(\’+)/g, "");
				sentence = sentence.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");


				line[i].sentence = sentence;
				console.log('sentence: ' + sentence + ', text: ' + text);

				if (sentence) {
					this.setTestLabel(line[i], sentence)
				}

				if (sentence.indexOf(text) != -1) {
				// if (sentence == text) {

				console.log('sentence: ' + sentence + ', text: ' + text);

					curHitCount ++;
					if (curHitCount >= targetHitCount) {
						return true;
					}

				}
			}
		}
	},

	getFilterSentence(data) {
		
		const sentenceArr = [];

		const block = data.block;
		for (let j = 0; j < block.length; j++) {

			const line = block[j].line;
			if (!line) {
				continue;
			}

			for (let i = 0; i < line.length; i++) {

				const word = line[i].word;

				console.log('word: ', word);

				let sentence = ''
				word.forEach(item => {
					sentence += item.content.trim();
				});

				sentence = sentence.trim();
				sentence = sentence.toLowerCase();
				sentence = sentence.replace(/(\'+)|(\’+)/g, "");
				sentence = sentence.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");

				line[i].sentence = sentence;
				// console.log('sentence: ' + sentence + ', text: ' + text);

				if (sentence) {
					this.setTestLabel(line[i], sentence)

					sentenceArr.push(sentence);
				}

			}
		}




		const deleteRightText = () => {

			// 排序一个新数组 防止有相同部分 先把长的某部分删除了
			const tempQuesArr = [];
			for (let i=0; i<this.quesArrIndex+1; i++) {
				tempQuesArr.push( this.quesArr[i] );
			}

			tempQuesArr.sort((a, b) => {
				return  b.text_en.length - a.text_en.length;
			})

			console.log('tempQuesArr: ', tempQuesArr);

			for (let i=0; i<tempQuesArr.length; i++) {
				let {text_en, isRight} = tempQuesArr[i];
	
				text_en = text_en.toLowerCase();
				text_en = text_en.replace(/(^\s+)|(\s+)|(\s+$)/g,"");
				text_en = text_en.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");

				//只找之前识别对的
				if (!isRight) {
					continue;
				}

				//识别到的句子中查找之前对的单词，找到的话从句子中删除
				for (let j=0; j<sentenceArr.length; j++) {
					const sentence = sentenceArr[j]

					if (sentence.indexOf(text_en) != -1) {
						sentenceArr[j] = sentence.replace(text_en, "");
						break;
					}
				}

			}

		}

		// deleteRightText();

		return sentenceArr;
	},

	getTargetHitCount(text) {

		let targetHitCount = 1;
		for (let i=0; i<this.quesArrIndex+1; i++) {
			let {text_en, isRight} = this.quesArr[i];

			text_en = text_en.toLowerCase();
			text_en = text_en.replace(/(^\s+)|(\s+)|(\s+$)/g,"");
			text_en = text_en.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");

			if (isRight && text_en.indexOf(text) != -1) {
				targetHitCount ++;
			}

			if (!isRight && text_en.indexOf(text) != -1) {
				console.log('isRight no: ', text_en);
			}
		}

		return targetHitCount;
	},

	checkHasAnswer(data, text) {

		text = text.toLowerCase();
		text = text.replace(/(^\s+)|(\s+)|(\s+$)/g,"");
		text = text.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");


		// const targetHitCount = this.getTargetHitCount(text);
		// console.log('targetHitCount: ', targetHitCount);
		// let curHitCount = 0;
		const block = data.block;
		for (let j = 0; j < block.length; j++) {

			const line = block[j].line;
			if (!line) {
				continue;
			}


			for (let i = 0; i < line.length; i++) {


				const word = line[i].word;

				console.log('word: ', word);
				for (let k=0; k<word.length; k++) {

					let content = word[k].content;


					content = content.trim();
					content = content.toLowerCase();
					content = content.replace(/(\'+)|(\’+)/g, "");
					content = content.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");

					

					this.setTestLabel(line[i], word[k])

	
					if (content == text) {
						return true;
					}
				}


				// let sentence = ''
				// word.forEach(item => {
				// 	sentence += item.content.trim();
				// });

				// sentence = sentence.trim();
				// sentence = sentence.toLowerCase();
				// sentence = sentence.replace(/(\'+)|(\’+)/g, "");
				// sentence = sentence.replace(/(\'+)|(\’+)|(\.+)|(\!+)/g, "");


				// line[i].sentence = sentence;
				// console.log('sentence: ' + sentence + ', text: ' + text);

				// if (sentence) {
				// 	this.setTestLabel(line[i], sentence)
				// }

				// if (sentence.indexOf(text) != -1) {
				// // if (sentence == text) {

				// console.log('sentence: ' + sentence + ', text: ' + text);

				// 	curHitCount ++;
				// 	if (curHitCount >= targetHitCount) {
				// 		return true;
				// 	}

				// }
			}
		}
	},

	


	setTestLabel(labelData, sentence) {

		console.log(' in setTestLabel')
		if (!this.debugLayer.parent || !this.debugLayer.active) {
			return;
		}
		console.log('labelData: ', labelData)
		const location = labelData.word[0].location;
		const label = this.getLabel(sentence);
		label.anchorX = 0;

		const l = label.getComponent(cc.Label);
		l.fontSize = 100 * this.canvas.width / 1080;
		l.lineHeight = l.fontSize;


		// label.anchorY = 1;
		label.x = location.left * 2;
		label.y = -location.top * 3
		label.zIndex = 50;


		const rect = {};
		rect.width = location.right - location.left;
		rect.height = location.bottom - location.top;
		rect.x = location.left;
		rect.y = -location.top;
		// const colorRect = this.getColorRect(rect, cc.Color.YELLOW);
		// this.debugLayer.addChild(colorRect);

		this.debugLayer.addChild(label);
	},

	getLabel(text, fontSize = 20) {
		const labelNode = new cc.Node();
		const label = labelNode.addComponent(cc.Label);
		label.string = text;
		labelNode.color = cc.Color.BLACK;
		label.fontSize = fontSize;
		label.lineHeight = fontSize;

		label.font = cc.find('Canvas/res/font/BiaoZhunShouxieTi').getComponent(cc.Label).font;
	


		return labelNode;
	},



	debugLayer: null,
	initDebugLayer() {


		const layer = new cc.Node();
		layer.x = -this.canvas.width / 2 + 10;
		layer.y = this.canvas.height / 2 - 10;
		layer.active = false;


		this.canvas.addChild(layer, 20)
		this.debugLayer = layer;

		layer.scale = 0.5;

		layer.width = this.canvas.width;
		layer.height = this.canvas.height;
		// layer.anchorX = 0;
		// layer.anchorY = 1;

		// const w = layer.width * layer.scaleX;
		// const h = layer.height * layer.scaleY;
		// if (layer.active ) {
		// 	const bgRectNode = new cc.Node();
		// 	const ctx = bgRectNode.addComponent(cc.Graphics);
		// 	ctx.rect(-w / 2, -h/2, w, h);
		// 	ctx.fillColor = cc.Color.WHITE.setA(130);
		// 	ctx.fill();
		// 	this.canvas.addChild(bgRectNode, 10);
		// }
	



		// console.log(' in initDebugLayer');
		// const layer = new cc.Node();

		// if (this.data.isDebug) {
		// 	layer.parent = cc.find('Canvas');
		// }


		// layer.width = this.canvas.width / 2;
		// layer.height = this.canvas.height / 2;

		// layer.zIndex = 100;
		// layer.anchorX = 0;
		// layer.anchorY = 1;


		// if (!this.data.bgItem2) {
		// 	return;
		// }


		// cc.loader.load({url: this.data.bgItem2.url}, (err, img) => {

		// 	this.debugBgImg = img;
		// 	this.checkBg = img;
		// 	layer.width = img.width;
		// 	layer.height = img.height;

		// 	layer.data = this.data.bgItem2;

		// 	const sprNode = layer;
	
		// 	var sf = new cc.SpriteFrame(img);

		// 	const spr = sprNode.addComponent(cc.Sprite);
		// 	spr.spriteFrame = sf			

		// 	const sx = this.canvas.width / 2 / layer.width;
		// 	const sy = (this.canvas.height) / 2 / layer.height;
		// 	const s = Math.min(sx, sy);
		// 	layer.scale = s;

		// 	this.addNewRect();
		// 	// this.addCircleItem();
		// 	// this.addSignItem();
		// 	// this.addFingerItem();

		// 	this.initDebugRect();

		// 	this.checkStart();
	
		// });

		// layer.x = -this.canvas.width / 2 + 10;
		// layer.y = this.canvas.height / 2 - this.canvas.height / 3;
		// layer.opacity = 150;

		// // layer.scale = 2;
		// this.debugLayer = layer;

		// // const bgRectNode = new cc.Node();
		// // const ctx = bgRectNode.addComponent(cc.Graphics);
		// // ctx.fillRect(0, -layer.height, layer.width, layer.height);
		// // ctx.fillColor = cc.Color.YELLOW.setA(100);
		// // ctx.fill();
		// // layer.addChild(bgRectNode);


		// const drawLayer = new cc.Node();
    // this.debugLayer.addChild(drawLayer, 2);

    // this.debugDrawLayer = drawLayer;



	},

	initDebugRect() {

		console.log(' in initDebugRect');

		
		this.linkRectGroup = [];
		this.data.hotZoneItemArr2.forEach((item) => {
			switch (item.gIdx) {
				// case "0":
				// 	this.setOneDebugLinkRect(item);
				// 	break;

				case "0":
					// this.setOneDebugWriteRect(item);
					break;

				default:
					break;
			}

		});
	

	},

	setOneDebugLinkRect(data) {
		const rate = (this.debugLayer.scale * this.debugLayer.width) / this.data.bgItem2.rect.width;
	
		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		this.debugLayer.addChild(rectNode);

		let ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / this.debugLayer.scaleY;

		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = data.rect.x * scale;
		rectNode.y =  - data.rect.height * scale - data.rect.y * scale;
	

		rectNode.anchorX = 0;
		rectNode.anchorY = 0;

		if (this.data.isDebug) {
			ctx.rect(0, 0, rectNode.width, rectNode.height);
		}
		ctx.stroke();
		ctx.fill();


		rectNode['data'] = data;
		rectNode.opacity = 100;

		rectNode['ccRect'] = rectNode.getBoundingBoxToWorld()


		rectNode.isRightPoint = data.checkbox.list[0].value == true;

		this.linkRectGroup.push(rectNode);

		this.setLinkDataByDebugItem(rectNode, data.index);

	},

	setLinkDataByDebugItem(item, index) {

		let hzItemId;
		let debugItemId;
		let linkHzItemId;
		let linkDebugItemId;


		debugItemId = index + 1;

		const hzItem = this.getHzItemByPoint(debugItemId)

		hzItemId = this.data.hotZoneItemArr.indexOf(hzItem) + 1;

		console.log(' hzItem: ', hzItem);
		console.log(' debugItemId: ', debugItemId);

		linkHzItemId = hzItem.linkItem;

		const linkHzItem = this.data.hotZoneItemArr[linkHzItemId-1]

		linkDebugItemId = linkHzItem.pointItem;


		const linkData = {hzItemId, debugItemId, linkHzItemId, linkDebugItemId};
		item.linkData = linkData;

	},

	getHzItemByPoint(pointId, gidx = '0') {
		
		const hzItem = this.data.hotZoneItemArr.find((item) => {

			if (item.gIdx == gidx) {
				return item.pointItem == pointId
			}
		});

		return hzItem;
	},

	addFingerItem() {
		if (!this.fingerRectArr) {
			return;
		}

		this.fingerRectCheckArr = [];
		const bg = this.debugLayer;
		for (let i=0; i<this.fingerRectArr.length; i++) {
			const oneData = this.fingerRectArr[i];
			const rect = this.setDebugRectDot(oneData, bg);
			this.fingerRectCheckArr.push(rect);
			console.log('oneData: ', oneData);
		}
	},

	addSignItem() {
		if (!this.signRectArr) {
			return;
		}

		this.signRectCheckArr = [];
		const bg = this.debugLayer;
		for (let i=0; i<this.signRectArr.length; i++) {
			const oneData = this.signRectArr[i];
			const rect = this.setDebugRectDot(oneData, bg);
			this.signRectCheckArr.push(rect);
			console.log('oneData: ', oneData);
		}
	},

	addCircleItem() {

		if (!this.circleRectArr) {
			return;
		}

		this.circleRectCheckArr = [];
		const bg = this.debugLayer;
		for (let i=0; i<this.circleRectArr.length; i++) {
			const oneData = this.circleRectArr[i];
			const rect = this.setDebugRectDot(oneData, bg);
			this.circleRectCheckArr.push(rect);
			console.log('oneData: ', oneData);
		}
	},


	setDebugRectDot(data, bg) {
		const bgData = bg.data;
		const rate = (bg.scale * bg.width) / bgData.rect.width;

		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		bg.addChild(rectNode);


		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / bg.scaleY;

		console.log('scale: ', scale);

		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = data.rect.x * scale;
		rectNode.y =  - data.rect.y * scale - data.rect.height * scale;


		rectNode.anchorX = rectNode.anchorY = 0;


		rectNode.x /= bg.width;
		rectNode.y /= bg.height;
		rectNode.width /= bg.width;
		rectNode.height /= bg.height;
		const colorRect = this.getColorRect(rectNode, 'blue');
		colorRect.opacity = 180;
		colorRect.data = data;
		bg.addChild(colorRect, 20);

		return colorRect;
	},

	addNewRect() {
		
		if (!this.newRectArr) {
			return;
		}

		this.newRectCheckArr = [];
		const bg = this.debugLayer;
		for (let i=0; i<this.newRectArr.length; i++) {
			const oneData = this.newRectArr[i];
			this.setNewRectDot(oneData, bg);
			console.log('oneData: ', oneData);
		}

	},


	setNewRectDot(data, bg) {
		const bgData = bg.data;
		const rate = (bg.scale * bg.width) / bgData.rect.width;

		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		bg.addChild(rectNode);


		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / bg.scaleY;

		console.log('scale: ', scale);

		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = data.rect.x * scale;
		rectNode.y =  - data.rect.y * scale - data.rect.height * scale;


		rectNode.anchorX = rectNode.anchorY = 0;


		rectNode.x /= bg.width;
		rectNode.y /= bg.height;
		rectNode.width /= bg.width;
		rectNode.height /= bg.height;
		const colorRect = this.getColorRect(rectNode, 'green');
		colorRect.opacity = 180;
		colorRect.data = data;
		bg.addChild(colorRect, 20);

		this.newRectCheckArr.push(colorRect);                                                                                                                                                                                        


		// if (this.data.bgItem.isShowDebugLine || true) {
		// 	ctx.rect(0, 0, rectNode.width, rectNode.height);
		// }
		// ctx.stroke();
		// ctx.fill();

	},
	 


	getPhotoWordArr(text, block, benchmark1Data) {


		const wordArr = [];
		// const maxLen = 10;

		text = text.trim();

		const topY = -benchmark1Data.top;

		for(let j=0; j<block.length; j++) {

			const line = block[j];
			if (!line) {
				continue;
			}


			const sentence = line.content;
			if (sentence.indexOf(text) != -1 ) {
				wordArr.push( line );
			}

			// for (let i=0; i<line.length; i++) {


			// 	const location = line[i].word[0].location;

			// 	const curTop = -location.top;
			// 	if (curTop >= topY ) {
			// 		continue;
			// 	}


			// 	let word = line[i].word;
			// 	let sentence = ''

			// 	// if (word.length > maxLen) {
			// 	// 	console.log('continue ', word.length);
			// 	// 	continue;
			// 	// }

			// 	line[i].word = word = this.checkCutWordData(word);
			// 	// console.log('word1~ ', word);


			// 	word.forEach(item => {
			// 		sentence += item.content + '';
			// 	});

			// 	sentence = sentence.trim().toLowerCase();

			// 	text = text.toLowerCase();

			// 	line[i].sentence = sentence;
			// 	console.log('sentence: ', sentence);
			// 	console.log('text: ', text);

			// 	console.log('index: ', sentence.indexOf(text));
			// 	if (sentence.indexOf(text) != -1 ) {
			// 		wordArr.push( line[i] );
			// 	}
			// }
		}

		return wordArr;
	},


	checkCutWordData(wordArr) {


		// console.log('wordArr: ', wordArr);

		let newWordArr = [];
		for(let i=0; i<wordArr.length; i++) {

			let wordObj = wordArr[i];

			wordObj.content = wordObj.content.trim();

			if (wordObj.content.length > 1) {

				const tmpArr = [];
				const w = wordObj.location.right - wordObj.location.left
				const subW = w / wordObj.content.length;
				for (let j=0; j<wordObj.content.length; j++) {

					const subWordObj = {};
					subWordObj.content = wordObj.content[j];
					subWordObj.location = {
						top: wordObj.location.top,
						bottom: wordObj.location.bottom,
						left: wordObj.location.left + subW * j,
						right: wordObj.location.left + subW * (j + 1)
					}

					tmpArr.push(subWordObj);
				}
				newWordArr = newWordArr.concat(tmpArr)


			} else {
				newWordArr.push(wordObj)
			}

		}

		// console.log('newWordArr: ', newWordArr);
		return newWordArr;
	},

	getPhotoData(cb) {
	


		const tmpData1 = {"allText":"晚上有月亮吗","block":[{"line":[{"word":[{"content":"晚上有月亮吗","cornerPoint":[{"x":121,"y":75},{"x":361,"y":75},{"x":361,"y":111},{"x":121,"y":111}],"location":{"bottom":111,"left":121,"right":361,"top":75},"recognizedLanguage":"zh"}]}]}]}
		
		// const tmpData1 = {"allText":"juicy peach","block":[{"line":[{"word":[{"content":"juicy","cornerPoint":[{"x":317,"y":117},{"x":392,"y":98},{"x":401,"y":135},{"x":326,"y":154}],"location":{"bottom":154,"left":317,"right":401,"top":98},"recognizedLanguage":"und"},{"content":"peach","cornerPoint":[{"x":403,"y":101},{"x":476,"y":83},{"x":483,"y":116},{"x":410,"y":134}],"location":{"bottom":134,"left":403,"right":483,"top":83},"recognizedLanguage":"und"}]}]}]}


		

		// const tmpData1 = {"x":"0.76","y":"0.36"}
		// const tmpData1 = {"page_id":"5","book_name":"Oxford_Phonics_World_1_SB"}
		
		// const tmpData1 = {"allText":"juicy peach","block":[{"line":[{"word":[{"content":"juicy","cornerPoint":[{"x":317,"y":117},{"x":392,"y":98},{"x":401,"y":135},{"x":326,"y":154}],"location":{"bottom":154,"left":317,"right":401,"top":98},"recognizedLanguage":"und"},{"content":"peach","cornerPoint":[{"x":403,"y":101},{"x":476,"y":83},{"x":483,"y":116},{"x":410,"y":134}],"location":{"bottom":134,"left":403,"right":483,"top":83},"recognizedLanguage":"und"}]}]}]}
		// const tmpData1 =  {"allText":"book\nruler\npencil","block":[{"line":[{"word":[{"content":"book","cornerPoint":[{"x":265,"y":72},{"x":343,"y":76},{"x":341,"y":102},{"x":263,"y":98}],"location":{"bottom":102,"left":263,"right":343,"top":72},"recognizedLanguage":"und"}]}]},{"line":[{"word":[{"content":"ruler","cornerPoint":[{"x":277,"y":114},{"x":345,"y":114},{"x":344,"y":139},{"x":276,"y":139}],"location":{"bottom":139,"left":276,"right":345,"top":114},"recognizedLanguage":"und"}]},{"word":[{"content":"pencil","cornerPoint":[{"x":277,"y":142},{"x":338,"y":133},{"x":341,"y":160},{"x":280,"y":169}],"location":{"bottom":169,"left":277,"right":341,"top":133},"recognizedLanguage":"und"}]}]}]}
		// const tmpData1 =  {  "allText" : "book\nhelle\nfioe",  "block" : [    {      "line" : [        {          "word" : [            {              "content" : "book",              "location" : {                "bottom" : 466.4888916015625,                "top" : 418.13333129882812,                "right" : 278.39999389648438,                "left" : 220.80000305175781              },              "cornerPoint" : [                {                  "x" : 147,                  "y" : 139                },                {                  "x" : 147.81631469726562,                  "y" : 173.990478515625                },                {                  "x" : 163.81196594238281,                  "y" : 173.6173095703125                },                {                  "x" : 162.99565124511719,                  "y" : 138.6268310546875                }              ]            }          ]        }      ]    },    {      "line" : [        {          "word" : [            {              "content" : "helle",              "location" : {                "bottom" : 568.888916015625,                "top" : 517.68890380859375,                "right" : 262.39999389648438,                "left" : 214.39999389648438              },              "cornerPoint" : [                {                  "x" : 184,                  "y" : 134                },                {                  "x" : 182.19378662109375,                  "y" : 162.94369506835938                },                {                  "x" : 198.1627197265625,                  "y" : 163.94023132324219                },                {                  "x" : 199.96893310546875,                  "y" : 134.99653625488281                }              ]            }          ]        }      ]    },    {      "line" : [        {          "word" : [            {              "content" : "fioe",              "location" : {                "bottom" : 950.04443359375,                "top" : 932.977783203125,                "right" : 572.79998779296875,                "left" : 547.20001220703125              },              "cornerPoint" : [                {                  "x" : 328,                  "y" : 343                },                {                  "x" : 328.23532104492188,                  "y" : 357.9981689453125                },                {                  "x" : 333.23471069335938,                  "y" : 357.91973876953125                },                {                  "x" : 332.9993896484375,                  "y" : 342.92156982421875                }              ]            }          ]        }      ]    }  ]}
		// const tmpData1 =  {"allText":"pooy","block":[{"line":[{"word":[{"content":"pooy","cornerPoint":[{"x":229,"y":143},{"x":229,"y":118},{"x":240,"y":118},{"x":240,"y":143}],"location":{"bottom":240,"left":145,"right":170,"top":229},"recognizedLanguage":"und"}]}]}]}
		// const tmpData1 = {"result":{"text":[{"left":0.4309999942779541,"right":0.5609999895095825,"top":0.5094433426856995,"bottom":0.5751649737358093,"score":0.8339493274688721,"content":"Cc","characters":[{"character":"C","centerLoc":[0.47766668,0.53908247],"poly":[0.45433334,0.50944334,0.50266665,0.50944334,0.50266665,0.56872165,0.45433334,0.56872165]},{"character":"c","centerLoc":[0.531,0.55068046],"poly":[0.5126667,0.53135055,0.551,0.53135055,0.551,0.56872165,0.5126667,0.56872165]}]}]}}
		// const tmpData1 = {"result":{"text":[{"left":0.4259999990463257,"right":0.5609999895095825,"top":0.5081546306610107,"bottom":0.5777422785758972,"score":0.8703044652938843,"content":"Cc","characters":[{"character":"C","centerLoc":[0.476,0.5377938],"poly":[0.451,0.50815463,0.501,0.50815463,0.501,0.56872165,0.451,0.56872165]},{"character":"c","centerLoc":[0.5276667,0.54939175],"poly":[0.5093334,0.53135055,0.54766667,0.53135055,0.54766667,0.56872165,0.5093334,0.56872165]}]}]}}
		// const tmpData1 =  {"result":{"text":[{"points":[0.749,0.505,0.601,0.522]}]}}
		// const tmpData1 = {"result":{"text":[{"symbol":[4,2,3,3,3]}]}};
		// const tmpData1 = {"result":{"text":[{"points":[0.20666666,0.45618558,0.21,0.45618558,0.21333334,0.45618558,0.21666667,0.45618558,0.22,0.45618558,0.22333333,0.45618558,0.22666667,0.45618558,0.23,0.45618558,0.23333333,0.45618558,0.2,0.45876288,0.20333333,0.45876288,0.20666666,0.45876288,0.21,0.45876288,0.21333334,0.45876288,0.21666667,0.45876288,0.22,0.45876288,0.22333333,0.45876288,0.22666667,0.45876288,0.23,0.45876288,0.23333333,0.45876288,0.23666666,0.45876288,0.24,0.45876288,0.19,0.46134022,0.19333333,0.46134022,0.19666667,0.46134022,0.2,0.46134022,0.20333333,0.46134022,0.20666666,0.46134022,0.21,0.46134022,0.21333334,0.46134022,0.21666667,0.46134022,0.22,0.46134022,0.22333333,0.46134022,0.22666667,0.46134022,0.23,0.46134022,0.23333333,0.46134022,0.23666666,0.46134022,0.24,0.46134022,0.24333334,0.46134022,0.24666667,0.46134022,0.25,0.46134022,0.17666666,0.46391752,0.18333334,0.46391752,0.18666667,0.46391752,0.19,0.46391752,0.19333333,0.46391752,0.19666667,0.46391752,0.24333334,0.46391752,0.24666667,0.46391752,0.25,0.46391752,0.25333333,0.46391752,0.25666666,0.46391752,0.26333332,0.46391752,0.17333333,0.46649486,0.17666666,0.46649486,0.18,0.46649486,0.18333334,0.46649486,0.25666666,0.46649486,0.26,0.46649486,0.26333332,0.46649486,0.26666668,0.46649486,0.17,0.46907216,0.17333333,0.46907216,0.17666666,0.46907216,0.26333332,0.46907216,0.26666668,0.46907216,0.27,0.46907216,0.16333333,0.4716495,0.16666667,0.4716495,0.17,0.4716495,0.17333333,0.4716495,0.26666668,0.4716495,0.27,0.4716495,0.27333334,0.4716495,0.27666667,0.4716495,0.16,0.4742268,0.16333333,0.4742268,0.16666667,0.4742268,0.27333334,0.4742268,0.27666667,0.4742268,0.28,0.4742268,0.15666667,0.47680414,0.16,0.47680414,0.16333333,0.47680414,0.27666667,0.47680414,0.28,0.47680414,0.28333333,0.47680414,0.15666667,0.47938144,0.16,0.47938144,0.28,0.47938144,0.28333333,0.47938144,0.15333334,0.48195878,0.15666667,0.48195878,0.28333333,0.48195878,0.28666666,0.48195878,0.14666666,0.48453608,0.15,0.48453608,0.15333334,0.48453608,0.28666666,0.48453608,0.29,0.48453608,0.29333332,0.48453608,0.14666666,0.48711342,0.15,0.48711342,0.15333334,0.48711342,0.28666666,0.48711342,0.29,0.48711342,0.29333332,0.48711342,0.14333333,0.48969072,0.14666666,0.48969072,0.15,0.48969072,0.29,0.48969072,0.29333332,0.48969072,0.29666665,0.48969072,0.14333333,0.49226806,0.14666666,0.49226806,0.29333332,0.49226806,0.29666665,0.49226806,0.14333333,0.49484536,0.29666665,0.49484536,0.14,0.4974227,0.14333333,0.4974227,0.29666665,0.4974227,0.3,0.4974227,0.14,0.5,0.3,0.5,0.13666667,0.5025773,0.14,0.5025773,0.3,0.5025773,0.30333334,0.5025773,0.13666667,0.5051546,0.14,0.5051546,0.3,0.5051546,0.30333334,0.5051546,0.13333334,0.507732,0.13666667,0.507732,0.14,0.507732,0.3,0.507732,0.30333334,0.507732,0.30666667,0.507732,0.13333334,0.5103093,0.13666667,0.5103093,0.30333334,0.5103093,0.30666667,0.5103093,0.13333334,0.5128866,0.13666667,0.5128866,0.30333334,0.5128866,0.30666667,0.5128866,0.13333334,0.5154639,0.13666667,0.5154639,0.30333334,0.5154639,0.30666667,0.5154639,0.13333334,0.51804125,0.13666667,0.51804125,0.30333334,0.51804125,0.30666667,0.51804125,0.13333334,0.52061856,0.13666667,0.52061856,0.30333334,0.52061856,0.30666667,0.52061856,0.13333334,0.52319586,0.13666667,0.52319586,0.30333334,0.52319586,0.30666667,0.52319586,0.13,0.52577317,0.13333334,0.52577317,0.13666667,0.52577317,0.30333334,0.52577317,0.30666667,0.52577317,0.31,0.52577317,0.13333334,0.52835053,0.13666667,0.52835053,0.30333334,0.52835053,0.30666667,0.52835053,0.13333334,0.53092784,0.13666667,0.53092784,0.30333334,0.53092784,0.30666667,0.53092784,0.13333334,0.53350514,0.13666667,0.53350514,0.30333334,0.53350514,0.30666667,0.53350514,0.13333334,0.53608245,0.13666667,0.53608245,0.30333334,0.53608245,0.30666667,0.53608245,0.13333334,0.5386598,0.13666667,0.5386598,0.30333334,0.5386598,0.30666667,0.5386598,0.13333334,0.5412371,0.13666667,0.5412371,0.30333334,0.5412371,0.30666667,0.5412371,0.13333334,0.5438144,0.13666667,0.5438144,0.14,0.5438144,0.3,0.5438144,0.30333334,0.5438144,0.30666667,0.5438144,0.13666667,0.5463917,0.14,0.5463917,0.3,0.5463917,0.30333334,0.5463917,0.13666667,0.5489691,0.14,0.5489691,0.3,0.5489691,0.30333334,0.5489691,0.14,0.5515464,0.3,0.5515464,0.14,0.5541237,0.14333333,0.5541237,0.29666665,0.5541237,0.3,0.5541237,0.14333333,0.556701,0.29666665,0.556701,0.14333333,0.55927837,0.14666666,0.55927837,0.29333332,0.55927837,0.29666665,0.55927837,0.14333333,0.5618557,0.14666666,0.5618557,0.15,0.5618557,0.29,0.5618557,0.29333332,0.5618557,0.29666665,0.5618557,0.14666666,0.564433,0.15,0.564433,0.15333334,0.564433,0.28666666,0.564433,0.29,0.564433,0.29333332,0.564433,0.14666666,0.5670103,0.15,0.5670103,0.15333334,0.5670103,0.28666666,0.5670103,0.29,0.5670103,0.29333332,0.5670103,0.15333334,0.56958765,0.15666667,0.56958765,0.28333333,0.56958765,0.28666666,0.56958765,0.15666667,0.57216495,0.16,0.57216495,0.28,0.57216495,0.28333333,0.57216495,0.15666667,0.57474226,0.16,0.57474226,0.16333333,0.57474226,0.27666667,0.57474226,0.28,0.57474226,0.28333333,0.57474226,0.16,0.57731956,0.16333333,0.57731956,0.16666667,0.57731956,0.27333334,0.57731956,0.27666667,0.57731956,0.28,0.57731956,0.16333333,0.5798969,0.16666667,0.5798969,0.17,0.5798969,0.17333333,0.5798969,0.26666668,0.5798969,0.27,0.5798969,0.27333334,0.5798969,0.27666667,0.5798969,0.17,0.58247423,0.17333333,0.58247423,0.17666666,0.58247423,0.26333332,0.58247423,0.26666668,0.58247423,0.27,0.58247423,0.17333333,0.58505154,0.17666666,0.58505154,0.18,0.58505154,0.18333334,0.58505154,0.25666666,0.58505154,0.26,0.58505154,0.26333332,0.58505154,0.26666668,0.58505154,0.17666666,0.58762884,0.18333334,0.58762884,0.18666667,0.58762884,0.19,0.58762884,0.19333333,0.58762884,0.19666667,0.58762884,0.24333334,0.58762884,0.24666667,0.58762884,0.25,0.58762884,0.25333333,0.58762884,0.25666666,0.58762884,0.26333332,0.58762884,0.19,0.5902062,0.19333333,0.5902062,0.19666667,0.5902062,0.2,0.5902062,0.20333333,0.5902062,0.20666666,0.5902062,0.21,0.5902062,0.21333334,0.5902062,0.21666667,0.5902062,0.22,0.5902062,0.22333333,0.5902062,0.22666667,0.5902062,0.23,0.5902062,0.23333333,0.5902062,0.23666666,0.5902062,0.24,0.5902062,0.24333334,0.5902062,0.24666667,0.5902062,0.25,0.5902062,0.2,0.5927835,0.20333333,0.5927835,0.20666666,0.5927835,0.21,0.5927835,0.21333334,0.5927835,0.21666667,0.5927835,0.22,0.5927835,0.22333333,0.5927835,0.22666667,0.5927835,0.23,0.5927835,0.23333333,0.5927835,0.23666666,0.5927835,0.24,0.5927835,0.20666666,0.5953608,0.21,0.5953608,0.21333334,0.5953608,0.21666667,0.5953608,0.22,0.5953608,0.22333333,0.5953608,0.22666667,0.5953608,0.23,0.5953608,0.23333333,0.5953608]}]}}


		// const tmpData1 = {"result":{"text":[{"type":1,"points":[0.23666666,0.45360824,0.24,0.45360824,0.22,0.45618558,0.22333333,0.45618558,0.22666667,0.45618558,0.23,0.45618558,0.23333333,0.45618558,0.24333334,0.45618558,0.24666667,0.45618558,0.25,0.45618558,0.25333333,0.45618558,0.25666666,0.45618558,0.26,0.45618558,0.20666666,0.45876288,0.21,0.45876288,0.21333334,0.45876288,0.21666667,0.45876288,0.26333332,0.45876288,0.26666668,0.45876288,0.27,0.45876288,0.27333334,0.45876288,0.19666667,0.46134022,0.2,0.46134022,0.20333333,0.46134022,0.27666667,0.46134022,0.28,0.46134022,0.28333333,0.46134022,0.17666666,0.46391752,0.18,0.46391752,0.18333334,0.46391752,0.18666667,0.46391752,0.19,0.46391752,0.19333333,0.46391752,0.28666666,0.46391752,0.29,0.46391752,0.29333332,0.46391752,0.29666665,0.46391752,0.3,0.46391752,0.30333334,0.46391752,0.30666667,0.46391752,0.31,0.46391752,0.31333333,0.46391752,0.31666666,0.46391752,0.32,0.46391752,0.32333332,0.46391752,0.32666665,0.46391752,0.17,0.46649486,0.17333333,0.46649486,0.28666666,0.46649486,0.33,0.46649486,0.33333334,0.46649486,0.33666667,0.46649486,0.34,0.46649486,0.34333333,0.46649486,0.34666666,0.46649486,0.35,0.46649486,0.35333332,0.46649486,0.35666665,0.46649486,0.36,0.46649486,0.36333334,0.46649486,0.36666667,0.46649486,0.37,0.46649486,0.16666667,0.46907216,0.28666666,0.46907216,0.16333333,0.4716495,0.28666666,0.4716495,0.16333333,0.4742268,0.28666666,0.4742268,0.16333333,0.47680414,0.28666666,0.47680414,0.16,0.47938144,0.28666666,0.47938144,0.16,0.48195878,0.28666666,0.48195878,0.16,0.48453608,0.28666666,0.48453608,0.16,0.48711342,0.29,0.48711342,0.15666667,0.48969072,0.29,0.48969072,0.15333334,0.49226806,0.29,0.49226806,0.15333334,0.49484536,0.29,0.49484536,0.15333334,0.4974227,0.29,0.4974227,0.15,0.5,0.29,0.5,0.15,0.5025773,0.29,0.5025773,0.15,0.5051546,0.29,0.5051546,0.15,0.507732,0.28666666,0.507732,0.15,0.5103093,0.28666666,0.5103093,0.15,0.5128866,0.28666666,0.5128866,0.15,0.5154639,0.28666666,0.5154639,0.15,0.51804125,0.28666666,0.51804125,0.15,0.52061856,0.28666666,0.52061856,0.15,0.52319586,0.28333333,0.52319586,0.15333334,0.52577317,0.28333333,0.52577317,0.15333334,0.52835053,0.28,0.52835053,0.15333334,0.53092784,0.27666667,0.53092784,0.15333334,0.53350514,0.27333334,0.53350514,0.15333334,0.53608245,0.26666668,0.53608245,0.27,0.53608245,0.15333334,0.5386598,0.25666666,0.5386598,0.26,0.5386598,0.26333332,0.5386598,0.15666667,0.5412371,0.25,0.5412371,0.25333333,0.5412371,0.15666667,0.5438144,0.24333334,0.5438144,0.24666667,0.5438144,0.15666667,0.5463917,0.23333333,0.5463917,0.23666666,0.5463917,0.24,0.5463917,0.16,0.5489691,0.23,0.5489691,0.16333333,0.5515464,0.22333333,0.5515464,0.22666667,0.5515464,0.16666667,0.5541237,0.17,0.5541237,0.17333333,0.5541237,0.17666666,0.5541237,0.18,0.5541237,0.18333334,0.5541237,0.18666667,0.5541237,0.19,0.5541237,0.19333333,0.5541237,0.19666667,0.5541237,0.2,0.5541237,0.20333333,0.5541237,0.20666666,0.5541237,0.21,0.5541237,0.21333334,0.5541237,0.21666667,0.5541237,0.22,0.5541237]}]}}
		// const tmpData1 = {"result":{"text":[{"left":0.22833333909511566,"right":0.3166666626930237,"top":0.5590206384658813,"bottom":0.628608226776123,"score":0.8552894592285156,"content":"Aa"},{"left":0.6816666126251221,"right":0.7666666507720947,"top":0.42257729172706604,"bottom":0.49860823154449463,"score":0.8148108720779419,"content":"Aa"},{"left":0.6983333230018616,"right":0.7666666507720947,"top":0.5564433336257935,"bottom":0.628608226776123,"score":0.7532452344894409,"content":"Aa"}]}}
		// const tmpData1 = {"result":{"text":[{"left":0.09814612567424774,"right":0.4471101462841034,"top":0.006644518114626408,"bottom":0.15614618360996246,"score":1,"content":"CTrace,write,and say."},{"left":0.10796073824167252,"right":0.5049073100090027,"top":0.1827242523431778,"bottom":0.4518272280693054,"score":0.9702169299125671,"content":"AAAA"},{"left":0.5834242105484009,"right":0.659760057926178,"top":0.17607973515987396,"bottom":0.4485049843788147,"score":0.9523985981941223,"content":"A"},{"left":0.6706652045249939,"right":0.8298800587654114,"top":0.15614618360996246,"bottom":0.43853819370269775,"score":0.9089533090591431,"content":"A"},{"left":0.5866957306861877,"right":0.6521264910697937,"top":0.634551465511322,"bottom":0.8504983186721802,"score":0.8326067328453064,"content":"a"},{"left":0.7699018716812134,"right":0.8276990056037903,"top":0.6411960124969482,"bottom":0.8039867281913757,"score":0.8035371899604797,"content":"a"}]}}
		cb(tmpData1);
		return;
	// const tmpData = {"allText":"Look and Trace\nblackboard\nwindow","block":[{"line":[{"word":[{"content":"Look","cornerPoint":[{"x":87,"y":203},{"x":83,"y":166},{"x":93,"y":164},{"x":97,"y":201}],"location":{"bottom":97,"left":85,"right":124,"top":83},"recognizedLanguage":"und"},{"content":"and","cornerPoint":[{"x":85,"y":161},{"x":82,"y":138},{"x":90,"y":137},{"x":93,"y":160}],"location":{"bottom":93,"left":127,"right":151,"top":82},"recognizedLanguage":"und"},{"content":"Trace","cornerPoint":[{"x":81,"y":132},{"x":77,"y":96},{"x":86,"y":95},{"x":90,"y":131}],"location":{"bottom":90,"left":156,"right":193,"top":77},"recognizedLanguage":"und"}]}]},{"line":[{"word":[{"content":"blackboard","cornerPoint":[{"x":119,"y":129},{"x":116,"y":58},{"x":131,"y":57},{"x":134,"y":128}],"location":{"bottom":134,"left":159,"right":231,"top":116},"recognizedLanguage":"und"}]}]},{"line":[{"word":[{"content":"window","cornerPoint":[{"x":171,"y":123},{"x":166,"y":72},{"x":177,"y":70},{"x":182,"y":121}],"location":{"bottom":182,"left":165,"right":218,"top":166},"recognizedLanguage":"und"}]}]}]}
		// const tmpData = {"allText":"Trace ttre letters\nLook! She is Short\nShe is a\ngirl.\nShe is a\ngirl.\nShe is smiling. She is","block":[{"line":[{"word":[{"content":"Trace","cornerPoint":[{"x":460,"y":366},{"x":416,"y":366},{"x":416,"y":354},{"x":460,"y":354}],"location":{"bottom":126,"left":20,"right":64,"top":114},"recognizedLanguage":"und"},{"content":"ttre","cornerPoint":[{"x":412,"y":367},{"x":387,"y":367},{"x":387,"y":354},{"x":412,"y":354}],"location":{"bottom":126,"left":68,"right":93,"top":113},"recognizedLanguage":"und"},{"content":"letters","cornerPoint":[{"x":384,"y":367},{"x":334,"y":367},{"x":334,"y":354},{"x":384,"y":354}],"location":{"bottom":126,"left":96,"right":146,"top":113},"recognizedLanguage":"und"}]}]},{"line":[{"word":[{"content":"Look!","cornerPoint":[{"x":340,"y":316},{"x":300,"y":318},{"x":299,"y":305},{"x":339,"y":303}],"location":{"bottom":177,"left":140,"right":181,"top":162},"recognizedLanguage":"und"}]}]}]}
		// const tmpData = {"allText":"e-Tnace the lettEr5\nAa Aa\nAa\nB b Bb Bbb\nBb\nCc\nCc","block":[{"line":[{"word":[{"content":"e-Tnace","cornerPoint":[{"x":399,"y":393},{"x":317,"y":395},{"x":316,"y":379},{"x":398,"y":377}],"location":{"bottom":103,"left":81,"right":164,"top":85},"recognizedLanguage":"und"},{"content":"the","cornerPoint":[{"x":313,"y":396},{"x":282,"y":396},{"x":281,"y":380},{"x":312,"y":380}],"location":{"bottom":100,"left":167,"right":199,"top":84},"recognizedLanguage":"und"},{"content":"lettEr5","cornerPoint":[{"x":278,"y":397},{"x":217,"y":398},{"x":216,"y":382},{"x":277,"y":381}],"location":{"bottom":99,"left":202,"right":264,"top":82},"recognizedLanguage":"und"}]}]},{"line":[{"word":[{"content":"Aa","cornerPoint":[{"x":436,"y":362},{"x":349,"y":363},{"x":348,"y":322},{"x":435,"y":321}],"location":{"bottom":159,"left":44,"right":132,"top":117},"recognizedLanguage":"und"}]}]}]}

		cb(tmpData);
	},


	checkGameEnd( arr ) {

		console.log(' in checkGameEnd arr.length: ', arr.length);
		if (!arr) {
			arr = this.animaNodeArr;
		}
		const isEnd = arr.every(node => {
			return node.isShowEnd;
		})

		if (isEnd) {
			this.gameEnd();
		} else {


			// this.endTesting();

			// setTimeout(() => {
			// 	this.startTesting();
			// }, 8000);

		}
	},














	bigStarArr: null,
	initStar() {
		const gArr = this.data.groupArr;
		if (gArr.length <= 1) {
			return;
		}

		this.cleanStar();

		this.bigStarArr = [];

		let baseX = this.canvas.width / 2 - 80 * this._mapScaleMin;
		let baseY = this.canvas.height / 2 - 80 * this._mapScaleMin;
		let disH = 80 * this._mapScaleMin;
		let disScale = 1;
		if (gArr.length > 5) {
			disH = (400 / gArr.length) * this._mapScaleMin;
			disScale = 5 / gArr.length;
		}
		for (let i = 0; i < gArr.length; i++) {
			const starBg = getSprNode('star_bg');
			this.canvas.addChild(starBg, 10);
			starBg.x = baseX;
			starBg.y = baseY - i * disH;
			starBg.scale = disScale;

			const starTop = getSprNode('star');
			starBg.addChild(starTop);
			starTop.active = false;
			starBg.star = starTop;

			const starBig = getSprNode('icon_bigstar');
			starTop.addChild(starBig);
			starBig.angle = -90;
			starBg.starBig = starBig;

			this.bigStarArr.push(starBg);
		}

		console.log("bigStarArr: ", this.bigStarArr);
	},

	cleanStar() {
		if (this.bigStarArr && this.bigStarArr.length > 0) {
			for (let i=0; i<this.bigStarArr.length; i++) {
				this.bigStarArr[i].removeFromParent();
			}
		}
	},


	showBigStar() {
		if (!this.bigStarArr || this.bigStarArr.length <= 0) {
			this.checkGameEnd();
			return;
		}
		const bigStarBg = this.bigStarArr[this.curGroupIndex];

		const starBig = bigStarBg.starBig;
		starBig.scale = 1;
		const star = bigStarBg.star;
		star.active = true;
		star.scaleX = 0.7 / bigStarBg.scale;
		star.scaleY = 1 / bigStarBg.scale;
		star.angle = 90;
		const canvas = cc.find('Canvas');
		const startPos = exchangeNodePos(star.parent, canvas, cc.v2(0, -canvas.height / 2));
		const middlePos = exchangeNodePos(star.parent, canvas, cc.v2(0, -canvas.height / 4));
		star.x = startPos.x;
		star.y = startPos.y - starBig.height;

		console.log('middlePos = ' + JSON.stringify(middlePos));
		const time = 1;
		cc.tween(star)
			.to(0.3, { y: middlePos.y + 80 }, { easing: 'quadOut' })
			.to(0.1, { y: middlePos.y + 40, scaleX: 1.2 / bigStarBg.scale, scaleY: 0.8 / bigStarBg.scale }, { easing: 'quadOut' })
			.to(0.1, { y: middlePos.y, scaleX: 1 / bigStarBg.scale, scaleY: 1 / bigStarBg.scale }, { easing: 'quadOut' })
			.delay(0.1)
			.to(0.8, { angle: -720, scale: 1 })
			.start();

		cc.tween(star)
			.delay(0.6)
			.to(0.8, { x: 0 }, { easing: 'quadIn' })
			.start();
		cc.tween(star)
			.delay(0.6)
			.to(0.8, { y: 0 }, { easing: 'quadOut' })
			.start();

		cc.tween(starBig)
			.delay(0.6)
			.to(0.8, { scale: 0 }, { easing: 'quadOut' })
			.call(() => {
				this.checkGameEnd();
				playAudio(this.starCountClip);
			})
			.start();

		playAudio(this.bigStarClip);
	},

	// checkGameEnd() {
	
	// 	this.curGroupIndex ++;
	// 	this.setCurGroupAndQuestion();



	// 	if (!this.curQuestionData) {
	// 		// this.gameEnd();
	// 		return;
	// 	}

	// 	this.showChangeQuesAnim();
	// },

	


	checkBtn: null,
	initBtn() {
		const checkBtn = getSprNode("btn_check");
		checkBtn.scale = this._mapScaleMin;
		this.canvas.addChild(checkBtn);
		checkBtn.x = -500 * this._mapScaleMin;
		checkBtn.y = -35 * this._mapScaleMin;
		checkBtn.baseX = checkBtn.x;
		checkBtn.baseY = checkBtn.y;
		checkBtn.opacity = 0;
		this.checkBtn = checkBtn;

		checkBtn.on(cc.Node.EventType.TOUCH_START, () => {
			if (checkBtn.opacity == 0) {
				return;
			}
			showBtnAnima(checkBtn);
			this.checkBtnClick();
		})

	},

	refreshCheckBtn() {

		this.checkBtn.opacity = 0;

		const arr = this.curOptionArr;
		for (let i=0; i<arr.length; i++) {
			if (arr[i].light.opacity > 254) {
				this.checkBtn.opacity = 255;
				return;
			}
		}
	},

	tryagain: null,
	initIcon() {
		const icon = getSprNode("try_again");
		icon.opacity = 0;
		icon.scale = this._mapScaleMin;
		this.canvas.addChild(icon);

		this.tryagain = icon;
	},

	showTryAgain() {
		const time = 0.3;
		cc.tween(this.tryagain)
			.to(time, {opacity: 255}, {easing: "cubicOut"})
			.delay(0.3)
			.to(time, {opacity: 0}, {easing: "cubicIn"})
			.start();
	},


	initQuestion() {
		// this.initPicQuestion();
		// this.initTextQuestion();
		// this.initVideoQuestion();
		// this.initAudioQuestion();
	},

	quesPicBg: null,
	initPicQuestion() {
		const picBg = getSprNode("ques_pic_bg");
		this.canvas.addChild(picBg);
		picBg.scale = this._mapScaleMin;
		picBg.y = 130 * this._mapScaleMin
		this.quesPicBg = picBg;
		picBg.active = false;

		this.addQuesAudio(picBg)
	},

	quesTextBg: null,
	initTextQuestion() {
		const picBg = getSprNode("ques_pic_bg");
		this.canvas.addChild(picBg);
		picBg.scale = this._mapScaleMin;
		picBg.y = 130 * this._mapScaleMin
		this.quesTextBg = picBg;


		const labelNode = new cc.Node();
		labelNode.parent = picBg;
		const label = labelNode.addComponent(cc.RichText);
		const size = 80
		label.font = cc.find('Canvas/res/font/Berlin-Sans-FB').getComponent(cc.Label).font;
		// label.string = `<outline color=#a83c13 width=2><size=${size}><color=#ffffff>${this.data.title || " " }</color></size></outline>`
		// label.string = `<size=${size}><color=#751e00>${this.curGroup.title }</color></size>`
		label.lineHeight = size;
		label.horizontalAlign = cc.macro.TextAlignment.CENTER

		label.maxWidth = 648;
	
		picBg.label = label;

		picBg.active = false;
		this.addQuesAudio(picBg)
	},

	quesVideoBg: null,
	videoNode: null,
	initVideoQuestion() {
		const picBg = getSprNode("ques_pic_bg");
		this.canvas.addChild(picBg);
		picBg.scale = this._mapScaleMin;
		picBg.y = 130 * this._mapScaleMin
		this.quesVideoBg = picBg;

		const videoNode = new cc.Node();
		const vPlayer = videoNode.addComponent(cc.VideoPlayer);
		picBg.addChild(videoNode);

		videoNode.width = 678;
		videoNode.height = 396;
		this.videoNode = videoNode;

		picBg.video = vPlayer;


		const btnNode = new cc.Node();
		picBg.addChild(btnNode);
		btnNode.x = picBg.width / 2 + 50;

		const playBtn = getSprNode("video_play");
		btnNode.addChild(playBtn);

		const pauseBtn = getSprNode("video_pause");
		btnNode.addChild(pauseBtn);
		pauseBtn.active = false;


		videoNode.player = vPlayer;
		videoNode.playBtn = playBtn;
		videoNode.pauseBtn = pauseBtn;

		playBtn.on(cc.Node.EventType.TOUCH_START, () => {
			vPlayer.play();
			playBtn.active = false;
			pauseBtn.active = true;
		})

		pauseBtn.on(cc.Node.EventType.TOUCH_START, () => {
			vPlayer.pause();
			pauseBtn.active = false;
			playBtn.active = true;
		})

		videoNode.on('completed', () => {
			pauseBtn.active = false;
			playBtn.active = true;
		})


		picBg.active = false;
	},

	quesAudioBg: null,
	initAudioQuestion() {

		
		const audioNode = new cc.Node();
		audioNode.active = false;

		this.canvas.addChild(audioNode);
		audioNode.x = 440 * this._mapScaleMin;
		audioNode.y = -60 * this._mapScaleMin;
		this.quesAudioBg = audioNode;
		
		const audioAnimNode = cc.instantiate(cc.find("Canvas/res/anim/audio_big"));
		audioNode.addChild(audioAnimNode);

		const iconTop = getSprNode('audio_big')
		audioNode.addChild(iconTop);
		iconTop.opacity = 255;

		iconTop.addComponent(cc.BlockInputEvents);
		iconTop.on(cc.Node.EventType.TOUCH_START, () => {

			if (iconTop.opacity == 0) {
				return;
			}

			if (!audioNode.audioClip) {
				return;
			}
			const anim = audioAnimNode.getComponent(cc.Animation);
			anim.play('audio_big');
			iconTop.opacity = 0;
			audioAnimNode.opacity = 255;

			if (audioNode.audioClip) {
				playAudio(audioNode.audioClip, () => {
					iconTop.opacity = 255;
					audioAnimNode.opacity = 0;
					anim.stop();
				});
			}
		})

	},


	addQuesAudio(bg) {
		const audioNode = new cc.Node();
		bg.addChild(audioNode);
		audioNode.x = bg.width / 2 + 50;


		const audioAnimNode = cc.instantiate(cc.find("Canvas/res/anim/ques_audio"));
		audioNode.addChild(audioAnimNode);

		const iconTop = getSprNode('ques_audio')
		audioNode.addChild(iconTop);
		iconTop.opacity = 255;

		iconTop.addComponent(cc.BlockInputEvents);
		iconTop.on(cc.Node.EventType.TOUCH_START, () => {

			if (iconTop.opacity == 0) {
				return;
			}
			const anim = audioAnimNode.getComponent(cc.Animation);
			anim.play('ques_audio');
			iconTop.opacity = 0;
			audioAnimNode.opacity = 255;

			if (audioNode.audioClip) {
				playAudio(audioNode.audioClip, () => {
					if (this.isDestroy) {
						return;
					}
					iconTop.opacity = 255;
					audioAnimNode.opacity = 0;
					anim.stop();
				});
			}
		})

		bg.audioNode = audioNode;
	},

	initOption() {
		this.initPicOption();
		this.initAudioOption();
		this.initTextOption();

		this.initPicOptionBig();
		this.initAudioOptionBig();
		this.initTextOptionBig();
	},

	optionPicBgArr: null,
	initPicOption() {
		// console.log('this.data: ', this.data);
		this.optionPicBgArr = [];
		for (let i=0; i<4; i++) {
		
			const pic = this.getOnePicOption();
			this.canvas.addChild(pic);
			pic.scale = this._mapScaleMin;
			pic.y = -235 * this._mapScaleMin;
			this.optionPicBgArr.push(pic);

		} 
	},

	optionPicBgBigArr: null,
	initPicOptionBig() {
		this.optionPicBgBigArr = [];

		const baseX = -380 * this._mapScaleMin;
		const disW = 440 * this._mapScaleMin;
		let baseY = 170 * this._mapScaleMin;
		const disH = 350 * this._mapScaleMin;
		let count = 0;


		for (let i=0; i<4; i++) {
		
			if (i==2) {
				count = 0;
				baseY -= disH;
			}
			const pic = this.getOnePicOption(true);
			this.canvas.addChild(pic);
			pic.scale = this._mapScaleMin;
			pic.x = baseX + count * disW;
			pic.y = baseY;
			this.optionPicBgBigArr.push(pic);

			count ++;
		} 
	},

	getOnePicOption(isBig = false) {
		const picBgParent = new cc.Node();

		let lightResName = "option_pic_bg_l";
		let bgResName = "option_pic_bg";
		if (isBig) {
			lightResName = "op_pic_bg_big_l";
			bgResName = "op_pic_bg_big";
		}

		const light = getSprNode(lightResName);
		picBgParent.addChild(light);
		light.opacity = 0;
		picBgParent.light = light;

		const picBg = getSprNode(bgResName);
		picBgParent.addChild(picBg);
		picBgParent.picBg = picBg;

		picBgParent.width = picBg.width;
		picBgParent.height = picBg.height;


		const soundNode = new cc.Node();
		picBgParent.addChild(soundNode);
		picBgParent.soundIcon = soundNode;

		const soundIconAnim = cc.instantiate(cc.find("Canvas/res/anim/laba"))
		soundNode.addChild(soundIconAnim);
		soundIconAnim.opacity = 0;

		const soundIconTop = getSprNode('btn_laba')
		soundNode.addChild(soundIconTop);
		soundIconTop.opacity = 255;

		soundNode.x = picBgParent.width / 2 - soundIconTop.width / 2;
		soundNode.y = picBgParent.height / 2 //- soundIconTop.height / 2;
		soundNode.active = false;


		picBgParent.active = false;


		picBgParent.on(cc.Node.EventType.TOUCH_START, () => {
			if( light.opacity == 0 ) {
				light.opacity = 255;
				playAudio(this.selectClip);
			} else {
				light.opacity = 0;
			}

			this.refreshCheckBtn();
		})


		soundIconTop.addComponent(cc.BlockInputEvents);
		soundIconTop.on(cc.Node.EventType.TOUCH_START, () => {
			const anim = soundIconAnim.getComponent(cc.Animation);
			anim.play('laba');
			soundIconTop.opacity = 0;
			soundIconAnim.opacity = 255;

			if (soundNode.audioClip) {
				playAudio(soundNode.audioClip, () => {

					if (this.isDestroy) {
						return;
					}
					soundIconTop.opacity = 255;
					soundIconAnim.opacity = 0;
					anim.stop();
				});
			}
		})

		return picBgParent;
	},

	addIconRight(bg) {

		const px = bg.width / 2;
		const py = -bg.height / 2 ;
		const worldPos = bg.convertToWorldSpaceAR(cc.v2(px, py));
		const localPos = this.canvas.convertToNodeSpaceAR(worldPos);


		const iconRight = getSprNode('icon_right');
		iconRight.scale = this._mapScaleMin;
		this.canvas.addChild(iconRight, 1);
		iconRight.x = localPos.x;
		iconRight.y = localPos.y + 50 * this._mapScaleMin;

		bg.iconRight = iconRight;


		this.showOneFirework(cc.v2(0, -bg.height / 3), bg, cc.find('paperBase').children, 200, 300, 20, 1);
	},


	optionAudioBgArr: null,
	initAudioOption() {
		this.optionAudioBgArr = [];
		for (let i=0; i<4; i++) {
		
			const audio = this.getOneAudioOption();
			this.canvas.addChild(audio);
			audio.scale = this._mapScaleMin;
			audio.y = -235 * this._mapScaleMin;
			this.optionAudioBgArr.push(audio);
		} 
	},

	optionAudioBgBigArr: null,
	initAudioOptionBig() {

		this.optionAudioBgBigArr = [];

		const baseX = -380 * this._mapScaleMin;
		const disW = 440 * this._mapScaleMin;
		let baseY = 170 * this._mapScaleMin;
		const disH = 350 * this._mapScaleMin;
		let count = 0;

		for (let i=0; i<4; i++) {
		
			if (i==2) {
				count = 0;
				baseY -= disH;
			}

			const audio = this.getOneAudioOption(true);
			this.canvas.addChild(audio);
			audio.scale = this._mapScaleMin;
			audio.x = baseX + count * disW;
			audio.y = baseY;
			this.optionAudioBgBigArr.push(audio);

			count ++;
		} 
	},


	optionTextBgArr: null,
	initTextOption() {
		this.optionTextBgArr = [];
		for (let i=0; i<4; i++) {
		
			const textOption = this.getOneTextOption();
			this.canvas.addChild(textOption);
			textOption.scale = this._mapScaleMin;
			// textOption.y = -235 * this._mapScaleMin;
			this.optionTextBgArr.push(textOption);
		} 
	},

	optionTextBgBigArr: null,
	initTextOptionBig() {

		const baseX = -180 * this._mapScaleMin;
		const disW = 100 * this._mapScaleMin;
		let baseY = 220 * this._mapScaleMin;
		const disH = 150 * this._mapScaleMin;

		this.optionTextBgBigArr = [];
		for (let i=0; i<4; i++) {
		
			const textOption = this.getOneTextOption(true);
			this.canvas.addChild(textOption);
			textOption.scale = this._mapScaleMin;
			textOption.x = baseX;
			textOption.y = baseY - i * disH;
			this.optionTextBgBigArr.push(textOption);
		}
	},

	getOneAudioOption(isBig=false) {

		let lightResName = "option_pic_bg_l";
		let bgResName = "option_pic_bg";
		if (isBig) {
			lightResName = "op_pic_bg_big_l";
			bgResName = "op_pic_bg_big";
		}

		const audioBgNode = new cc.Node();

		const light = getSprNode(lightResName);
		audioBgNode.addChild(light);
		light.opacity = 0;
		audioBgNode.light = light;

		const picBg = getSprNode(bgResName);
		audioBgNode.addChild(picBg);
		audioBgNode.picBg = picBg;

		audioBgNode.width = picBg.width;
		audioBgNode.height = picBg.height;

		const animNode = cc.instantiate(cc.find("Canvas/res/anim/op_audio"))
		audioBgNode.addChild(animNode);
		animNode.anchorX = 0.6;


		const animTop = getSprNode('op_audio');
		audioBgNode.addChild(animTop);
		animTop.anchorX = 0.6;

		const anim = animNode.getComponent(cc.Animation);
		animNode.opacity = 0;

		audioBgNode.anim = anim;
		audioBgNode.animNode = animNode;
		audioBgNode.animTop = animTop;
		
		audioBgNode.showAnim = () => {
			this.playItemAnim(audioBgNode);
			cc.audioEngine.stop(audioBgNode.audioId);
		}
		audioBgNode.stopAnim = () => {
			cc.audioEngine.stop(audioBgNode.audioId);
			this.stopItemAnim(audioBgNode);
		}

		audioBgNode.on(cc.Node.EventType.TOUCH_START, () => {
			if( light.opacity == 0 ) {
				light.opacity = 255;
				playAudio(this.selectClip);
				
				audioBgNode.showAnim();
				if (audioBgNode.audioClip) {
					audioBgNode.audioId = playAudio(audioBgNode.audioClip, () => {
						this.stopItemAnim(audioBgNode);
					});
				}

			} else {
				light.opacity = 0;
				audioBgNode.stopAnim();
			}

			this.refreshCheckBtn();

		});

		audioBgNode.active = false;

		return audioBgNode;
	},

	getOneTextOption(isBig=false) {

		let lightResName = "option_text_bg_l";
		let bgResName = "option_text_bg";
		if (isBig) {
			lightResName = "op_text_bg_big_l";
			bgResName = "op_text_bg_big";
		}

		const textBgParent = new cc.Node();
		textBgParent.active = false;

		const light = getSprNode(lightResName);
		textBgParent.addChild(light);
		light.opacity = 0;
		textBgParent.light = light;

		const textBg = getSprNode(bgResName);
		textBgParent.addChild(textBg);
		textBgParent.textBg = textBg;

		textBgParent.width = textBg.width;
		textBgParent.height = textBg.height;

		const labelNode = new cc.Node();
		labelNode.parent = textBgParent;
		const label = labelNode.addComponent(cc.Label);

		label.fontSize = 56;
		label.lineHeight = 56;
		if (isBig) {
			label.fontSize = 64;
			label.lineHeight = 64;
		}

		label.font = cc.find('Canvas/res/font/Berlin-Sans-FB').getComponent(cc.Label).font;
		textBgParent.label = label;

		const color = new cc.Color();
		cc.Color.fromHEX(color, '#023659' );
		labelNode.color = color;


		const soundNode = new cc.Node();
		textBgParent.addChild(soundNode);
		textBgParent.soundIcon = soundNode;

		const soundIconAnim = cc.instantiate(cc.find("Canvas/res/anim/laba"))
		soundNode.addChild(soundIconAnim);
		soundIconAnim.opacity = 0;

		const soundIconTop = getSprNode('btn_laba')
		soundNode.addChild(soundIconTop);
		soundIconTop.opacity = 255;

		soundNode.x = textBgParent.width / 2 - 15; // - soundIconTop.width / 2;
		soundNode.y = textBgParent.height / 2 - 15; //- soundIconTop.height / 2;
		soundNode.active = false;


		textBgParent.on(cc.Node.EventType.TOUCH_START, () => {
			if( light.opacity == 0 ) {
				light.opacity = 255;
				playAudio(this.selectClip);
			} else {
				light.opacity = 0;
			}
			this.refreshCheckBtn();
		})


		soundIconTop.addComponent(cc.BlockInputEvents);
		soundIconTop.on(cc.Node.EventType.TOUCH_START, () => {
			const anim = soundIconAnim.getComponent(cc.Animation);
			anim.play('laba');
			soundIconTop.opacity = 0;
			soundIconAnim.opacity = 255;

			if (soundNode.audioClip) {
				playAudio(soundNode.audioClip, () => {
					soundIconTop.opacity = 255;
					soundIconAnim.opacity = 0;
					anim.stop();
				});
			}
		})

		return textBgParent;
	},

	playItemAnim(item) {
		item.anim.play();
		item.animNode.opacity = 255;
		item.animTop.opacity = 0;
	},

	stopItemAnim(item) {
		item.animNode.opacity = 0;
		item.animTop.opacity = 255;
	},

	setCurQuestion() {
		
		switch(this.curQuestionData.questionType) {
			case "pic":
				this.setQuestionPic();
				break;
			case "text":
				this.setQuestionText();
				break;
			case "video":
				this.setQuestionVideo();
				break;
			case "audio":
				this.setQuestionAudio();
				break;
		}

		this.refreshCheckBtnPos();
	},

	refreshCheckBtnPos() {
		if (this.curQuestionData.questionType == 'audio') {
			this.checkBtn.x = 440 * this._mapScaleMin;
			this.checkBtn.y = -240 * this._mapScaleMin;
		} else {
			this.checkBtn.x = this.checkBtn.baseX;
			this.checkBtn.y = this.checkBtn.baseY;
		}
	},

	curQuesBg: null,
	setQuestionPic() {

		this.curQuesBg = this.quesPicBg;
		this.curQuesBg.active = true;


		if (this.quesPicBg.pic) {
			this.quesPicBg.pic.removeFromParent();
			this.quesPicBg.pic = null;
		}
		if (this.curQuestionData.pic_url) {
			getSprNodeByUrl(this.curQuestionData.pic_url, (spr) => {
				const sprNode = spr.node;
				setSprNodeMaxLen(sprNode, 678, 396);
				this.quesPicBg.addChild(sprNode)
				this.quesPicBg.pic = sprNode;
			})
		}
	
		const audioNode = this.quesPicBg.audioNode;
		audioNode.active = false;
		audioNode.audioClip = null;
		if (this.curQuestionData.audio_url) {
			cc.assetManager.loadRemote(this.curQuestionData.audio_url, (err, audioClip) => {
				audioNode.audioClip = audioClip;
			});	
			audioNode.active = true;
		}
	},

	setQuestionText() {
		this.curQuesBg = this.quesTextBg;
		this.curQuesBg.active = true;

		
		const label = this.curQuesBg.label;
		const size = 80; 
		label.string = `<size=${size}><color=#fff4b6>${this.curQuestionData.text}</color></size>`

		const maxH = this.curQuesBg.height * 0.98;

		if (label.node.height > maxH) {
			label.node.scale = maxH / label.node.height
		} else {
			label.node.scale = 1;
		}


		const audioNode = this.curQuesBg.audioNode;
		audioNode.active = false;
		audioNode.audioClip = null;
		if (this.curQuestionData.audio_url) {
			cc.assetManager.loadRemote(this.curQuestionData.audio_url, (err, audioClip) => {
				audioNode.audioClip = audioClip;
			});	
			audioNode.active = true;
		}
	},

	setQuestionVideo() {
		this.curQuesBg = this.quesVideoBg;
		this.curQuesBg.active = true;
		this.videoNode.active = true;

		if (this.curQuestionData.video_url) {
			this.curQuesBg.video.remoteURL = this.curQuestionData.video_url;
		}
	},

	setQuestionAudio() {
		this.curQuesBg = this.quesAudioBg;
		this.curQuesBg.active = true;


		this.curQuesBg.audioClip = null;
		if (this.curQuestionData.audio_url) {
			cc.assetManager.loadRemote(this.curQuestionData.audio_url, (err, audioClip) => {
				this.curQuesBg.audioClip = audioClip;
			});
		}
	},



	setCurOption() {
		const arr = this.curQuestionData.answerArr;

		const isBig = this.curQuestionData.questionType == 'audio';

		switch(this.curQuestionData.answerType) {
			case "pic":
				this.setOptionPic(arr, isBig);
				break;
			case "audio":
				this.setOptionAudio(arr, isBig);
				break;
			case "text":
				this.setOptionText(arr, isBig);
				break;
		}
		
	},



	curOptionArr: null,
	setOptionPic(arr, isBig=false) {

		let opItemArr = this.optionPicBgArr;
		if (isBig) {
			opItemArr = this.optionPicBgBigArr;
		}
		this.curOptionArr = [];
		const disW = 158 * this._mapScaleMin;
		const baseX = -(arr.length - 1) * disW;
		for (let i=0; i<arr.length; i++) {
			
			opItemArr[i].active = true;
			if (!isBig) {
				opItemArr[i].x = baseX + i * disW * 2;
			}

			const picBg = opItemArr[i].picBg;
			picBg.removeAllChildren();
			
			const data = arr[i];
			if (data.pic_url) {
				getSprNodeByUrl, getSprNodeByUrl(data.pic_url, (spr) => {
					let maxW = 280;
					let maxH = 190;
					if (isBig) {
						maxW = 366;
						maxH = 248;
					}

					setSprNodeMaxLen(spr.node, maxW, maxH);
					console.log('spr: ', spr);
					picBg.addChild(spr.node);
				})
			}

			const soundIcon = opItemArr[i].soundIcon;
			soundIcon.active = false;
			soundIcon.audioClip = null;
			opItemArr[i].audioClip = null;
			if (data.audio_url) {
				cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
					soundIcon.audioClip = audioClip;
					opItemArr[i].audioClip = audioClip;
				});
				
				soundIcon.active = true;
			}

			opItemArr[i].data = data;
			this.curOptionArr.push(opItemArr[i]);
		}
	},


	setOptionAudio(arr, isBig=false) {

		let opItemArr = this.optionAudioBgArr;
		if (isBig) {
			opItemArr = this.optionAudioBgBigArr;
		}

		this.curOptionArr = [];
		const disW = 158 * this._mapScaleMin;
		const baseX = -(arr.length - 1) * disW;
		for (let i=0; i<arr.length; i++) {
			
			opItemArr[i].active = true;
			if(!isBig) {
				opItemArr[i].x = baseX + i * disW * 2;
			}

			const data = arr[i];

			opItemArr[i].audioClip = null;
			if (data.audio_url) {
				cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
					opItemArr[i].audioClip = audioClip;
				});
			}

			opItemArr[i].data = data;
			this.curOptionArr.push(opItemArr[i]);
		}
	},

	setOptionAudioBig(arr) {
		this.curOptionArr = [];
		for (let i=0; i<arr.length; i++) {
			
			this.optionAudioBgArr[i].active = true;

			const data = arr[i];

			this.optionAudioBgArr[i].audioClip = null;
			if (data.audio_url) {
				cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
					this.optionAudioBgArr[i].audioClip = audioClip;
				});
			}

			this.optionAudioBgArr[i].data = data;
			this.curOptionArr.push(this.optionAudioBgArr[i]);
		}
	},


	setOptionText(options, isBig=false) {

		console.log(' in setOptionText, isBig: ', isBig);

		let opItemArr = this.optionTextBgArr;
		if (isBig) {
			opItemArr = this.optionTextBgBigArr
		}

		this.curOptionArr = [];
		const disW = 315 * this._mapScaleMin;
		const disH = 120 * this._mapScaleMin;
		const baseX = - disW ;
		let baseY = -235 * this._mapScaleMin;
		if (options.length > 2) {
			baseY = -170 * this._mapScaleMin;
		}
		let count = 0;
		for (let i=0; i<options.length; i++) {

			if ( i == 2 ) {
				baseY -= disH;
				count = 0;
			}
			
			opItemArr[i].active = true;
			if (!isBig) {
				opItemArr[i].x = baseX + count * disW * 2;
				opItemArr[i].y = baseY;
			}
		
			const data = options[i];

			opItemArr[i].label.string = data.text;
			opItemArr[i].label["_forceUpdateRenderData"](true);
			if (opItemArr[i].label.node.width > opItemArr[i].width * 0.9) {
				opItemArr[i].label.node.scale = opItemArr[i].width * 0.9 / opItemArr[i].label.node.width;
			} else {
				opItemArr[i].label.node.scale = 1;
			}
			

			const soundIcon = opItemArr[i].soundIcon;
			soundIcon.active = false;
			soundIcon.audioClip = null;
			opItemArr[i].audioClip = null;
			if (data.audio_url) {
				cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
					soundIcon.audioClip = audioClip;
					opItemArr[i].audioClip = audioClip;
				});
				
				soundIcon.active = true;
			}

			opItemArr[i].data = data;
			this.curOptionArr.push(opItemArr[i]);

			count++;
		}
	},



	shakeArr: null,
	wrongArr: null,
	checkBtnClick() {

		this.shakeArr = [];
		this.wrongArr = [];
		this.checkItemWrong();

		if (this.wrongArr.length > 0) {
			//有选错的
			this.itemShake();
			this.hideLight();
			playAudio(this.wrongClip);
			return;
		}

		const isRightAll = this.checkItemRightCount();
		if (!isRightAll) {
			// 有漏选的
			this.itemShake();
			this.hideLight();
			playAudio(this.wrongClip);
			return;
		}

		this.showAllRight();
		this.showMask();

		playAudio(this.rightClip, () => {

			if (this.isDestroy) {
				return;
			}
			this.playAnswerAudio(0);
		})
		
	},

	playAnswerAudio(index) {
		const arr = this.curOptionArr;
		if (!arr[index]) {

			// delayCall(0.5, () => {
				this.changeNextQuestion();
			// })

		} else {
			if ( arr[index].light.opacity > 254 && arr[index].audioClip ) {
				playAudio(arr[index].audioClip, () => {

					if (this.isDestroy) {
						return;
					}
					this.playAnswerAudio(index + 1);
				})
			} else {
				this.playAnswerAudio(index + 1);
			}
		}
	},


	checkItemWrong() {
		const arr = this.curOptionArr;
		console.log('arr: ', arr);
		for (let i=0; i<arr.length; i++) {
			const itemBg = arr[i];
			if (itemBg.light.opacity >= 254) {
				this.shakeArr.push(itemBg);
				console.log('aaa', itemBg.data);;
				if (itemBg.data.answerRight == '0') {
					this.wrongArr.push(itemBg);
				}
			}
		}
	},

	checkItemRightCount() {
		let rightTotalCount = 0;
		const answerArr = this.curQuestionData.answerArr;
		for (let i=0; i<answerArr.length; i++) {
			if (answerArr[i].answerRight == '1') {
				rightTotalCount ++;
			}
		}

		let curRightCount = 0;
		const curOptionArr = this.curOptionArr;
		for (let i=0; i<curOptionArr.length; i++) {
			if (curOptionArr[i].light.opacity > 254) {
				curRightCount ++;
			}
		}

		return rightTotalCount == curRightCount;
	},

	itemShake() {
		let rate = 1;
		if (this.curQuestionData.answerType == 'text') {
			rate = 0.5;
		}

		const arr = this.shakeArr;
		for (let i=0; i<arr.length; i++) {
			this.rotateShake(arr[i], rate);
			if (arr[i].stopAnim) {
				arr[i].stopAnim();
			}
		}

		this.showTryAgain();
	},

	hideLight() {
		const arr = this.curOptionArr;
		for (let i=0; i<arr.length; i++) {
			arr[i].light.opacity = 0;
		}
		this.checkBtn.opacity = 0;
	},

	rotateShake(item, rate = 1) {

		const time = 0.9;
		cc.tween(item)
			.to(time / 6 / 2, {angle: -20 * rate}, {easing: 'sineInOut'})
			.to(time / 6, {angle: 12 * rate}, {easing: 'sineInOut'})
			.to(time / 6, {angle: -7 * rate}, {easing: 'sineInOut'})
			.to(time / 6, {angle: 4 * rate}, {easing: 'sineInOut'})
			.to(time / 6, {angle: -2 * rate}, {easing: 'sineInOut'})
			.to(time / 6, {angle: 1 * rate}, {easing: 'sineInOut'})
			.to(time / 6, {angle: 0 * rate}, {easing: 'sineInOut'})
			.start();

	},

	showAllRight() {
		const curOptionArr = this.curOptionArr;
		for (let i=0; i<curOptionArr.length; i++) {
			if (curOptionArr[i].light.opacity > 254) {
				this.addIconRight(curOptionArr[i]);
			}
		}
	},

	changeNextQuestion() {
		console.log(' in changeNextQuestion')

		this.curQuestionIndex ++ ;
		this.setCurQuestionData();

		if (!this.curQuestionData) {
			// this.gameEnd();
			return;
		}

		this.showChangeQuesAnim();
	
	},

	showChangeQuesAnim() {
		this.hideLight();

		this.hideCurOptionAnim(() => {

			if (this.isDestroy) {
				return;
			}
			this.setCurOption();
			this.showCurOptionAnim();
			this.hideMask();
		});

		this.hideCurQuestion(() => {

			if (this.isDestroy) {
				return;
			}
			this.setCurQuestion();
			this.showCurQuestionAnim();
		});
	},


	maskLayer: null,
	initMask() {
		const maskLayer = new cc.Node();
		maskLayer.width = this.canvas.width;
		maskLayer.height = this.canvas.height;
		this.canvas.addChild(maskLayer, 20);

		maskLayer.addComponent(cc.BlockInputEvents);
		this.maskLayer = maskLayer;
		this.maskLayer.active = false;
	},

	showMask() {
		this.maskLayer.active = true;
	},

	hideMask() {
		this.maskLayer.active = false;
	},

	hideCurOptionAnim(cb) {
		const arr = this.curOptionArr;
		const time = 0.5;
		for (let i=0; i<arr.length; i++) {
			if (arr[i].iconRight) {
				arr[i].iconRight.removeFromParent();
				arr[i].iconRight = null;
			}
			cc.tween(arr[i])
				.to(time, {opacity: 0}, {easing: "cubicOut"})
				.call(() => {
					arr[i].active = false;
				})
				.start();
		}
		delayCall(time, () => {
			cb();
		})
	},

	showCurOptionAnim(cb=null) {
		const arr = this.curOptionArr;
		const time = 0.5;
		for (let i=0; i<arr.length; i++) {
			arr[i].opacity = 0;
			cc.tween(arr[i])
				.to(time, {opacity: 255}, {easing: "cubicIn"})
				.start();
		}

		if (cb) {
			delayCall(time, () => {
				cb();
			})
		}
	
	},

	hideCurQuestion(cb) {
		const time = 0.5;
		cc.tween(this.curQuesBg)
			.to(time, {opacity: 0}, {easing: "cubicOut"})
			.call(() => {

				if (this.isDestroy) {
					return;
				}
				this.curQuesBg.active = false;
				cb();
			})
			.start();
	},

	showCurQuestionAnim() {

		this.curQuesBg.active = true;
		this.curQuesBg.opacity = 0;

		const time = 0.5;
		cc.tween(this.curQuesBg)
			.to(time, {opacity: 255}, {easing: "cubicIn"})
			.start();
	},


	changeStep() {

		this.typeArrIndex ++;
		
		if (!this.data.change_step_audio_url) {
			this.startTesting();
			return;
		}
		playAudioByUrl(this.data.change_step_audio_url, () => {
			this.startTesting();
		})

	},


	showAllWordSound() {
		console.log(' in showAllWordSound')
		for (let i=0; i<this.wordBgArr.length; i++) {
			const {wordSoundBtn} = this.wordBgArr[i];

			this.appearAnim(wordSoundBtn);
		}
	},

	gameEnd() {
		console.log('game end !')

		this.isGameEnd = true;
		// this.showAllWordSound();

		// playAudioByUrl(this.data.finish_right_audio_url, () => {
		delayCall(0.5, () => {

			if (this.isDestroy) {
				return;
			}

			// this.saveLearnHistory();

			this.restartNode.active = true;
	
			this.endTesting();
		})
		return;
		


		if (this.typeArrIndex < this.typeArr.length - 1) {

			this.changeStep();

			return;
		}





		// this.showRestart();
		// this.showGoodjob();
		// this.showOneFirework(cc.v2(0, -this.canvas.height / 2), this.canvas, cc.find('paperBase').children, this.canvas.width / 2.5, this.canvas.height * 2, 100, 1);
		playAudio(this.finishClip);


		const camera = cc.find('Canvas/Main Camera');
		camera.zIndex = 100;

		showTrebleFirework(camera, cc.find('RibbonNodeBase').children);


		const endData = this.getEndData();
		delayCall(2,( ) => {
			onHomeworkFinish(endData);

			// const nextBtn = cc.find('middleLayer/BtnRight');
			// if (nextBtn) {
			// 	nextBtn.active = true;
			// }
		})

	},


	saveLearnHistory() {
		console.log(' in saveLearnHistory');
		const middleLayer = cc.find('middleLayer');
		if (middleLayer) {

			const arr = this.getLearnHistoryData();
			console.log('saveLearnHistory: ', JSON.stringify( arr ));
			middleLayer.getComponent('middleLayer').callApiSaveLearnHistory(arr, (res) => {
				console.log(" res~ : ", res)
			});
		}
	},

	getLearnHistoryData() {
		const arr = [];
		for (let i=0; i<this.data.rows.length; i++) {
			const oneData = this.data.rows[i];
			
			const oneLearnData = {
				wid: oneData.id,
				word: oneData.text_en,
				status_: oneData.isRight ? 1 : 2
			}
			arr.push(oneLearnData);
		}

		return arr;
	},



	getEndData() {

		return {};

		const arr = this.picNodeArr;
		const customData = [];
		let stone = 0;
		const oneQuesStone = 10 / arr.length;
		arr.forEach(node => {
			customData.push({isRight: node.isRight})
			if (node.isRight) {
				stone += oneQuesStone;
			}
		})
		stone = Math.round(stone * 10) / 10;
		return {customData, stone};
	},

	showGoodjob() {

		const icon = getSprNode("goodjob");
		icon.scale = this._mapScaleMin;
		icon.baseS = icon.scale;
		this.canvas.addChild(icon, 20);


		const time = 1;
		icon.scale = 0;
		cc.tween(icon)
			.to(0.8,  {scale: icon.baseS}, {easing: "elasticOut"})
			.delay(1)
			.to(0.5, {scale: 0} , {easing: "cubicIn"})

			.start();



	},

	showRestart() {

		const btn = getSprNode("btn_restart");
		btn.scale = this._mapScaleMin;
		btn.baseS = btn.scale;
		this.canvas.addChild(btn, 21);

		btn.on(cc.Node.EventType.TOUCH_START, () => {
			// btn.removeFromParent();
			// this.initData();
			// this.initStar();
			// this.showChangeQuesAnim();
			// playAudio(this.btnClip);

			const middleLayer = cc.find('middleLayer');
			if (middleLayer) {
				middleLayer.getComponent('middleLayer').reloadBundle();
			}
		})

		const time = 0.9;
		btn.scale = 0;
		cc.tween(btn)
			.delay(2.5)
			.to(time,  {scale: btn.baseS}, {easing: "elasticOut"})
			.start();

	},



	async showOneFirework(pos, parentNode, nodeList, w, h, n, timeRate=1) {

		for (let i = 0; i < 3; i++) {
				this.showFirework(pos, parentNode, nodeList, w, h, n, timeRate);
				await asyncDelay(0.1);
		}
	},

	showFirework(pos, parentNode, nodeList, width = 200, height = 500, number = 30, timeRate=1) {
			const subTime = 1;
			for (let i = 0; i < number; i++) {
					const quad = this.createQuads(pos, parentNode, nodeList);
					const targetX = RandomInt(width / 2, -width / 2);
					const targetY = RandomInt(height);

					cc.tween(quad)
							.by(0.5 * timeRate, { x: targetX })
							.by((2 + subTime *  Math.random()) * timeRate, { x: targetX * 2 })
							.start();

					cc.tween(quad)
							.by(0.5 * timeRate, { y: targetY }, { easing: 'quadOut' })
							.to((3 + subTime * Math.random()) * timeRate, { y: -parentNode.height * 2 }, { easing: 'quadIn' })
							.removeSelf()
							.start();

					cc.tween(quad)
							.delay(1  * timeRate)
							.to((0.5 + subTime * Math.random()) * timeRate , { opacity: 0 })
							.start();
			}
	},

	createQuads(pos, parentNode, nodeList) {
			const quadBase = cc.instantiate(nodeList[RandomInt(nodeList.length)]);

			quadBase.x = pos.x;
			quadBase.y = pos.y;
			quadBase.z = pos.z;
			quadBase.angle = RandomInt(180);
			quadBase.parent = parentNode;

			const quad = quadBase.getChildByName('quad');
			quad.x = 0;
			quad.y = 0;
			quad.angle = RandomInt(180);

			const paper = quad.getChildByName('paper');
			paper.scaleX = Math.random() * 0.8 + 0.2;
			paper.scaleY = Math.random() * 0.8 + 0.2;

			quadBase.scaleX = Math.random();
			cc.tween(quadBase)
					.to((1 - quadBase.scaleX) * 0.3, { scaleX: 1 })
					.call(() => {
							const time = Math.random() * 0.2;
							cc.tween(quadBase)
									.to(0.1 + time, { scaleX: -1 })
									.to(0.1 + time, { scaleX: 1 })
									.union()
									.repeatForever()
									.start();
					})
					.start();


			return quadBase;
	},


















	restart() {
		
	},


	initTitle() {

		const offX = 96;
		const offY = 11;
		const title = getSprNode('title_bg');
		title.parent = this.canvas;
		title.scale = this._mapScaleMin;
		title.zIndex = 10;

		title.x = -this.canvas.width / 2 + title.width / 2 * title.scale + offX;
		title.y = this.canvas.height / 2 - title.height / 2 * title.scale - offY;

		// console.log('this.data: ', this.data);

		title.addComponent(cc.Button)
		title.on('click', () => {
			if (this.data.title_audio_url) {
				playAudioByUrl(this.data.title_audio_url);
			}
		})

		const labelNode = new cc.Node();
		labelNode.parent = title;
		const label = labelNode.addComponent(cc.RichText);
		const size = 42
		label.font = cc.find('Canvas/res/font/aharoni').getComponent(cc.Label).font;
		label.string = `<outline color=#a83c13 width=2><size=${size}><color=#ffffff>${this.data.title || " " }</color></size></outline>`
		// label.string = `<size=${size}><color=#751e00>${this.curGroup.title }</color></size>`
		label.lineHeight = size;
		label.horizontalAlign = cc.macro.TextAlignment.LEFT
		labelNode.anchorX = 0;
		labelNode.anchorY = 1
		labelNode.x = -title.width / 2 + 90;

		const maxLen = 305;
		if (labelNode.width > maxLen) {
			labelNode.scale = maxLen / labelNode.width;
		}

		labelNode.y = labelNode.height / 2 * labelNode.scale + 15;

	},


	initBg() {
		
		console.log("this.data.bg_pic_url: ", this.data.bg_pic_url);

		const bgLayer = new cc.Node();
		bgLayer.width = this.canvas.width;
		bgLayer.height = this.canvas.height;
		this.canvas.addChild(bgLayer, 2);
		this.bgLayer = bgLayer;



		if (this.isVertical) {
			this.initVerticalBg();
			return;
		}


		const designW = 1920;

		const bgY = getSprNode("new/bg");
		this.canvas.addChild(bgY);
		bgY.scale = this.getVerticalMaxScale(bgY);
		bgY.anchorY = 0;
		bgY.y = -this.canvas.height / 2;


		const glassBg = getSprNode("new/glass_4");
		const glassSpr = glassBg.getComponent(cc.Sprite);
		glassSpr.type = cc.Sprite.Type.SLICED;
		this.bgLayer.addChild(glassBg);
		glassBg.baseW = glassBg.width;
		glassBg.baseH = glassBg.height;
		delayCall(0.01, () => {
			console.log('this.scrollView.width: ', this.scrollView.width)
			console.log('this.scrollView.height: ', this.scrollView.height)
			glassBg.width = this.scrollView.node.width; //this.canvas.width * 0.8;
			glassBg.height = this.scrollView.node.height + 76//this.canvas.height * 0.8;

			glassBg.parent = this.scrollView.node;
			glassBg.zIndex = -1;

		})


		const bottomLeft = getSprNode("new/bottom_left");
		this.bgLayer.addChild(bottomLeft);
		bottomLeft.scale = this.canvas.width / designW
		bottomLeft.anchorX = 0;
		bottomLeft.anchorY = 0;
		bottomLeft.x = -this.canvas.width/ 2;
		bottomLeft.y = -this.canvas.height / 2;



		const bottomRight = getSprNode("new/bottom_right");
		this.bgLayer.addChild(bottomRight);
		bottomRight.scale = this.canvas.width / designW
		bottomRight.anchorX = 1;
		bottomRight.anchorY = 0;
		bottomRight.x = this.canvas.width/ 2;
		bottomRight.y = -this.canvas.height / 2;


		// const glassBg = getSprNode("new/glass_4");
		// const glassSpr = glassBg.getComponent(cc.Sprite);
		// glassSpr.type = cc.Sprite.Type.SLICED;
		// this.bgLayer.addChild(glassBg);
		// glassBg.baseW = glassBg.width;
		// glassBg.baseH = glassBg.height;
		// delayCall(0.01, () => {
		// 	glassBg.width = this.scrollView.width //this.canvas.width * 0.8;
		// 	glassBg.height = this.scrollView.height//this.canvas.height * 0.8;
		// })
		// // this.glassBg = glassBg;


		const topRectSize = {
			width: designW,
			height: 174
		}

		const tempS = this.canvas.width / topRectSize.width;
		this.topH = topRectSize.height * tempS;

		const backBtn = getSprNode("btn_back");
		// this.bgLayer.addChild(backBtn);
		backBtn.scale = tempS;
		backBtn.x = -this.canvas.width / 2 + this.topH / 2;
		backBtn.y = this.canvas.height / 2 - this.topH / 2;
		backBtn.addComponent(cc.Button);
		backBtn.on("click", () => {
			const middleLayer = cc.find('middleLayer');
			if (middleLayer) {
				const middleLayerComponent = middleLayer.getComponent('middleLayer');
				middleLayerComponent.showMenuTemplate();
				
			} 
		});
		backBtn.active = false;


		const changeDirBtn = getSprNode("btn_flip_v");
		// this.bgLayer.addChild(changeDirBtn);
		changeDirBtn.scale = tempS;
		changeDirBtn.x = this.canvas.width / 2 - this.topH / 2;
		changeDirBtn.y = this.canvas.height / 2 - this.topH / 2;
		changeDirBtn.addComponent(cc.Button);
		changeDirBtn.on("click", () => {
			const middleLayer = cc.find('middleLayer');
			if (middleLayer) {
				const middleLayerComponent = middleLayer.getComponent('middleLayer');
				middleLayerComponent.setTemplateIsVertical("hw_dictation", !this.isVertical);
				middleLayerComponent.reloadBundle();
			} 
		});


		if (cc.sys.isNative && cc.sys.os == cc.sys.OS_IOS) {
			// changeDirBtn.active = false;
		}



		const itemW = 1035 / 1080 * designW;
		const svBgNode = new cc.Node();
		svBgNode.width = itemW / designW * this.canvas.width;
		svBgNode.height = this.canvas.height - this.topH;
		svBgNode.y = - this.topH / 2;
		this.bgLayer.addChild(svBgNode);


		console.log('svBgNode: ', svBgNode.width);
		console.log('this.canvas: ', this.canvas.width);
		console.log('this.canvas: ', this.canvas.height);

		this.bg = svBgNode;


		return;






		// this.topH = 200 * this._mapScaleMin;



		// const bgY = getSprNode("h_bg");
		// this.bgLayer.addChild(bgY);
		// bgY.scale = this._mapScaleMax;

		// const bg = new cc.Node();
		// bg.width = this.canvas.width;
		// bg.height = this.canvas.height - this.topH;
		// bg.y = -this.topH / 2;
		// this.bgLayer.addChild(bg);
		// this.bg = bg;


		// const backBtn = getSprNode("btn_back");
		// this.bgLayer.addChild(backBtn);
		// backBtn.scale = this._mapScaleMin;;
		// backBtn.x = -this.canvas.width / 2 + this.topH / 2;
		// backBtn.y = this.canvas.height / 2 - this.topH / 2;
		// backBtn.addComponent(cc.Button);
		// backBtn.on("click", () => {
		// 	const middleLayer = cc.find('middleLayer');
		// 	if (middleLayer) {
		// 		const middleLayerComponent = middleLayer.getComponent('middleLayer');
		// 		middleLayerComponent.showMenuTemplate();
		// 	} 
		// });


		// const changeDirBtn = getSprNode("btn_flip_h");
		// this.bgLayer.addChild(changeDirBtn);
		// changeDirBtn.scale = this._mapScaleMin;;
		// changeDirBtn.x = this.canvas.width / 2 - this.topH / 2;
		// changeDirBtn.y = this.canvas.height / 2 - this.topH / 2;
		// changeDirBtn.addComponent(cc.Button);
		// changeDirBtn.on("click", () => {
		// 	const middleLayer = cc.find('middleLayer');
		// 	if (middleLayer) {
		// 		const middleLayerComponent = middleLayer.getComponent('middleLayer');
		// 		middleLayerComponent.setTemplateIsVertical("hw_dictation", !this.isVertical);
		// 		middleLayerComponent.reloadBundle();
		// 	} 
		// });


		// if (cc.sys.isNative && cc.sys.os == cc.sys.OS_IOS) {
		// 	// changeDirBtn.active = false;
		// }
		
		
	},

	initVerticalBg() {


		// const bgY = getSprNode("bg_y_2");
		const bgY = getSprNode("new/bg");
		this.canvas.addChild(bgY);
		bgY.scale = this.getVerticalMaxScale(bgY);
		bgY.anchorY = 0;
		bgY.y = -this.canvas.height / 2;


		const bottomLeft = getSprNode("new/bottom_left");
		this.bgLayer.addChild(bottomLeft);
		bottomLeft.scale = this.canvas.width / 1080
		bottomLeft.anchorX = 0;
		bottomLeft.anchorY = 0;
		bottomLeft.x = -this.canvas.width/ 2;
		bottomLeft.y = -this.canvas.height / 2;



		const bottomRight = getSprNode("new/bottom_right");
		this.bgLayer.addChild(bottomRight);
		bottomRight.scale = this.canvas.width / 1080
		bottomRight.anchorX = 1;
		bottomRight.anchorY = 0;
		bottomRight.x = this.canvas.width/ 2;
		bottomRight.y = -this.canvas.height / 2;


		const glassBg = getSprNode("new/glass_4");
		const glassSpr = glassBg.getComponent(cc.Sprite);
		glassSpr.type = cc.Sprite.Type.SLICED;
		this.bgLayer.addChild(glassBg);
		glassBg.baseW = glassBg.width;
		glassBg.baseH = glassBg.height;
		delayCall(0.01, () => {
			console.log('this.scrollView.width: ', this.scrollView.width)
			console.log('this.scrollView.height: ', this.scrollView.height)
			glassBg.width = this.scrollView.node.width; //this.canvas.width * 0.8;
			glassBg.height = this.scrollView.node.height + 76//this.canvas.height * 0.8;
			// glassBg.y = this.scrollView.node.y;
			// glassBg.scale = this.scrollView.node.scale;

			glassBg.parent = this.scrollView.node;
			glassBg.zIndex = -1;

		})
		// this.glassBg = glassBg;


		const topRectSize = {
			width: 1080,
			height: 174
		}

		const tempS = this.canvas.width / topRectSize.width;
		this.topH = topRectSize.height * tempS;

		const backBtn = getSprNode("btn_back");
		// this.bgLayer.addChild(backBtn);
		backBtn.scale = tempS;
		backBtn.x = -this.canvas.width / 2 + this.topH / 2;
		backBtn.y = this.canvas.height / 2 - this.topH / 2;
		backBtn.addComponent(cc.Button);
		backBtn.on("click", () => {
			const middleLayer = cc.find('middleLayer');
			if (middleLayer) {
				const middleLayerComponent = middleLayer.getComponent('middleLayer');
				middleLayerComponent.showMenuTemplate();
				
			} 
		});


		const changeDirBtn = getSprNode("btn_flip_v");
		// this.bgLayer.addChild(changeDirBtn);
		changeDirBtn.scale = tempS;
		changeDirBtn.x = this.canvas.width / 2 - this.topH / 2;
		changeDirBtn.y = this.canvas.height / 2 - this.topH / 2;
		changeDirBtn.addComponent(cc.Button);
		changeDirBtn.on("click", () => {
			const middleLayer = cc.find('middleLayer');
			if (middleLayer) {
				const middleLayerComponent = middleLayer.getComponent('middleLayer');
				middleLayerComponent.setTemplateIsVertical("hw_dictation", !this.isVertical);
				middleLayerComponent.reloadBundle();
			} 
		});


		if (cc.sys.isNative && cc.sys.os == cc.sys.OS_IOS) {
			// changeDirBtn.active = false;
		}



		const itemW = 1035;
		const svBgNode = new cc.Node();
		svBgNode.width = itemW / 1080 * this.canvas.width;
		svBgNode.height = this.canvas.height - this.topH;
		svBgNode.y = - this.topH / 2;
		this.bgLayer.addChild(svBgNode);


		console.log('svBgNode: ', svBgNode.width);
		console.log('this.canvas: ', this.canvas.width);
		console.log('this.canvas: ', this.canvas.height);

		this.bg = svBgNode;
	},

	getVerticalMinScale(node) {
		const sx = this.canvas.width / node.width;
		const sy = this.canvas.height / node.height;
		return Math.min(sx,sy);
	},

	getVerticalMaxScale(node) {
		const sx = this.canvas.width / node.width;
		const sy = this.canvas.height / node.height;
		return Math.max(sx,sy);
	},


	initHotZone() {
		this.initHotZoneBg();
	},


	hotZoneBg: null,
	initHotZoneBg() {
		this.hotZoneBg = new cc.Node();

		this.hotZoneBg.name = 'hotZoneBg';
		this.hotZoneBg.parent = cc.find('Canvas');
		this.hotZoneBg.zIndex = 4;

		if (!this.data.bgItem) {
			return;
		}

		cc.loader.load({url: this.data.bgItem.url}, (err, img) => {

			// this.addMask(this.hotZoneBg);

			this.hotZoneBg.width = img.width;
			this.hotZoneBg.height = img.height;



			const sprNode = new cc.Node();
			sprNode.name = 'bgItemSpr'
			var sf = new cc.SpriteFrame(img);
			// const spr = this.hotZoneBg.addComponent(cc.Sprite);
			const spr = sprNode.addComponent(cc.Sprite);
			spr.spriteFrame = sf
			sprNode.width = this.hotZoneBg.width;
			sprNode.height = this.hotZoneBg.height;
			sprNode.parent = this.hotZoneBg;
			window['bg'] =sprNode 


			const sx = this.canvas.width / this.hotZoneBg.width;
			const sy = (this.canvas.height) / this.hotZoneBg.height;
			const s = Math.min(sx, sy);
			this.hotZoneBg.scale = s;

			// this.data.bgItem.isShowDebugLine = true;
			this.initHotZoneItem();
			// this.initFingerQuesData();
		
			this.initQuesArr();
			this.initCurQues();

			this.hzLoadEnd = true;
			// this.checkStart();


	
		});

	},

	initHotZoneItem() {

		this.picNodeArr = [];

		this.data.hotZoneItemArr.forEach((item) => {
			console.log('item.gIdx: ', item.gIdx);
			switch (item.gIdx) {

				case "0":
					this.setOneText(item);
					break;

				case "1":
					this.setOneWriteAnima(item);
					break;

				// case "2":
				// 	this.setOneCircleAnima(item);
				// 	break;

				// case "4":
				// 	this.setOneSignAnima(item);
				// 	break;

				// case "5":
				// 	this.setOneFingerAnima(item);
				// 	break;
				// case "0":
				// 	this.setOneHotZonePic(item);
				// 	break;
						
				default:
					break;
			}

		});

	},

	setOneLinkRect(data) {
		const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;

		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		this.hotZoneBg.addChild(rectNode);

		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / this.hotZoneBg.scaleY;

		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
		rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
		// rectNode.scale = 1 / data.mapScale;

		rectNode.anchorX = rectNode.anchorY = 0;


		if (this.data.isDebug) {
			ctx.rect(0, 0, rectNode.width, rectNode.height);
		}
		ctx.stroke();
		ctx.fill();

		rectNode.data = data;

		console.log(" data is ~~~ : ", data);

		this.rectNodeArr.push(rectNode)


		const debugItemId = data.pointItem;
		const debugItemData = this.data.hotZoneItemArr2[Number(debugItemId) - 1];
		rectNode.isRightPoint = debugItemData.checkbox.list[0].value == true;

		console.log('debugItemData.checkbox.list[0].value: ', debugItemData.checkbox.list[0].value);

	},


	addMask(node) {
		const mask = node.addComponent(cc.Mask);
		mask.type = cc.Mask.Type.RECT;
	},


	setOneDragAction(data) {

		const rate =  (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;
		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		this.hotZoneBg.addChild(rectNode);

		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / this.hotZoneBg.scaleY ;

		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
		rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
		const {x, y, width, height} = rectNode;
		// rectNode.anchorX = rectNode.anchorY = 0;

		if (this.data.bgItem.isShowDebugLine) {
			ctx.rect(-rectNode.width / 2, -rectNode.height / 2, rectNode.width, rectNode.height);
		}
		ctx.stroke();
		ctx.fill();
		rectNode.x += rectNode.width / 2;
		rectNode.y += rectNode.height / 2;

		rectNode.baseX = rectNode.x;
		rectNode.baseY = rectNode.y;
		rectNode.targetOff();

		rectNode.on(cc.Node.EventType.TOUCH_START, () => {

			if (rectNode.isDragEnd) {
				if (rectNode.audioClip) {
					cc.audioEngine.stopAllEffects();
					cc.audioEngine.playEffect(rectNode.audioClip, false, 0.8);
				}
				return;
			}
			this._curShowItem = rectNode;
		})
		

		const realRate = this.hotZoneBg.width / this.data.bgItem.rect.width;
		rectNode.targetPx = -this.hotZoneBg.width / 2 + ( data.dragDot.x - this.data.bgItem.rect.x ) * realRate;
		rectNode.targetPy = this.hotZoneBg.height / 2 - (data.dragDot.y - this.data.bgItem.rect.y) * realRate;


		if (data.audio_url) {
			cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
				rectNode.audioClip = audioClip;
			});
		}



		console.log('setOneAction ~~ data: ', data)
		const actionData = data['actionData_' + data.gIdx];
		if (!actionData) {
			return;
		}
		if (actionData.type == 'text') {
			const label = this.setOneActionText(rectNode, actionData);
			label.node.scale = scale * data.fontScale;

			label.node.targetOff();
		
	

			// label.overflow = cc.Label.Overflow.NONE;
			// label.node.setContentSize(new cc.Size(0, lineHeight));
			label["_forceUpdateRenderData"](true);
		
			
		} else if (actionData.type == 'pic') {

			const pic = this.setOneActionPic(rectNode, actionData);

		} else if (actionData.type == 'anima') {

			const anima = this.setOneActionAnima(rectNode, actionData);
		}
	},



	setOneAction(data) {

		const rate =  (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;
		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		this.hotZoneBg.addChild(rectNode);

		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / this.hotZoneBg.scaleY ;

		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
		rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
		const {x, y, width, height} = rectNode;
		rectNode.anchorX = rectNode.anchorY = 0;

		if (this.data.bgItem.isShowDebugLine) {
			ctx.rect(0, 0, rectNode.width, rectNode.height);
		}
		ctx.stroke();
		ctx.fill();



		console.log('setOneAction ~~ data: ', data)
		const actionData = data['actionData_' + data.gIdx];
		if (!actionData) {
			return;
		}
		if (actionData.type == 'text') {
			const label = this.setOneActionText(rectNode, actionData);
			label.node.scale = scale * data.fontScale;

			// label.overflow = cc.Label.Overflow.NONE;
			// label.node.setContentSize(new cc.Size(0, lineHeight));
			label["_forceUpdateRenderData"](true);
		
			
		} else if (actionData.type == 'pic') {

			const pic = this.setOneActionPic(rectNode, actionData);

		} else if (actionData.type == 'anima') {

			const anima = this.setOneActionAnima(rectNode, actionData);
		}
	},

	setOneActionText(rectNode, actionData) {


		const labelNode = new cc.Node();
		labelNode.parent = rectNode;
		const label = labelNode.addComponent(cc.Label);

		label.font = cc.find('Canvas/res/font/ahronbd-1').getComponent(cc.Label).font;
		label.string = actionData.text;
		// label.string = `<size=${size}><color=#751e00>${this.curGroup.title }</color></size>`
		// label.lineHeight = size;
		// label.horizontalAlign = cc.macro.TextAlignment.LEFT
		// labelNode.anchorX = 0;
		// labelNode.anchorY = 1
		labelNode.color = cc.Color.BLACK;


		const opArr = actionData.changeOption
		// console.log('opArr', opArr);


		const tweenArr = [];

		for (let i = 0; i < opArr.length; i++ ) {

			const opData = opArr[i];
			console.log('opArr[0]', opArr[i])
			if (opData[0] == 'fontColor') {
				const color = new cc.Color();
				cc.Color.fromHEX(color, opData[1] );
				labelNode.color = color;

			} else if (opData[0] == 'opacity') {
				// console.log('opData: ', opData)
				labelNode.opacity = Number( opData[1] / 100 * 255 ) + 0.1;
				// console.log(labelNode.opacity);
				tweenArr.push({item: labelNode , option: `{"${opData[0]}" : ${opData[2] / 100 * 255}}`, optionName: opData[0]},)

			} else {
				label[opData[0]] = opData[1];
				tweenArr.push({item: label, option: `{"${opData[0]}" : ${opData[2]}}`, optionName: opData[0]})

			}
		}


		// if (actionData.audio_url) {
		// 	cc.assetManager.loadRemote(actionData.audio_url, (err, audioClip) => {
		// 		labelNode.audioClip = audioClip;
		// 	});
		// }


		label.lineHeight = label.fontSize;

		// labelNode.y += rectNode.height / 2;
		// labelNode.x += rectNode.width / 2;
		

		// rectNode.addComponent(cc.Button);
		// rectNode.on('click', () => {

		// 	if (labelNode.audioClip) {
		// 		cc.audioEngine.stopAllEffects();
		// 		cc.audioEngine.playEffect(labelNode.audioClip, false, 0.8);
		// 	}

		// 	if (labelNode.isClicked) {
		// 		// return;
		// 	}
		// 	labelNode.isClicked = true;

		// 	for (let i=0; i<tweenArr.length; i++) {
		// 		const tweenData = tweenArr[i];

		// 		if (tweenData.optionName == 'opacity') {
		// 			console.log('~~~ ',  tweenData.item[tweenData.optionName] );

		// 			cc.tween(tweenData.item)
		// 				.to(actionData.changeTime,  JSON.parse(tweenData.option) )
		// 				.start();
		// 		}
				

		// 	}

		// });


		return label;
	},

	setOneActionPic(rectNode, actionData) {

		console.log('setOneActionPic actionData: ', actionData)
		const picNode = new cc.Node();
		rectNode.addChild(picNode);

		cc.loader.load({url: actionData.pic_url}, (err, img) => {

			const spr = picNode.addComponent(cc.Sprite);
			spr.spriteFrame = new cc.SpriteFrame(img)

			picNode.y += rectNode.height / 2;
			picNode.x += rectNode.width / 2;

			picNode.scaleX = rectNode.width / picNode.width;
			picNode.scaleY = rectNode.height / picNode.height;

			const opArr = actionData.changeOption	
			const tweenArr = [];
	
			for (let i = 0; i < opArr.length; i++ ) {
	
				const opData = opArr[i];
				console.log('opData: ~~~ ', opData);

				if (opData[0] == 'opacity') {
					picNode.opacity = Number( opData[1] / 100 * 255 ) + 0.1;
					console.log(picNode.opacity);
					tweenArr.push({item: picNode , option: `{"${opData[0]}" : ${opData[2] / 100 * 255}}`, optionName: opData[0]},)
	
				}  else {
					// picNode[opData[0]] = Number(opData[1]);
					// tweenArr.push({item: picNode, option: `{"${opData[0]}" : ${opData[2]}}`, optionName: opData[0]})
				}

	
				if (actionData.audio_url) {
					cc.assetManager.loadRemote(actionData.audio_url, (err, audioClip) => {
						rectNode.audioClip = audioClip;
					});
				}
				

				rectNode.addComponent(cc.Button);
				rectNode.on('click', () => {

					if (rectNode.audioClip) {
						cc.audioEngine.stopAllEffects();
						cc.audioEngine.playEffect(rectNode.audioClip, false, 0.8);
					}
		
					if (rectNode.isClicked) {
						// return;
					}
					rectNode.isClicked = true;

					for (let i=0; i<tweenArr.length; i++) {
						const tweenData = tweenArr[i];
		
						if (tweenData.optionName == 'opacity') {
							cc.tween(tweenData.item)
								.to(actionData.changeTime,  JSON.parse(tweenData.option) )
								.start();
						}
					}
		
				});
			}

		});
	},

	setOneActionAnima(rectNode, actionData) {


		const animaNode = new cc.Node();
		rectNode.addChild(animaNode);

		if (actionData.audio_url) {
			cc.assetManager.loadRemote(actionData.audio_url, (err, audioClip) => {
				rectNode.audioClip = audioClip;
			});
		}

		const data = actionData;

		const dragonDisplay = animaNode.addComponent(dragonBones.ArmatureDisplay);
		if (!data.texPngData) {
			return
		}



		const image = data.texPngData.url//"http://staging-teach.cdn.ireadabc.com/5a0c5af3e952acd0ac83a6e5c6f03ff1.png";
		const ske = data.skeJsonData.url//"http://staging-teach.cdn.ireadabc.com/bd825dcceea298d1146be8067ae3d17f.json";
		const atlas = data.texJsonData.url//"http://staging-teach.cdn.ireadabc.com/246f8991b729fa3e5a7f4802de828efa.json";
		cc.loader.load(image, (error, texture) => {

			cc.loader.load({url: atlas, type: 'txt'}, (error, atlasJson) => {

				cc.loader.load({url: ske, type: 'txt'}, (error, dragonBonesJson) => {

					const atlas = new dragonBones.DragonBonesAtlasAsset();
					atlas.atlasJson = atlasJson;
					atlas.texture = texture;

					const asset = new dragonBones.DragonBonesAsset();
					asset.dragonBonesJson = dragonBonesJson;

					dragonDisplay.dragonAtlasAsset = atlas;
					dragonDisplay.dragonAsset = asset;


					let json = JSON.parse(asset.dragonBonesJson);
					let armatures = json["armature"];
					let armatureNames = [];
					for (let i = 0; i < armatures.length; i++) {
						armatureNames.push(armatures[i].name);
					}
					// console.log('armatureNames: ', armatureNames);

					let animationNames = [];

					if (armatureNames.length > 0) {
						let defaultArmatureName = armatureNames[0];
						dragonDisplay.armatureName = defaultArmatureName;
						// let animationNames = dragonDisplay.getAnimationNames(defaultArmatureName);
						let defaultArmature = armatures[0];
						let animations = defaultArmature.animation;
						for (let i = 0; i < animations.length; i++) {
							animationNames.push(animations[i].name);
						}

						// rectNode.addComponent(cc.Button);
						// rectNode.on('click', () => {
						// 	if (rectNode.isClicked) {
						// 		// return;
						// 	}
						// 	rectNode.isClicked = true;
						// 	console.log('clicked');

						// 	if (rectNode.audioClip) {
						// 		cc.audioEngine.stopAllEffects();
						// 		cc.director.emit('STOP_ALL_AUDIO')
						// 		cc.audioEngine.playEffect(rectNode.audioClip, false, 0.8);
						// 	}

						// 	if (animationNames.length > 0) {
						// 		dragonDisplay.playAnimation(animationNames[0], 1);
						// 	}
						// });
					}


					// animaNode.x = rectNode.x + rectNode.width / 2;
					// animaNode.y = rectNode.y + rectNode.height / 2;

					// const sx = rectNode.width / animaNode.width;
					// const sy = rectNode.height / animaNode.height;
					// const scale = Math.min(sx, sy);
					// animaNode.scale = scale;
					


			


					animaNode.y += rectNode.height / 2;
					animaNode.x += rectNode.width / 2;

					animaNode.scaleX = rectNode.width / animaNode.width;
					animaNode.scaleY = rectNode.height / animaNode.height;
		
					const opArr = actionData.changeOption	
					const tweenArr = [];
			
					for (let i = 0; i < opArr.length; i++ ) {
			
						const opData = opArr[i];
						console.log('opData: ~~~ ', opData);
		
						if (opData[0] == 'opacity') {
							animaNode.opacity = Number( opData[1] / 100 * 255 ) + 0.1;
							console.log(animaNode.opacity);
							tweenArr.push({item: animaNode , option: `{"${opData[0]}" : ${opData[2] / 100 * 255}}`, optionName: opData[2] == null ? '' : opData[0]},)
			
						}  else {
							// animaNode[opData[0]] = Number(opData[1]);
							// tweenArr.push({item: animaNode, option: `{"${opData[0]}" : ${opData[2]}}`, optionName: opData[2] == null ? '' : opData[0]})
						}
		
			
						if (actionData.audio_url) {
							cc.assetManager.loadRemote(actionData.audio_url, (err, audioClip) => {
								rectNode.audioClip = audioClip;
							});
						}
						
		
						rectNode.addComponent(cc.Button);
						rectNode.on('click', () => {
		
							if (rectNode.audioClip) {
								cc.audioEngine.stopAllEffects();
								cc.audioEngine.playEffect(rectNode.audioClip, false, 0.8);
							}
				
							if (rectNode.isClicked) {
								// return;
							}
							rectNode.isClicked = true;
		
							for (let j=0; j<tweenArr.length; j++) {
								const tweenData = tweenArr[j];
				
								console.log('tweenData: ', tweenData);

								if (tweenData.optionName) {

									cc.tween(tweenData.item)
										.to(actionData.changeTime,  JSON.parse(tweenData.option))
										.start();

								}

							}
						
							if (animationNames.length > 0) {
								dragonDisplay.playAnimation(animationNames[0], 1);
							}
				
						});
					}
		
					
				});
			});
		});

	},

	setOneText(data) {


		const rectNode = this.setOneNormalRect(data);

		const labelNode = new cc.Node();
		labelNode.parent = rectNode;
		const label = labelNode.addComponent(cc.Label);

		
		label.font = cc.find('Canvas/res/font/BiaoZhunShouxieTi').getComponent(cc.Label).font;
		label.string = data.text;
		label.fontSize = 50;
		// label.string = `<size=${size}><color=#751e00>${this.curGroup.title }</color></size>`
		// label.lineHeight = size;
		// label.horizontalAlign = cc.macro.TextAlignment.LEFT
		// labelNode.anchorX = 0;
		// labelNode.anchorY = 1
		labelNode.color = cc.Color.BLACK;
		label.lineHeight = label.fontSize;

		labelNode.opacity = 0.01;
		delayCall(0.01, () => {

			const sx = rectNode.width / labelNode.width;
			const sy = rectNode.height / labelNode.height;
			const s = Math.min(sx, sy);
			labelNode.scale = s;

			labelNode.x = rectNode.width/ 2;
			labelNode.y = rectNode.height / 2;

			labelNode.opacity = 0;
		})

		labelNode.data = data;
		this.quesNodeArr.push(labelNode);


	},
	

	setOneWriteAnima(data) {



		const rectNode = this.setOneNormalRect(data);

		const labelNode = new cc.Node();
		labelNode.parent = rectNode;
		const label = labelNode.addComponent(cc.Label);

		
		label.font = cc.find('Canvas/res/font/BiaoZhunShouxieTi').getComponent(cc.Label).font;
		label.string = data.labelText;
		label.fontSize = 100//;
	
		labelNode.color = cc.Color.BLACK;
		label.lineHeight = label.fontSize;

		labelNode.opacity = 0.01;
		delayCall(0.01, () => {
			const sx = rectNode.width / labelNode.width;
			const sy = rectNode.height / labelNode.height;
			const s = Math.min(sx, sy);
			labelNode.scale = sy //s;
			
			labelNode.x = rectNode.width/ 2;
			labelNode.y = rectNode.height / 2.2;

			labelNode.opacity = 0;
		})

		// labelNode.on("touchstart", () => {
		// 	this.showLetterLabel(labelNode);
		// })

		labelNode.data = data;
		this.animaNodeArr.push(labelNode);

	},


	setOneCircleAnima(data) {

		const animaNode = this.setOneAnimaSmall(data);
		this.circleAnimaNodeArr.push(animaNode);
	},

	setOneSignAnima(data) {
		const animaNode = this.setOneAnimaSmall(data);
		this.signAnimaNodeArr.push(animaNode);
	},

	setOneFingerAnima(data) {
		console.log(' in setOneFingerAnima: ', data );
		const animaNode = this.setOneAnimaSmall(data);

		if (this.data.page_id == '20' && this.data.book_id == "Oxford_Phonics_World_1_SB") {
			animaNode.scale = 0.5;
		}

		this.fingerAnimaNodeArr.push(animaNode);
	},


	setOneAnimaSmall(data) {


		const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;

		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		this.hotZoneBg.addChild(rectNode);


		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / this.hotZoneBg.scaleY;

		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
		rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;

		rectNode.anchorX = rectNode.anchorY = 0;


		if (this.data.bgItem.isShowDebugLine) {
			ctx.rect(0, 0, rectNode.width, rectNode.height);
		}
		ctx.stroke();
		ctx.fill();




		const animaNode = new cc.Node();
		animaNode.name = 'anima_' + data.index;
		this.hotZoneBg.addChild(animaNode);

		animaNode.data = data;


		if (data.audio_url) {
			cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
				animaNode.audioClip = audioClip;
			});
		}


		const dragonDisplay = animaNode.addComponent(dragonBones.ArmatureDisplay);
		if (!data.texPngData) {
			return
		}
		
		const image = data.texPngData.url//"http://staging-teach.cdn.ireadabc.com/5a0c5af3e952acd0ac83a6e5c6f03ff1.png";
		const ske = data.skeJsonData.url//"http://staging-teach.cdn.ireadabc.com/bd825dcceea298d1146be8067ae3d17f.json";
		const atlas = data.texJsonData.url//"http://staging-teach.cdn.ireadabc.com/246f8991b729fa3e5a7f4802de828efa.json";
		cc.loader.load(image, (error, texture) => {

			cc.loader.load({url: atlas, type: 'txt'}, (error, atlasJson) => {

				cc.loader.load({url: ske, type: 'txt'}, (error, dragonBonesJson) => {

					const atlas = new dragonBones.DragonBonesAtlasAsset();
					atlas.atlasJson = atlasJson;
					atlas.texture = texture;

					const asset = new dragonBones.DragonBonesAsset();
					asset.dragonBonesJson = dragonBonesJson;

					dragonDisplay.dragonAtlasAsset = atlas;
					dragonDisplay.dragonAsset = asset;

					

					let json = JSON.parse(asset.dragonBonesJson);
					let armatures = json["armature"];
					// console.log('armatures: ', armatures);
					let armatureNames = [];
					for (let i = 0; i < armatures.length; i++) {
						armatureNames.push(armatures[i].name);
					}
					// console.log('armatureNames: ', armatureNames);
					if (armatureNames.length > 0) {
						let defaultArmatureName = armatureNames[0];
						dragonDisplay.armatureName = defaultArmatureName;
						// let animationNames = dragonDisplay.getAnimationNames(defaultArmatureName);
						let defaultArmature = armatures[0];
						let animations = defaultArmature.animation;
						let animationNames = [];
						for (let i = 0; i < animations.length; i++) {
							animationNames.push(animations[i].name);
						}

						animaNode.animationNames = animationNames;

						rectNode.addComponent(cc.Button);
						rectNode.on('click', () => {

							return;
							if (rectNode.isClicked) {
								// return;
							}
							rectNode.isClicked = true;
							console.log('clicked');

							if (animaNode.audioClip) {
								cc.audioEngine.stopAllEffects();
								cc.director.emit('STOP_ALL_AUDIO')
								cc.audioEngine.playEffect(animaNode.audioClip, false, 0.8);
							}

							if (animationNames.length > 0) {
								dragonDisplay.playAnimation(animationNames[0], 1);
							}
						});

						// animaNode.playRightAnim = () => {
						// 	animaNode.active = true;
						// 	if (animationNames.length > 0) {
						// 		dragonDisplay.playAnimation(animationNames[0], 1);
						// 	}
						// }
						animaNode.dragonDisplay = dragonDisplay;
					}


					animaNode.x = rectNode.x + rectNode.width / 2;
					animaNode.y = rectNode.y + rectNode.height / 2;

					const sx = rectNode.width / animaNode.width;
					const sy = rectNode.height / animaNode.height;
					const scale = Math.min(sx, sy);
					// animaNode.scale = scale;

					// animaNode.active = false;
					animaNode.opacity = 0;
					animaNode.hitCount = 0;
					// animaNode.opacity = 20;
			
					
				});
			});
		});

		return animaNode;

	},

	playRightAnim(animaNode, isAudio = true) {

		console.log('in playRightAnim ..')

		const animationNames = animaNode.animationNames;
		const dragonDisplay = animaNode.dragonDisplay;

		animaNode.active = true;
		animaNode.opacity = 255;
		// animaNode.opacity = 255;
		if (dragonDisplay && animationNames && animationNames.length > 0) {
			dragonDisplay.playAnimation(animationNames[0], 1);
		}

		if (isAudio) {
			playAudio(this.rightClip, () => {
			
			})
		}
	
	},

	setOneHotZonePic(data) {
		const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;

		const picNode = new cc.Node();
		picNode.name= 'pic' + data.index;
		picNode.data = data;
		this.hotZoneBg.addChild(picNode);

		this.picNodeArr.push(picNode);
		picNode.hitCount = 0;

		cc.loader.load({url: data.pic_url}, (err, img) => {

			const spr = picNode.addComponent(cc.Sprite);
			spr.spriteFrame = new cc.SpriteFrame(img)

			const scale = rate / this.hotZoneBg.scaleY;

			picNode.width = data.rect.width * scale;
			picNode.height = data.rect.height * scale;
			picNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
			picNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;

			picNode.x += picNode.width / 2 * picNode.scaleX;
			picNode.y += picNode.height / 2 * picNode.scaleX;


			getSprNodeByUrl(data.answer_pic_url, (spr) => {

				const sprNode = spr.node;
				sprNode.active = false;
				picNode.addChild(sprNode);
				picNode.answerPic = sprNode;

				picNode.isLoadEnd = true;
				// this.checkStart();
			})

			// picNode.anchorX = picNode.anchorY = 0;

			// if (data.audio_url) {
			// 	this.addPicAudio(picNode);
			// }

			// this.addDragPoint(picNode, data)

		});

	},

	addDragPoint(picNode, data) {


		picNode.baseX = picNode.x;
		picNode.baseY = picNode.y;

		const realRate = this.hotZoneBg.width / this.data.bgItem.rect.width;
		picNode.targetPx = -this.hotZoneBg.width / 2 + ( data.dragDot.x - this.data.bgItem.rect.x ) * realRate;
		picNode.targetPy = this.hotZoneBg.height / 2 - (data.dragDot.y - this.data.bgItem.rect.y) * realRate;


		if (data.audio_url) {
			cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
				picNode.audioClip = audioClip;
			});
		}


		picNode.on(cc.Node.EventType.TOUCH_START, () => {
			if (picNode.isDragEnd) {
				if (picNode.audioClip) {
					cc.audioEngine.stopAllEffects();
					cc.audioEngine.playEffect(picNode.audioClip, false, 0.8);
				}
				return;
			}
			this._curShowItem = picNode;

			// picNode.x = -this.hotZoneBg.width / 2 + ( data.dragDot.x - this.data.bgItem.rect.x ) * realRate;
			// picNode.y = this.hotZoneBg.height / 2 - (data.dragDot.y - this.data.bgItem.rect.y) * realRate;

		})
	},


	setOnePic(data) {
		const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;

		const picNode = new cc.Node();
		picNode.name= 'pic' + data.index;
		picNode.data = data;
		this.hotZoneBg.addChild(picNode);

		getSprNodeByUrl(data.pic_url, (spr) => {

			const sprNode = spr.node;
			picNode.addChild(sprNode);

			const scale = rate / this.hotZoneBg.scaleY;

			picNode.width = sprNode.width = data.rect.width * scale;
			picNode.height = sprNode.height = data.rect.height * scale;
			picNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
			picNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;

			// sprNode.anchorX = sprNode.anchorY = 0;


		})


		// cc.loader.load({url: data.pic_url}, (err, img) => {

		// 	const spr = picNode.addComponent(cc.Sprite);
		// 	spr.spriteFrame = new cc.SpriteFrame(img)

		// 	const scale = rate / this.hotZoneBg.scaleY;

		// 	picNode.width = data.rect.width * scale;
		// 	picNode.height = data.rect.height * scale;
		// 	picNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
		// 	picNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;

		// 	picNode.anchorX = picNode.anchorY = 0;

		// 	// if (data.audio_url) {
		// 	// 	this.addPicAudio(picNode);
		// 	// }

		// });

		// picNode.on('touchstart', () => {
		// 	this.show
		// })

	},

	setOneNormalRect(data) {
		const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;

		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		this.hotZoneBg.addChild(rectNode);


		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / this.hotZoneBg.scaleY;
		// console.log('scale: ', scale);
		// console.log('scale2: ', scale / data.mapScale);


		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
		rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
		// rectNode.scale = 1 / data.mapScale;

		rectNode.anchorX = rectNode.anchorY = 0;

		if (this.data.bgItem.isShowDebugLine || this.data.isDebug) {
			ctx.rect(0, 0, rectNode.width, rectNode.height);
		}
		ctx.stroke();
		ctx.fill();

		return rectNode;
	},

	setOneRect(data) {
		const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;

		const rectNode = new cc.Node();
		rectNode.name = 'rect' + data.index;
		this.hotZoneBg.addChild(rectNode);


		const ctx = rectNode.addComponent(cc.Graphics);
		// 红色矩形
		ctx.lineWidth = 4;
		ctx.strokeColor = cc.Color.BLACK;
		ctx.fillColor = cc.Color.WHITE.setA(100);

		const scale = rate / this.hotZoneBg.scaleY;
		// console.log('scale: ', scale);
		// console.log('scale2: ', scale / data.mapScale);


		rectNode.width = data.rect.width * scale;
		rectNode.height = data.rect.height * scale;
		rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
		rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
		// rectNode.scale = 1 / data.mapScale;

		rectNode.anchorX = rectNode.anchorY = 0;

		if (this.data.bgItem.isShowDebugLine || this.data.isDebug || true) {
			ctx.rect(0, 0, rectNode.width, rectNode.height);
		}
		ctx.stroke();
		ctx.fill();

		this.linkRectGroup.push(rectNode);

		// console.log('```data: ', data)

		// this.dragEndRectArr.push(rectNode);

		// if (data.audio_url) {
		// 	cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
		// 		rectNode.audioClip = audioClip;
		// 	});
		// }



	},

	addPicAudio(picNode) {
		const data = picNode.data;
		
		cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
			picNode.audioClip = audioClip;
		});

		picNode.addComponent(cc.Button);
		picNode.on('click', () => {
				if (picNode.audioClip) {
					cc.audioEngine.stopAllEffects();
					cc.audioEngine.playEffect(picNode.audioClip, false, 0.8);
				}
		});
	},


	initListener() {

		const canvas = cc.find('Canvas');
		
		let downFlag = false;

		const touchMove = (e) => {
			this.canvasTouchMove(e);
			if (canvas.hasEventListener(cc.Node.EventType.MOUSE_MOVE)) {
				canvas.off(cc.Node.EventType.MOUSE_MOVE, mouseMove)
			}
		}

		const mouseMove = (e) => {
			if (!downFlag) {
				return;
			}
			this.canvasTouchMove(e);
			if (canvas.hasEventListener(cc.Node.EventType.TOUCH_MOVE)) {
				canvas.off(cc.Node.EventType.TOUCH_MOVE, touchMove)
				this.removeHtmlCanvasListener('touchmove');
			}
		}

		const touchEnd = (e) => {
		
			downFlag = false;
			this.canvasTouchEnd(e);

			if (canvas.hasEventListener(cc.Node.EventType.MOUSE_UP)) {
				canvas.off(cc.Node.EventType.MOUSE_UP, mouseUp)
			}
			if (canvas.hasEventListener(cc.Node.EventType.MOUSE_LEAVE)) {
				canvas.off(cc.Node.EventType.MOUSE_LEAVE, mouseUp)
			}
			this.removeHtmlTouchEnd();
		}

		const mouseUp = (e) => {
	
			downFlag = false;

			this.canvasTouchEnd(e);

			if (canvas.hasEventListener(cc.Node.EventType.TOUCH_END)) {
				canvas.off(cc.Node.EventType.TOUCH_END, touchEnd)
			}
			if (canvas.hasEventListener(cc.Node.EventType.TOUCH_CANCEL)) {
				canvas.off(cc.Node.EventType.TOUCH_CANCEL, touchEnd)
			}
		}
		

		canvas.on(cc.Node.EventType.TOUCH_MOVE, touchMove)
		canvas.on(cc.Node.EventType.MOUSE_MOVE, mouseMove)

		canvas.on(cc.Node.EventType.TOUCH_END, touchEnd)
		canvas.on(cc.Node.EventType.TOUCH_CANCEL, touchEnd)
		canvas.on(cc.Node.EventType.MOUSE_UP, mouseUp)

	},

	removeHtmlCanvasListener(type) {
		const canvasHtml = document.querySelector('canvas');
		canvasHtml.addEventListener(type, (e) => {})
	},	
	removeHtmlTouchEnd() {
		const canvasHtml = document.querySelector('canvas');
		canvasHtml.removeEventListener('touchend', this.htmlCanvasTouchendFunc, this);
	},

	canvasTouchMove(e) {

		if (!this._curShowItem) {
			return;
		}
		const pos = e.getLocation();
		this._curShowItem.x = pos.x - e.currentTarget.width / 2;
		this._curShowItem.y = pos.y - e.currentTarget.height / 2;

		// console.log('pos: ', pos.x);
	},

	canvasTouchEnd(e) {

		if (!this._curShowItem) {
			return;
		}
		this.checkOnDragEndRect();
		this._curShowItem = null;
	},



	checkOnDragEndRect() {

		console.log('emptyGroupArr: ',  this.emptyGroupArr);
		for (let i = 0; i < this.dragEndRectArr.length; i++) {

			const rect = this.dragEndRectArr[i];

			const worldPos = this._curShowItem.parent.convertToWorldSpaceAR(cc.v2(this._curShowItem.x, this._curShowItem.y));
			const worldRect = rect.getBoundingBoxToWorld();
			if (worldRect.contains(worldPos)) {
			
				console.log('rect in ')
				this.checkIsDragEndTarget(rect);
				// removeItemFromArr(this.emptyGroupArr, letterGroup);
				// this.showLetterSuccess(letterGroup);
				// this.checkGroupEnd();
				return;
			}
			
		}

		this.itemBack();
	},

	itemBack() {

		cc.audioEngine.playEffect(this.wrongClip, false, 0.8);

		cc.tween(this._curShowItem)
			.to(0.5, {x: this._curShowItem.baseX, y: this._curShowItem.baseY}, {easing: "elasticOut"})
			.start();
	},

	checkIsDragEndTarget(rect) {

		const worldPos = this._curShowItem.parent.convertToWorldSpaceAR(cc.v2(this._curShowItem.targetPx, this._curShowItem.targetPy));
		const worldRect = rect.getBoundingBoxToWorld();
		if (worldRect.contains(worldPos)) {
			this._curShowItem.x = this._curShowItem.targetPx;
			this._curShowItem.y = this._curShowItem.targetPy;
			this._curShowItem.isDragEnd = true;


			cc.audioEngine.playEffect(this.rightClip, false, 0.8);

		} else {
			this.itemBack();
		}
	},

	onDestroy() {
		this.isDestroy = true;
		this.endTesting();
	},


});
